/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#include "smpcmn.h"

#ifndef CORBA_UNIX

#define socket isoc_socket
#define bind isoc_bind
#define recvfrom isoc_recvfrom
#define close isoc_close

#endif /* CORBA_UNIX */

int
IOR_recv(char *ior_buff)
{
	int			s;
	int			namelen;
	int			ret;
	long			ior_size;
	struct sockaddr_in	rcv;
	struct sockaddr_in	snd;

	s = socket(PF_INET, SOCK_DGRAM, 0);
	if (s < 0) {
		return 1;
	}

	rcv.sin_family = PF_INET;
	rcv.sin_port = htons(IOR_RECV_PORT);
	rcv.sin_addr.s_addr = htonl(0);
	bzero(rcv.sin_zero, 8);
	ret = bind(s, (struct sockaddr *)&rcv, sizeof(rcv));
	if (ret < 0) {
		return 1;
	}

	namelen = sizeof(snd);
	ret = recvfrom(s, (char *)&ior_size, sizeof(long), 0,
			(struct sockaddr *)&snd, &namelen);
	if (ret < 0) {
		return 1;
	}

	ret = recvfrom(s, ior_buff, ior_size, 0,
			(struct sockaddr *)&snd, &namelen);
	if (ret < 0) {
		return 1;
	}

	close(s);
	return 0;
}

