/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#include "smpcmn.h"

#ifndef CORBA_UNIX

#define socket isoc_socket
#define bind isoc_bind
#define sendto isoc_sendto
#define close isoc_close

static unsigned long
get_ipaddr(unsigned long *server_addr)
{
	HOSTENT			target;
	struct in_addr		*target_addr;
	B			buf[HBUFLEN];
	ERR			ret;

	ret = isoc_gethostbyname(REMOTE_HOST_NAME, &target, buf);
	if (ret < 0) {
		return 1;
	}

	target_addr = (struct in_addr *)*target.h_addr_list;
	*server_addr = ntohl((unsigned long)target_addr->s_addr);
	return 0;
}

#else /* CORBA_UNIX */

static unsigned long
get_ipaddr(void)
{
	struct hostent		*target;
	struct sockaddr_in	sin;

	target = gethostbyname(REMOTE_HOST_NAME);
	if (target == 0) {
		return 1;
	}

	memcpy(&sin.sin_addr.s_addr, target->h_addr, target->h_length);
	*server_addr = ntohl((unsigned long)sin.sin_addr.s_addr);
	return 0;
}

#endif /* CORBA_UNIX */

int
IOR_send(char *ior)
{
	int			s;
	int			ret;
	long			ior_size;
	struct sockaddr_in	rcv;
	struct sockaddr_in	snd;
	unsigned long		server_addr;

	ior_size = strlen(ior) + 1;

	s = socket(PF_INET, SOCK_DGRAM, 0);
	if (s < 0) {
		return 1;
	}

	snd.sin_family = PF_INET;
	snd.sin_port = htons(IOR_SEND_PORT);
	snd.sin_addr.s_addr = htonl(0);
	bzero(snd.sin_zero, 8);
	ret = bind(s, (struct sockaddr *)&snd, sizeof(rcv));
	if (s < 0) {
		return 1;
	}

	ret = get_ipaddr(&server_addr);

	rcv.sin_family = PF_INET;
	rcv.sin_port = htons(IOR_RECV_PORT);
	rcv.sin_addr.s_addr = htonl((unsigned long)server_addr);
	bzero(rcv.sin_zero, 8);

  	ret = sendto(s, (char *)&ior_size, sizeof(long), 0,
			(struct sockaddr *)&rcv, sizeof(rcv));
	if (s < 0) {
		return 1;
	}

	ret = sendto(s, ior, ior_size, 0,
			(struct sockaddr *)&rcv, sizeof(rcv));
	if (s < 0) {
		return 1;
	}

	close(s);
	return 0;
}
