/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#include "test.h"
#include "config.h"

static CORBA_UsrDefine corba_def = {
	CORBA_TARGET_NAME,
	CORBA_SERVER_NUMBER,			
	CORBA_MAX_MEMORY,
	CORBA_NULL,
	0,
	0,
	0,
	0
};

static ASRV_UsrDefine asrv_def = {
	ASRV_SERVER_ID,		
	ASRV_SERVER_PRI,		
	ASRV_OBJECT_PRI,		
	ASRV_SERVER_PORT,
	ASRV_OBJECT_NUMBER,		
	ASRV_DYNAMIC_NUMBER,		
	0,
	0,
	0,
	0
};

static ORB_UsrDefine orb_def;

static POA_UsrDefine poa_def = {
	POA_MAX_POA_NUMBER,		
	POA_MAX_SERVANT_NUMBER,		
	0,
	0,
	0,
	0
};

static MRSHL_UsrDefine mrshl_def;
static GIOP_UsrDefine giop_def;

static CON_UsrDefine con_def = {
	CON_SERVER_NUMBER,		
	CON_CLIENT_NUMBER,		
	CON_SERVER_TIMEOUT,
	0,
	0,
	0,
	0
};

static SYS_UsrDefine sys_def;

CORBA_int
ecorba_init(void)
{
	CORBA_int	ret;
	SG_CORBA	sg;

	sg.sg_corba = &corba_def;
	sg.sg_asrv = &asrv_def;
	sg.sg_orb = &orb_def;
	sg.sg_poa = &poa_def;
	sg.sg_mrshl = &mrshl_def;
	sg.sg_giop = &giop_def;
	sg.sg_con = &con_def;
	sg.sg_sys = &sys_def;

	ret = ECORBA_init(&sg);
	if (ret != CORBA_SGOK) {
		printf("ERR:ECORBA_init !\n");
		return 1;
	}
	return 0;
}
