/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#include "smpcmn.h"
#include "test.h"
#include "config.h"

CORBA_int	TP_ExcFlg;

CORBA_long
func_impl(PortableServer_Servant servant, const CORBA_long test,
	  CORBA_Environment *ev)
{
	printf("func_impl arg %d ret %d\n",
	       (CORBA_int)test, (CORBA_int)test + 1);
	return test + 1;
}

PortableServer_ServantBase__epv base_epv = {
  NULL,
  NULL,
  NULL
};


void
srv_tsk(void)
{
	int				argc;
	char				*argv;
	CORBA_char			ServerName[100];
	CORBA_Environment		ev;
	CORBA_Object			obj;
	CORBA_ORB			orb;
	CORBA_sequence_Policy		policy;
	PortableServer_ObjectId		*oid;
	PortableServer_POA		root_poa;
	PortableServer_POA		child_poa;
	PortableServer_POAManager	poa_mgr = NULL;
	POA_Test__epv			test_epv = {0, func_impl };
	POA_Test__vepv			test_vepv = {0, &base_epv, &test_epv };
	POA_Test			test = {0, &test_vepv };

	printf("\n===== Server Tsk Start =====\n");

	CORBA_exception_init(&ev);

	strcpy(ServerName, "ServerName=");
	strcat(ServerName, SERVER_NAME);

	argc = 1;
	argv = ServerName;
	orb = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	if (ev._major != CORBA_NO_EXCEPTION) {
		printf("Failed to get orb\n");
		CORBA_exception_free(&ev);
		exd_tsk();
	}

	/*
         * RootPOA롣
         */
	obj = CORBA_ORB_resolve_initial_references(orb, "RootPOA", &ev);
	root_poa = (PortableServer_POA)obj;
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to get poa\n");
		CORBA_Object_release((CORBA_Object)orb, &ev);
		CORBA_exception_free(&ev);
		exd_tsk();
	}

	/*
         * RootPOAȴϢŤ줿POAManager롣
         */
	poa_mgr = PortableServer_POA__get_the_POAManager(root_poa, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to get poa_mgr\n");
		PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
		CORBA_Object_release((CORBA_Object)orb, &ev);
		CORBA_exception_free(&ev);
		exd_tsk();
	}

	POA_Test__init(&test, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to POA_Test__init\n");
		PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
		CORBA_Object_release((CORBA_Object)orb, &ev);
		CORBA_exception_free(&ev);
		exd_tsk();
	}

	/*
	 * ֥ID
	 */	
	oid = PortableServer_string_to_ObjectId(OBJECT_ID, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to ObjectId\n");
		PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
		CORBA_Object_release((CORBA_Object)orb, &ev);
		CORBA_exception_free(&ev);
		exd_tsk();
	}

	/*
	 * POALifespan PolicyPERSISTENTˤ롣
	 */
	policy._buffer = CORBA_sequence_Policy_allocbuf(1);
	policy._length = 1;
	policy._release = CORBA_FALSE;
	policy._buffer[0] = PortableServer_POA_create_lifespan_policy(
					root_poa, PortableServer_PERSISTENT,
					&ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to create policy\n");
		CORBA_free(oid);
		PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
		CORBA_Object_release((CORBA_Object)orb, &ev);
		CORBA_exception_free(&ev);
		CORBA_free(policy._buffer);
		exd_tsk();
	}

	/*
	 * POA롣
	 */
	child_poa = PortableServer_POA_create_POA(root_poa, CHILD_POA, 
						  poa_mgr, &policy, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to create child POA\n");
		CORBA_free(oid);
		PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
		CORBA_Object_release((CORBA_Object)orb, &ev);
		CORBA_exception_free(&ev);
		CORBA_free(policy._buffer);
		exd_tsk();
	}
	CORBA_free(policy._buffer);

	/*
         * POA˥ХȤϿ롣
         */
	PortableServer_POA_activate_object_with_id(child_poa, oid, &test, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to activate object\n");
		CORBA_free(oid);
		PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
		CORBA_Object_release((CORBA_Object)orb, &ev);
		CORBA_exception_free(&ev);
		exd_tsk();
	}
	CORBA_free(oid);

	/*
         * POAManager˳Υå롣
         * POAManagerϿƤ뤹٤ƤPOA롣
         */
	PortableServer_POAManager_activate(poa_mgr, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to activate poa manager\n");
		PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
		CORBA_Object_release((CORBA_Object)orb, &ev);
		CORBA_exception_free(&ev);
		exd_tsk();
	}

	/*
	 * ORBå롼פ롣
         */
	CORBA_ORB_run(orb, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to run orb\n");
		PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
		CORBA_Object_release((CORBA_Object)orb, &ev);
		CORBA_exception_free(&ev);
		exd_tsk();
	}

	/*
	 * POA
	 * (Don't reach)
         */
	PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to destroy poa\n");
		CORBA_Object_release((CORBA_Object)orb, &ev);
		CORBA_exception_free(&ev);
		exd_tsk();
	}

	CORBA_Object_release((CORBA_Object)orb, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to destroy poa\n");
		CORBA_Object_release((CORBA_Object)orb, &ev);
		CORBA_exception_free(&ev);
		exd_tsk();
	}

	printf("\n===== Server Tsk Shutdown =====\n");
	exd_tsk();
}


CORBA_int	Doid;

/*
 *	ưŪϿ/Ԥ
 */
void
usr_tsk(void)
{
	char			cmdstr[10];

	TP_START();

	 while (1) {
		CMD_recv(cmdstr);
		if (strcmp(cmdstr, "entry") == 0) {
			/*
			 *	Ͽ
			 */
			T_CTSK	tsk;

			tsk.exinf = (VP)CH4toW('S','T','S','K');
			tsk.task = srv_tsk;
			tsk.itskpri = DEFAULT_PRI;
			tsk.stksz = 0x8000;
			tsk.tskatr = TA_HLNG | TA_RNG0;
			printf("server task entry %s\n", SERVER_NAME);
			Doid = ASRV_entry_dobj(&tsk, SERVER_NAME, 1);
			if (Doid > 0) {
				printf("object entry OK(id:%d)\n", Doid);
				CMD_send("OK");
			} else {
				printf("object entry NG\n");
				CMD_send("NG");
			}
		} else if (strcmp(cmdstr, "cancel") == 0) {
			/*
			 *	
			 */
			printf("object cancel OK(id:%d)\n", Doid);
			ASRV_cancel_dobj_id(Doid);
			CMD_send("OK");
		} else if (strcmp(cmdstr, "end") == 0) {
			printf("task end\n");
			CMD_send("OK");
			break;
		} else {
			printf("BAD PARAMETER\n");
			CMD_send("NG");
		}
	}

	TP_EXIT();
}

ERR
main(Bool Startup, TC *arg)
{
	WERR		tskid0;

	if (ecorba_init()) {
		return 1;
	}

	MAIN_START();

	tskid0 = CreateTask(usr_tsk, DEFAULT_PRI);
	printf("tskid0: %d\n", tskid0);

	MAIN_EXIT();
	return 0;
}

