/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#include "test.h"
#include "smpcmn.h"
#include "config.h"

CORBA_char	IORstr[1024];
CORBA_int	TP_ExcFlg;

void
tsk(void)
{
	int			argc;
	char			*argv;
	CORBA_Environment	ev;
	CORBA_ORB		orb;
	CORBA_long		l;
	Test			test;

	TP_START();
	CORBA_exception_init(&ev);

	argc = 0;
	orb = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	if (ev._major != CORBA_NO_EXCEPTION) {
		printf("Failed to get orb\n");
		CORBA_exception_free(&ev);
		TP_EXIT();
	}

	test = CORBA_ORB_string_to_object(orb, IORstr, &ev);
	if (ev._major != CORBA_NO_EXCEPTION) {
		printf("Failed to get string_to_object\n");
		CORBA_Object_release((CORBA_Object)orb, &ev);
		CORBA_exception_free(&ev);
		TP_EXIT();
	}
	
	l = 5;
	printf("prev l = %d\n", (CORBA_int)l);
	l = test_func(test, l, &ev);
	if (ev._major != CORBA_NO_EXCEPTION) {
		printf("exception from func!\n");
		CORBA_Object_release(test, &ev);
		CORBA_Object_release((CORBA_Object)orb, &ev);
		TP_EXIT();
	}
	printf("end l = %d\n", (CORBA_int)l);

	CORBA_Object_release(test, &ev);
	CORBA_Object_release((CORBA_Object)orb, &ev);

	TP_EXIT();
}

ERR
main(Bool Startup, TC *arg)
{
	WERR		tskid0;
	
	if (ecorba_init()) {
		return 1;
	}

	if(IOR_recv(IORstr)) {
		return 1;
	}

	MAIN_START();
	tskid0 = CreateTask(tsk, DEFAULT_PRI);
	printf("tskid0: %d\n", tskid0);

	MAIN_EXIT();
	return 0;
}

