/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#include "test.h"
#include "smpcmn.h"
#include "config.h"

CORBA_int	TP_ExcFlg;

CORBA_long
func_impl(PortableServer_Servant servant, const CORBA_long test,
	  CORBA_Environment *ev)
{
	printf("func_impl arg %d ret %d\n",
	       (CORBA_int)test, (CORBA_int)test + 1);
	return test + 1;
}

PortableServer_ServantBase__epv base_epv = {
  NULL,
  NULL,
  NULL
};


void
tsk(void)
{
	int				argc;
	char				*argv;
	CORBA_ORB			orb;
	CORBA_Environment		ev;
	CORBA_Object			obj;
	PortableServer_ObjectId		*oid;
	PortableServer_POA		root_poa;
	PortableServer_POAManager	poa_mgr = NULL;
	POA_Test__epv			test_epv = {0, func_impl};
	POA_Test__vepv			test_vepv = {0, &base_epv, &test_epv};
	POA_Test 			test_servant = {0, &test_vepv };

	CORBA_char			*str;

	CORBA_exception_init(&ev);

	argc = 0;
	orb = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	if (ev._major != CORBA_NO_EXCEPTION) {
		printf("Failed to get orb\n");
		CORBA_exception_free(&ev);
		TP_EXIT();
	}

	/*
         * RootPOA롣
         */
	obj = CORBA_ORB_resolve_initial_references(orb, "RootPOA", &ev);
	root_poa = (PortableServer_POA)obj;
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to get poa\n");
		CORBA_Object_release((CORBA_Object)orb, &ev);
		CORBA_exception_free(&ev);
		TP_EXIT();
	}

	/*
         * RootPOAȴϢŤ줿POAManager롣
         */
	poa_mgr = PortableServer_POA__get_the_POAManager(root_poa, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to get poa_mgr\n");
		PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
		CORBA_Object_release((CORBA_Object)orb, &ev);
		CORBA_exception_free(&ev);
		TP_EXIT();
	}

	POA_Test__init(&test_servant, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to POA_Test__init\n");
		PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
		CORBA_Object_release((CORBA_Object)orb, &ev);
		CORBA_exception_free(&ev);
		TP_EXIT();
	}
	
	oid = PortableServer_string_to_ObjectId("test", &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to POA_Test__init\n");
		PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
		CORBA_Object_release((CORBA_Object)orb, &ev);
		CORBA_exception_free(&ev);
		TP_EXIT();
	}
	
	/*
         * POA˥ХȤϿ롣
         */
	PortableServer_POA_activate_object_with_id(root_poa, oid, &test_servant, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to activate object\n");
		PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
		CORBA_Object_release((CORBA_Object)orb, &ev);
		CORBA_exception_free(&ev);
		CORBA_free(oid);
		TP_EXIT();
	}
	CORBA_free(oid);

	/*
         * POAManager˳Υå롣
         * POAManagerϿƤ뤹٤ƤPOA롣
         */
	PortableServer_POAManager_activate(poa_mgr, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to activate poa manager\n");
		PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
		CORBA_Object_release((CORBA_Object)orb, &ev);
		CORBA_exception_free(&ev);
		TP_EXIT();
	}

	/*
	 * ХȤ饪֥ȥե󥹤κ
         */
        obj = PortableServer_POA_servant_to_reference(root_poa, &test_servant, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to servant_to_reference\n");
		PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
		CORBA_Object_release((CORBA_Object)orb, &ev);
		CORBA_exception_free(&ev);
		TP_EXIT();
	}
	
	/*
	 * ֥ȥե󥹤ʸѴ
         */
	str = CORBA_ORB_object_to_string(orb, obj, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to object_to_string\n");
		PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
		CORBA_Object_release((CORBA_Object)orb, &ev);
		CORBA_Object_release(obj, &ev);
		CORBA_exception_free(&ev);
		TP_EXIT();
	}
	CORBA_Object_release(obj, &ev);

	/*
	 * ֥ȥե󥹤򥯥饤ȤϤ
         */
	if (IOR_send(str)) {
		printf("Failed to IOR_send\n");
		PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
		CORBA_Object_release((CORBA_Object)orb, &ev);
		CORBA_free(str);
		TP_EXIT();
	}
	CORBA_free(str);

	/*
	 * ORBå롼פ롣
         */
	CORBA_ORB_run(orb, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to run orb\n");
		PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
		CORBA_Object_release((CORBA_Object)orb, &ev);
		CORBA_exception_free(&ev);
		TP_EXIT();
	}

	/*
	 * POA
	 * (Don't reach)
         */
	PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to destroy poa\n");
		CORBA_Object_release((CORBA_Object)orb, &ev);
		CORBA_exception_free(&ev);
		TP_EXIT();
	}

	CORBA_Object_release((CORBA_Object)orb, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to destroy poa\n");
		CORBA_exception_free(&ev);
		TP_EXIT();
	}

	TP_EXIT();
}

ERR
main(Bool Startup, TC *arg)
{
	WERR		tskid0;

	if (ecorba_init()) {
		return 1;
	}

	tskid0 = CreateTask(tsk, DEFAULT_PRI);
	printf("tskid0: %d\n", tskid0);
	return 0;
}

