/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#include "config.h"
#include "tpchk.h"

#ifndef CORBA_UNIX

#define socket isoc_socket
#define bind isoc_bind
#define sendto isoc_sendto
#define close isoc_close

unsigned long
TP_get_ipaddr(CORBA_char *name)
{
	HOSTENT			target;
	struct in_addr		*target_addr;
	B			buf[HBUFLEN];
	ERR			ret;

/*	TP_Msg("%s\n", name);
*/

	ret = isoc_gethostbyname(name, &target, buf);
	TP_CHECK((ret >= 0), (" "));
	target_addr = (struct in_addr *)*target.h_addr_list;

	return ntohl((CORBA_unsigned_long)target_addr->s_addr);
}

#else /* CORBA_UNIX */

unsigned long
TP_get_ipaddr(CORBA_char *name)
{
	struct hostent		*target;
	struct sockaddr_in	sin;

	TP_Msg("%s\n", name);

	target = gethostbyname(name);
	TP_CHECK((target), (" "));

	memcpy(&sin.sin_addr.s_addr, target->h_addr, target->h_length);

	return ntohl((unsigned long)sin.sin_addr.s_addr);
}

#endif /* CORBA_UNIX */
