/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#include "config.h"
#include "tpchk.h"

#define	IOR_BUFSZ		(1000)

#ifndef CORBA_UNIX

#define socket isoc_socket
#define bind isoc_bind
#define recvfrom isoc_recvfrom
#define close isoc_close

#endif /* CORBA_UNIX */

CORBA_boolean
TP_IOR_recv(unsigned short port, char *ior_buff)
{
	int			s;
	int			namelen;
	int			ret;
	long			ior_size;
	struct sockaddr_in	rcv;
	struct sockaddr_in	snd;

	s = socket(PF_INET, SOCK_DGRAM, 0);
	TP_CHECK((s >= 0), (" "));

	rcv.sin_family = PF_INET;
	rcv.sin_port = htons(port);
	rcv.sin_addr.s_addr = htonl(0);
	bzero(rcv.sin_zero, 8);
	ret = bind(s, (struct sockaddr *)&rcv, sizeof(rcv));
	TP_CHECK((ret >= 0), (" "));

	namelen = sizeof(snd);
	ret = recvfrom(s, (char *)&ior_size, sizeof(long), 0,
			(struct sockaddr *)&snd, &namelen);
	TP_CHECK((ret >= 0), (" "));

	ior_size = ntohl(ior_size);

	TP_Msg("ior_size %d\n", ior_size);
	ret = recvfrom(s, ior_buff, ior_size, 0,
			(struct sockaddr *)&snd, &namelen);
	TP_CHECK((ret >= 0), (" "));

	close(s);
	return CORBA_TRUE;

}

