/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#include "config.h"
#include "tpchk.h"

#ifndef CORBA_UNIX

#define socket isoc_socket
#define bind isoc_bind
#define sendto isoc_sendto
#define close isoc_close

#endif /* CORBA_UNIX */

void
TP_IOR_send(unsigned short port, char *ior)
{
	int			s;
	int			ret;
	long			ior_size;
	long			ior_size_net;
	struct sockaddr_in	rcv;
	struct sockaddr_in	snd;
	unsigned long		server_addr;

	ior_size = strlen(ior) + 1;
	TP_Msg("ior_size %d\n", ior_size);

	s = socket(PF_INET, SOCK_DGRAM, 0);
	TP_CHECK((s >= 0), (" "));

	snd.sin_family = PF_INET;
	snd.sin_port = htons(0);
	snd.sin_addr.s_addr = htonl(0);
	bzero(snd.sin_zero, 8);
	ret = bind(s, (struct sockaddr *)&snd, sizeof(rcv));
	TP_CHECK((ret >= 0), ("%d", ret));

	server_addr = TP_get_ipaddr(IOR_RECV_HOST_NAME);

	rcv.sin_family = PF_INET;
	rcv.sin_port = htons(port);
	rcv.sin_addr.s_addr = htonl((unsigned long)server_addr);
	bzero(rcv.sin_zero, 8);

	ior_size_net = htonl(ior_size);

  	ret = sendto(s, (char *)&ior_size_net, sizeof(long), 0,
			(struct sockaddr *)&rcv, sizeof(rcv));
	TP_CHECK((ret >= 0), ("%d", ret));

	ret = sendto(s, ior, ior_size, 0,
			(struct sockaddr *)&rcv, sizeof(rcv));
	TP_CHECK((ret >= 0), ("%d", ret));

	close(s);
}
