/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#ifdef	CORBA_UNIX

typedef int PRI;
typedef int ID;
typedef void (*FP)();
typedef struct {
	int	dmy;
} T_CTSK;

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <netdb.h>

#include "corba.h"

#define TP_START()	sleep(1);
#define TP_END()	/* */
#define MAIN_START()	/* */
#define MAIN_END()	/* */

#define TP_delete_ASRVtsk(a) /**/
#define TP_Msg	printf

#else	/* CORBA_UNIX */

#include <basic.h>
#include <bstring.h>
#include <tstring.h>
#include <inner.h>
#include <driver/driver.h>
#include <kernel/util.h>
#include <errcode.h>
#include <bstdio.h>
#include <jcg/i_socket.h>

#include "corba.h"

void ASRV_fini(void);
void MRSHL_fini(void);
void CON_fini(void);
void GIOP_fini(void);
void ORB_fini(void);
CORBA_boolean MRSHL_get_native_order(void);
void SYS_init_debug(CORBA_unsigned_long);

#define htons TPswaps
#define ntohs TPswaps
#define htonl TPswapl
#define ntohl TPswapl
CORBA_unsigned_short TPswaps(CORBA_unsigned_short);
CORBA_unsigned_long TPswapl(CORBA_unsigned_long);

#define TP_START()	\
{			\
	TP_ExcFlg++;	\
}

#define TP_END()			\
{					\
	ter_tsk(ASRV_SERVER_ID);	\
	del_tsk(ASRV_SERVER_ID);	\
	TP_ExcFlg--;			\
	exd_tsk();			\
}

#define	TP_LINE()	\
{			\
	TP_Msg("-----O-----O-----O-----O-----O-----O-----O-----O-----\n"); \
}

#define MAIN_START()	\
{			\
	TP_ExcFlg = 0;	\
}

#define MAIN_END()		\
{				\
	while (TP_ExcFlg) {	\
		dly_tsk(100);	\
	}			\
}

#endif	/* CORBA_UNIX */

#define TP_CHECK(a, b)	\
if (!(a)) {		\
	TP_Msg("!!!ERROR!!!: file:%s line:%d ", __FILE__, __LINE__);	\
	TP_Msg b;	\
	TP_Msg("\n");	\
	TP_END();	\
}

#define TP_INFO(a)	\
{			\
	TP_Msg a;	\
}

#define TP_CHECK_CorbaMem(a, b, c, d)		\
{						\
	CORBA_boolean	ret;			\
						\
	ret = tp_check_corbamem(a, b, c, d);	\
	if (ret == CORBA_FALSE) {		\
		TP_Msg("!!!ERROR!!!: file:%s line:%d\n", __FILE__, __LINE__);	\
		TP_Msg("%d %d %d %d\n", a, b, c, d);	\
		TP_END();			\
	}					\
}

extern CORBA_int	TP_ExcFlg;

#define DEFAULT_PRI	(130)
#define TASK_STKSZ	(0x4000)

CORBA_int TP_wait(CORBA_int);
void TP_corba_init(void);
void TP_corba_init2(CORBA_unsigned_short);
void TP_corba_fini(void);
CORBA_boolean tp_check_sysmem(CORBA_int, CORBA_int, CORBA_int, CORBA_int);
CORBA_boolean tp_check_corbamem(CORBA_int, CORBA_int, CORBA_int, CORBA_int);

void TP_IOR_send(unsigned short, char *);
CORBA_boolean TP_IOR_recv(unsigned short, char *);
unsigned long TP_get_ipaddr(CORBA_char *);
void sync_send(char *, unsigned short);
void sync_recv(unsigned short);
CORBA_int tsk_stop_check(ID, char *, unsigned short);
void tsk_stop_wait(unsigned short);

#ifndef	CORBA_UNIX
void TP_Msg(CORBA_char *, ...);
WERR TP_CreateTask(FP, PRI);
void TP_delete_ASRVtsk(ID);

#endif	/* CORBA_UNIX */

