/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#include "s2102.h"
#include "_loging.h"

PortableServer_ServantPrivateInfo test_class = {
	"IDL:test:1.0",				/*	type_id	*/
	_skl_dispatch_test,			/*	dispatchؿ	*/
} ;

void POA_Test__init(POA_Test *servant, CORBA_Environment *env)
{
	POA_Test	*test;

	test = (POA_Test *)servant;
	((PortableServer_ServantBase *)test)->vepv->_private = (void *)&test_class;
}

void POA_Test__fini(POA_Test *servant, CORBA_Environment *env)
{
}

void
_skl_dispatch_test(PortableServer_Servant servant, GIOP_SrvInf *msg)
{
	CORBA_char		*bufp;
	CORBA_boolean		order;
	CORBA_Environment	env;

	bufp = GIOP_srv_bcurp(msg);
	order = GIOP_srv_bordr(msg);

	env._major = CORBA_NO_EXCEPTION;
	env._id = 0;
	env._params = 0;

	printf("operation %s\n", GIOP_srv_opnam(msg));

	if (!strcmp(GIOP_srv_opnam(msg), "func")) {
		CORBA_char		ret;
		CORBA_char		dat;
		CORBA_unsigned_long	size;

		dat = MRSHL_get_char(&bufp, order);

		ret = ((POA_Test *)servant)->vepv->Test_epv->func(servant, dat, &env);
		if (env._major == CORBA_SYSTEM_EXCEPTION) {
			GIOP_send_repexc(msg, env._id, CORBA_COMPLETED_NO);
			printf("_skl_dispatch_test_func err 1\n");
			return;
		} else if (env._major == CORBA_USER_EXCEPTION) {
			GIOP_send_repexc(msg, CORBA_Ex_UNKNOWN,
					 CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_func err 2\n");
			return;
		}

		size = 0;
		size = MRSHL_index_char(size);	/* return data size */
		bufp = GIOP_create_repbuf(msg, size);
		if (!bufp) {
			GIOP_send_repexc(msg, CORBA_Ex_NO_MEMORY,
					 CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_func err 3\n");
			return;
		}
		MRSHL_put_long(&bufp, CORBA_NO_EXCEPTION);
		MRSHL_put_char(&bufp, ret);

		size = (CORBA_unsigned_long)(bufp - GIOP_srv_btopp(msg));
		printf("_skl_dispatch_test_func rep send\n");
		GIOP_send_rep(msg, size);

		IPA_LOG_Srv_init(0);

		printf("_skl_dispatch_test_func success\n");
		return ;
	} else if (!strcmp(GIOP_srv_opnam(msg), "func_shutdown")){
		CORBA_long		ret;
		CORBA_long		dat;
		CORBA_unsigned_long	size;

		dat = MRSHL_get_long(&bufp, order);

		ret = ((POA_Test *)servant)->vepv->Test_epv->func_shutdown(servant, dat, &env);
		if (env._major == CORBA_SYSTEM_EXCEPTION) {
			GIOP_send_repexc(msg, env._id, CORBA_COMPLETED_NO);
			printf("_skl_dispatch_test_shutdown err 1\n");
			return;
		} else if (env._major == CORBA_USER_EXCEPTION) {
			GIOP_send_repexc(msg, CORBA_Ex_UNKNOWN,
					 CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_shutdown err 2\n");
			return;
		}

		size = 0;
		size = MRSHL_index_long(size);	/* return data size */
		bufp = GIOP_create_repbuf(msg, size);
		if (!bufp) {
			GIOP_send_repexc(msg, CORBA_Ex_NO_MEMORY,
					 CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_shutdown err 3\n");
			return;
		}
		MRSHL_put_long(&bufp, CORBA_NO_EXCEPTION);
		MRSHL_put_long(&bufp, ret);

		size = (CORBA_unsigned_long)(bufp - GIOP_srv_btopp(msg));
		printf("_skl_dispatch_test_shutdown rep send\n");
		GIOP_send_rep(msg, size);
		printf("_skl_dispatch_test_shutdown success\n");
		return ;
	} else {
		GIOP_send_repexc(msg, CORBA_Ex_BAD_OPERATION,
				 CORBA_COMPLETED_NO);
		return;
	}
}
