/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#include "s2102.h"
#include "config.h"
#include "_sysdbg.h"
#include "_syslibc.h"
#include "_loging.h"

#define PORT 6666

#define	TEST01	0
#define	TEST02	1
#define	TEST03	2

static CORBA_char	IORstr1[1024];
static CORBA_char	IORstr2[1024];
static CORBA_char	IORstr3[1024];

CORBA_UsrDefine corba_def = {
	CORBA_TARGET_NAME,
	CORBA_SERVER_NUMBER,
	CORBA_MAX_MEMORY,
	CORBA_NULL,
	0,
	0,
	0,
	0
};

ASRV_UsrDefine asrv_def = {
	ASRV_SERVER_ID,
	ASRV_SERVER_PRI,
	ASRV_SERVER_PORT,
	ASRV_OBJECT_PRI,
	ASRV_OBJECT_NUMBER,
	ASRV_DYNAMIC_NUMBER,
	0,
	0,
	0,
	0
};

ORB_UsrDefine orb_def = {
	0,
	0,
	0,
	0
};

POA_UsrDefine poa_def = {
	POA_MAX_POA_NUMBER,
	POA_MAX_SERVANT_NUMBER,
	0,
	0,
	0,
	0
};

MRSHL_UsrDefine mrshl_def = {
	0,
	0,
	0,
	0
};

GIOP_UsrDefine giop_def = {
	0,
	0,
	0,
	0
};

CON_UsrDefine con_def = {
	CON_SERVER_NUMBER,
	CON_CLIENT_NUMBER,
	CON_SERVER_TIMEOUT,
	0,
	0,
	0,
	0
};

SYS_UsrDefine sys_def = {
	0,
	0,
	0,
	0
};

SG_CORBA sg_def = {
	&corba_def,
	&asrv_def,
	&orb_def,
	&poa_def,
	&mrshl_def,
	&giop_def,
	&con_def,
	&sys_def,
	0,
	0,
	0,
	0
};

static void tsk(void);
static void tsk01(void);
static void tsk02(void);
static void tsk03(void);
static void tsk04(void);
static void tsk05(void);
static void tsk06(void);

#define tsk_dly(flg)		\
{				\
	while (flg == 0) {	\
		dly_tsk(10);	\
	}			\
}

static CORBA_int	FlgTsk01;
static CORBA_int	FlgTsk02;
static CORBA_int	FlgTsk03;
static CORBA_int	FlgTsk04;
static CORBA_int	FlgTsk05;
static CORBA_int	FlgTsk06;

void
tsk(void)
{
	ID	id1;
	ID	id2;
	ID	id3;
	ID	id4;
	ID	id5;
	ID	id6;

	FlgTsk01 = 0;
	FlgTsk02 = 0;
	FlgTsk03 = 0;
	FlgTsk04 = 0;
	FlgTsk05 = 0;
	FlgTsk06 = 0;

	TP_START();

	id1 = TP_CreateTask(tsk01, DEFAULT_PRI);
	tsk_dly(FlgTsk01);

	id2 = TP_CreateTask(tsk02, DEFAULT_PRI);
	tsk_dly(FlgTsk02);

	id3 = TP_CreateTask(tsk03, DEFAULT_PRI);
	tsk_dly(FlgTsk03);

	id4 = TP_CreateTask(tsk04, DEFAULT_PRI);
	tsk_dly(FlgTsk04);

	id5 = TP_CreateTask(tsk05, DEFAULT_PRI);
	tsk_dly(FlgTsk05);

	id6 = TP_CreateTask(tsk06, DEFAULT_PRI);
	tsk_dly(FlgTsk06);

	FlgTsk01 = 0;
	FlgTsk02 = 0;
	FlgTsk03 = 0;
	FlgTsk04 = 0;
	FlgTsk05 = 0;

	wup_tsk(id5);
	tsk_dly(FlgTsk05);

	wup_tsk(id4);
	tsk_dly(FlgTsk04);

	wup_tsk(id3);
	tsk_dly(FlgTsk03);

	wup_tsk(id2);
	tsk_dly(FlgTsk02);

	wup_tsk(id1);
	tsk_dly(FlgTsk01);

	TP_END();
}

void
tsk01(void)
{
	int			argc;
	char			*argv;
	CORBA_ORB		orb;
	CORBA_Environment	ev;
	Test			test1;
	Test			test2;
	Test			test3;

	printf("### START : Task 01 ###\n");

	CORBA_exception_init(&ev);

	argc = 0;
	orb = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	test1 = CORBA_ORB_string_to_object(orb, IORstr1, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	test2 = CORBA_ORB_string_to_object(orb, IORstr2, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	test3 = CORBA_ORB_string_to_object(orb, IORstr3, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	
	CORBA_exception_init(&ev);

	TP_LINE();
	printf("s210201 : START\n");
	{
		CORBA_char	l = 5;

		IPA_LOG_init(IPA_LOG_NET);

		printf("before l = %d\n", (CORBA_int)l);
		l = test_func(test1, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		printf("after l = %d\n", (CORBA_int)l);

		printf("before l = %d\n", (CORBA_int)l);
		l = test_func(test1, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		printf("after l = %d\n", (CORBA_int)l);

		IPA_LOG_init(0);

		printf("1 on 1 OK\n");
	}
	printf("s210201 : END\n\n");

	TP_LINE();
	printf("s210202 : START\n");
	{
		CORBA_char	l = 5;

		IPA_LOG_init(IPA_LOG_NET);

		printf("before l = %d\n", (CORBA_int)l);
		l = test_func(test2, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		printf("after l = %d\n", (CORBA_int)l);

		printf("before l = %d\n", (CORBA_int)l);
		l = test_func(test2, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		printf("after l = %d\n", (CORBA_int)l);

		IPA_LOG_init(0);

		printf("1 on 2 OK\n");
	}
	printf("s210202 : END\n\n");

	TP_LINE();
	printf("s210203 : START\n");
	{
		CORBA_char	l = 5;

		IPA_LOG_init(IPA_LOG_NET);

		printf("before l = %d\n", (CORBA_int)l);
		l = test_func(test3, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		printf("after l = %d\n", (CORBA_int)l);

		printf("before l = %d\n", (CORBA_int)l);
		l = test_func(test3, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		printf("after l = %d\n", (CORBA_int)l);

		IPA_LOG_init(0);

		printf("1 on 3 OK\n");
	}
	printf("s210203 : END\n\n");

	FlgTsk01 = 1;

#if	CORBA_UNIX
	tsk02();
#else	/* CORBA_UNIX */
	slp_tsk();
#endif	/* CORBA_UNIX */

	test_func_shutdown(test2, TEST02, &ev);
	test_func_shutdown(test1, TEST01, &ev);

	TP_LINE();
	printf("s210207 : START\n");
	{
		CORBA_char	l = 5;
		CORBA_char	*id;

		IPA_LOG_init(0);

		printf("before l = %d\n", (CORBA_int)l);
		l = test_func(test3, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		printf("after l = %d\n", (CORBA_int)l);

		printf("before l = %d\n", (CORBA_int)l);
		l = test_func(test3, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		printf("after l = %d\n", (CORBA_int)l);

		test_func_shutdown(test3, TEST03, &ev);

		l = test_func(test3, l, &ev);
		TP_CHECK((ev._major == CORBA_SYSTEM_EXCEPTION), (" "));

		IPA_LOG_init(0);

		id = CORBA_exception_id(&ev);
                TP_CHECK((id != CORBA_NULL), (" "));
                TP_CHECK((strcmp(id, CORBA_Ex_COMM_FAILURE) == 0),
				 ("%s", id));

                TP_Msg("_id OK: %s\n", id);
		CORBA_exception_free(&ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	}
	printf("s210207 : END\n\n");

	CORBA_Object_release(test3, &ev);
	CORBA_Object_release(test2, &ev);
	CORBA_Object_release(test1, &ev);
	CORBA_Object_release((CORBA_Object)orb, &ev);

	printf("### END : Task 01 ###\n");

	FlgTsk01 = 1;
 	ext_tsk();
}

void
tsk02(void)
{
	int			argc;
	char			*argv;
	CORBA_ORB		orb;
	CORBA_Environment	ev;
	Test			test;

	printf("### START : Task 02 ###\n");

	CORBA_exception_init(&ev);

	argc = 0;
	orb = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	test = CORBA_ORB_string_to_object(orb, IORstr2, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	TP_LINE();
	printf("s210204 : START\n");
	{
		CORBA_char	l = 5;

		IPA_LOG_init(IPA_LOG_NET);

		printf("before l = %d\n", (CORBA_int)l);
		l = test_func(test, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		printf("after l = %d\n", (CORBA_int)l);

		printf("before l = %d\n", (CORBA_int)l);
		l = test_func(test, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		printf("after l = %d\n", (CORBA_int)l);

		IPA_LOG_init(0);

		printf("2 on 1 OK\n");
	}
	printf("s210204 : END\n\n");

	FlgTsk02 = 1;

#if	CORBA_UNIX
	tsk03();
#else	/* CORBA_UNIX */
	slp_tsk();
#endif	/* CORBA_UNIX */

	CORBA_Object_release((CORBA_Object)orb, &ev);

	printf("### END : Task 02 ###\n");

	FlgTsk02 = 1;
	ext_tsk();
}

void
tsk03(void)
{
	int			argc;
	char			*argv;
	CORBA_ORB		orb;
	CORBA_Environment	ev;
	Test			test;

	printf("### START : Task 03 ###\n");

	CORBA_exception_init(&ev);

	argc = 0;
	orb = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	test = CORBA_ORB_string_to_object(orb, IORstr3, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	TP_LINE();
	printf("s210205 : START\n");
	{
		CORBA_char	l = 5;

		IPA_LOG_init(IPA_LOG_NET);

		printf("before l = %d\n", (CORBA_int)l);
		l = test_func(test, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		printf("after l = %d\n", (CORBA_int)l);

		printf("before l = %d\n", (CORBA_int)l);
		l = test_func(test, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		printf("after l = %d\n", (CORBA_int)l);

		IPA_LOG_init(0);

		printf("3 on 1 OK\n");
	}
	printf("s210205 : END\n\n");
	TP_LINE();

	FlgTsk03 = 1;

#if	CORBA_UNIX
	tsk04();
#else	/* CORBA_UNIX */
	slp_tsk();
#endif	/* CORBA_UNIX */

	CORBA_Object_release((CORBA_Object)orb, &ev);

	printf("### END : Task 03 ###\n");

	FlgTsk03 = 1;
	ext_tsk();
}

void
tsk04(void)
{
	int			argc;
	char			*argv;
	CORBA_ORB		orb;
	CORBA_Environment	ev;
	Test			test;

	printf("### START : Task 04 ###\n");

	CORBA_exception_init(&ev);

	argc = 0;
	orb = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	test = CORBA_ORB_string_to_object(orb, IORstr1, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	{
		CORBA_char	l = 5;

		printf("before l = %d\n", (CORBA_int)l);
		l = test_func(test, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		printf("after l = %d\n", (CORBA_int)l);

		printf("before l = %d\n", (CORBA_int)l);
		l = test_func(test, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		printf("after l = %d\n", (CORBA_int)l);
	}

	FlgTsk04 = 1;

#if	CORBA_UNIX
	tsk05();
#else	/* CORBA_UNIX */
	slp_tsk();
#endif	/* CORBA_UNIX */

	CORBA_Object_release((CORBA_Object)orb, &ev);

	printf("### END : Task 04 ###\n");

	FlgTsk04 = 1;
	ext_tsk();
}

void
tsk05(void)
{
	int			argc;
	char			*argv;
	CORBA_ORB		orb;
	CORBA_Environment	ev;
	Test			test;

	printf("### START : Task 05 ###\n");

	CORBA_exception_init(&ev);

	argc = 0;
	orb = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	test = CORBA_ORB_string_to_object(orb, IORstr1, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	{
		CORBA_char	l = 5;

		printf("before l = %d\n", (CORBA_int)l);
		l = test_func(test, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		printf("after l = %d\n", (CORBA_int)l);

		printf("before l = %d\n", (CORBA_int)l);
		l = test_func(test, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		printf("after l = %d\n", (CORBA_int)l);
	}

	FlgTsk05 = 1;

#if	CORBA_UNIX
	tsk06();
#else	/* CORBA_UNIX */
	slp_tsk();
#endif	/* CORBA_UNIX */

	{
		CORBA_char	l = 5;

		printf("before l = %d\n", (CORBA_int)l);
		l = test_func(test, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		printf("after l = %d\n", (CORBA_int)l);

		printf("before l = %d\n", (CORBA_int)l);
		l = test_func(test, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		printf("after l = %d\n", (CORBA_int)l);
	}
	printf("s210206 : END\n\n");
	TP_LINE();

	CORBA_Object_release((CORBA_Object)orb, &ev);

	printf("### END : Task 05 ###\n");

	FlgTsk05 = 1;
	ext_tsk();
}

void
tsk06(void)
{
	int			argc;
	char			*argv;
	CORBA_ORB		orb;
	CORBA_Environment	ev;
	Test			test;

	printf("### START : Task 06 ###\n");

	CORBA_exception_init(&ev);

	argc = 0;
	orb = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	test = CORBA_ORB_string_to_object(orb, IORstr1, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	
	TP_LINE();
	printf("s210206 : START\n");
	{
		CORBA_char	l = 5;

		IPA_LOG_init(IPA_LOG_NET);

		printf("before l = %d\n", (CORBA_int)l);
		l = test_func(test, l, &ev);
		TP_CHECK((strcmp(CORBA_exception_id(&ev), "IDL:CORBA/COMM_FAILURE:1.0") == 0), (" "));

		printf("after l = %d\n", (CORBA_int)l);

		IPA_LOG_init(0);

		printf("_id OK: %s\n", CORBA_exception_id(&ev));
		CORBA_exception_free(&ev);
	}

	CORBA_Object_release((CORBA_Object)orb, &ev);

	printf("### END : Task 06 ###\n");

	FlgTsk06 = 1;

	ext_tsk();
}

#ifdef	CORBA_UNIX

void
main(int argc, char *argv[])
{
	SYS_init_debug(0);
	if (ecorba_init()) {
		printf("ERROR ecorba_init\n");
		exit(-1);
	}

	IORstr1 = (CORBA_char *)SYS_malloc(1024);
	if (TP_IOR_recv(PORT, IORstr1) == CORBA_FLASE) {
		return -1;
	}

	IORstr2 = (CORBA_char *)SYS_malloc(1024);
	if (TP_IOR_recv(PORT, IORstr2) == CORBA_FLASE) {
		SYS_free(IORstr1);
		return -1;
	}

	IORstr3 = (CORBA_char *)SYS_malloc(1024);
	if (TP_IOR_recv(PORT, IORstr3) == CORBA_FLASE) {
		SYS_free(IORstr1);
		SYS_free(IORstr2);
		return -1;
	}

	tsk01();

	SYS_free(IORstr1);
	SYS_free(IORstr2);
	SYS_free(IORstr3);

	exit(0);
}

#else	/* CORBA_UNIX */

ERR
main(Bool Startup, TC *arg)
{
	WERR		tskid0;

	MAIN_START();

	SYS_init_debug(0);
	IPA_LOG_init(0);

	if (ECORBA_init(&sg_def)) {
		return 1;
	}

	TP_IOR_recv(PORT, IORstr1);
	TP_IOR_recv(PORT, IORstr2);
	TP_IOR_recv(PORT, IORstr3);

	tskid0 = TP_CreateTask(tsk, DEFAULT_PRI);
	printf("tskid0: %d\n", tskid0);

	MAIN_END();
	return 0;
}

#endif	/* CORBA_UNIX */

