/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#include "s2102.h"
#include "config.h"
#include "_sysdbg.h"
#include "_syslibc.h"
#include "_loging.h"

#define PORT 6666

CORBA_UsrDefine corba_def = {
	CORBA_TARGET_NAME,
	CORBA_SERVER_NUMBER,
	CORBA_MAX_MEMORY,
	CORBA_NULL,
	0,
	0,
	0,
	0
};

ASRV_UsrDefine asrv_def = {
	ASRV_SERVER_ID,
	ASRV_SERVER_PRI,
	ASRV_SERVER_PORT,
	ASRV_OBJECT_PRI,
	ASRV_OBJECT_NUMBER,
	ASRV_DYNAMIC_NUMBER,
	0,
	0,
	0,
	0
};

ORB_UsrDefine orb_def = {
	0,
	0,
	0,
	0
};

POA_UsrDefine poa_def = {
	POA_MAX_POA_NUMBER,
	POA_MAX_SERVANT_NUMBER,
	0,
	0,
	0,
	0
};

MRSHL_UsrDefine mrshl_def = {
	0,
	0,
	0,
	0
};

GIOP_UsrDefine giop_def = {
	0,
	0,
	0,
	0
};

CON_UsrDefine con_def = {
	CON_SERVER_NUMBER,
	CON_CLIENT_NUMBER,
	CON_SERVER_TIMEOUT,
	0,
	0,
	0,
	0
};

SYS_UsrDefine sys_def = {
	0,
	0,
	0,
	0
};

SG_CORBA sg_def = {
	&corba_def,
	&asrv_def,
	&orb_def,
	&poa_def,
	&mrshl_def,
	&giop_def,
	&con_def,
	&sys_def,
	0,
	0,
	0,
	0
};

CORBA_ORB	Orb[3];

CORBA_char
func_impl(PortableServer_Servant servant, const CORBA_char test,
	  CORBA_Environment *ev)
{
	printf("func_impl arg %d ret %d\n",
	       (CORBA_int)test, (CORBA_int)test + 1);
	return test + 1;
}

CORBA_long
func_shutdown_impl(PortableServer_Servant servant, CORBA_long num, 
	  CORBA_Environment *ev)
{
	CORBA_ORB_shutdown(Orb[num], ev);
	return 0;
}

PortableServer_ServantBase__epv base_epv = {
	NULL,
	NULL,
	NULL
};

static void tsk(void);
static void tsk01(void);
static void tsk02(void);
static void tsk03(void);

void
tsk(void)
{
	ID	id1;
	ID	id2;
	ID	id3;

	id1 = TP_CreateTask(tsk01, DEFAULT_PRI);	dly_tsk(200);
	id2 = TP_CreateTask(tsk02, DEFAULT_PRI);	dly_tsk(200);
	id3 = TP_CreateTask(tsk03, DEFAULT_PRI);

	exit(-1);
}

void
tsk01(void)
{
	int				argc;
	char				*argv;
	CORBA_Environment		ev;
	CORBA_Object			obj;
	PortableServer_ObjectId		*oid;
	PortableServer_POA		root_poa;
	PortableServer_POAManager	poa_mgr = NULL;
	POA_Test__epv			test_epv = {NULL, func_impl, func_shutdown_impl};
	POA_Test__vepv			test_vepv = { NULL, &base_epv, &test_epv };
	POA_Test			test = { 0, &test_vepv };
	CORBA_char			*str;

	printf("### START : Task 01 ###\n");
	CORBA_exception_init(&ev);

	argc = 0;
	Orb[0] = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	if (ev._major != CORBA_NO_EXCEPTION) {
		printf("Failed to get orb\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	/*
         * RootPOA롣
         */
	obj = CORBA_ORB_resolve_initial_references(Orb[0], "RootPOA", &ev);
	root_poa = (PortableServer_POA)obj;
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to get poa\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	/*
         * RootPOAȴϢŤ줿POAManager롣
         */
	poa_mgr = PortableServer_POA__get_the_POAManager(root_poa, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to get poa_mgr\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	POA_Test__init(&test, &ev);
	
	oid = PortableServer_string_to_ObjectId("test", &ev);
	
	/*
         * POA˥ХȤϿ롣
         */
	PortableServer_POA_activate_object_with_id(root_poa, oid, &test, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to activate object bank account\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	/*
         * POAManager˳Υå롣
         * POAManagerϿƤ뤹٤ƤPOA롣
         */
	PortableServer_POAManager_activate(poa_mgr, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to activate poa manager\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	/*
	 * ХȤ饪֥ȥե󥹤κ
         */
        obj = PortableServer_POA_servant_to_reference(root_poa, &test, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to servant_to_reference\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}
	
	/*
	 * ֥ȥե󥹤ʸѴ
         */
	str = CORBA_ORB_object_to_string(Orb[0], obj, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to object_to_string\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	/*
	 * Ϥǡ֥ȥե󥹤
         * 饤ȤذϤɬפ롣
         */
	TP_IOR_send(PORT, str);

	IPA_LOG_Srv_init(IPA_LOG_CON);
	/*
	 * ORBå롼פ롣
         */
	CORBA_ORB_run(Orb[0], &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to run Orb[0]\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	/*
	 * POA
	 * (Don't reach)
         */
	PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to destroy poa\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	CORBA_Object_release((CORBA_Object)Orb[0], &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to destroy poa\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	printf("### END : Task 01 ###\n");
	exit(-1);
}

void
tsk02(void)
{
	int				argc;
	char				*argv;
	CORBA_Environment		ev;
	CORBA_Object			obj;
	PortableServer_ObjectId		*oid;
	PortableServer_POA		root_poa;
	PortableServer_POAManager	poa_mgr = NULL;
	POA_Test__epv			test_epv = {NULL, func_impl, func_shutdown_impl};
	POA_Test__vepv			test_vepv = { NULL, &base_epv, &test_epv };
	POA_Test			test = { 0, &test_vepv };
	CORBA_char			*str;

	printf("### START : Task 02 ###\n");
	CORBA_exception_init(&ev);

	argc = 0;
	Orb[1] = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	if (ev._major != CORBA_NO_EXCEPTION) {
		printf("Failed to get orb\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	/*
         * RootPOA롣
         */
	obj = CORBA_ORB_resolve_initial_references(Orb[1], "RootPOA", &ev);
	root_poa = (PortableServer_POA)obj;
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to get poa\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	/*
         * RootPOAȴϢŤ줿POAManager롣
         */
	poa_mgr = PortableServer_POA__get_the_POAManager(root_poa, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to get poa_mgr\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	POA_Test__init(&test, &ev);
	
	oid = PortableServer_string_to_ObjectId("test", &ev);
	
	/*
         * POA˥ХȤϿ롣
         */
	PortableServer_POA_activate_object_with_id(root_poa, oid, &test, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to activate object bank account\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	/*
         * POAManager˳Υå롣
         * POAManagerϿƤ뤹٤ƤPOA롣
         */
	PortableServer_POAManager_activate(poa_mgr, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to activate poa manager\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	/*
	 * ХȤ饪֥ȥե󥹤κ
         */
        obj = PortableServer_POA_servant_to_reference(root_poa, &test, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to servant_to_reference\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}
	
	/*
	 * ֥ȥե󥹤ʸѴ
         */
	str = CORBA_ORB_object_to_string(Orb[1], obj, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to object_to_string\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	/*
	 * Ϥǡ֥ȥե󥹤
         * 饤ȤذϤɬפ롣
         */
	TP_IOR_send(PORT, str);

	/*
	 * ORBå롼פ롣
         */
	CORBA_ORB_run(Orb[1], &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to run Orb[1]\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	/*
	 * POA
	 * (Don't reach)
         */
	PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to destroy poa\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	CORBA_Object_release((CORBA_Object)Orb[1], &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to destroy poa\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	printf("### END : Task 02 ###\n");	dly_tsk(200);
	exit(-1);
}

void
tsk03(void)
{
	int				argc;
	char				*argv;
	CORBA_Environment		ev;
	CORBA_Object			obj;
	PortableServer_ObjectId		*oid;
	PortableServer_POA		root_poa;
	PortableServer_POAManager	poa_mgr = NULL;
	POA_Test__epv			test_epv = {NULL, func_impl, func_shutdown_impl};
	POA_Test__vepv			test_vepv = { NULL, &base_epv, &test_epv };
	POA_Test			test = { 0, &test_vepv };
	CORBA_char			*str;

	printf("### START : Task 03 ###\n");
	CORBA_exception_init(&ev);

	argc = 0;
	Orb[2] = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	if (ev._major != CORBA_NO_EXCEPTION) {
		printf("Failed to get Orb[2]\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	/*
         * RootPOA롣
         */
	obj = CORBA_ORB_resolve_initial_references(Orb[2], "RootPOA", &ev);
	root_poa = (PortableServer_POA)obj;
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to get poa\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	/*
         * RootPOAȴϢŤ줿POAManager롣
         */
	poa_mgr = PortableServer_POA__get_the_POAManager(root_poa, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to get poa_mgr\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	POA_Test__init(&test, &ev);
	
	oid = PortableServer_string_to_ObjectId("test", &ev);
	
	/*
         * POA˥ХȤϿ롣
         */
	PortableServer_POA_activate_object_with_id(root_poa, oid, &test, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to activate object bank account\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	/*
         * POAManager˳Υå롣
         * POAManagerϿƤ뤹٤ƤPOA롣
         */
	PortableServer_POAManager_activate(poa_mgr, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to activate poa manager\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	/*
	 * ХȤ饪֥ȥե󥹤κ
         */
        obj = PortableServer_POA_servant_to_reference(root_poa, &test, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to servant_to_reference\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}
	
	/*
	 * ֥ȥե󥹤ʸѴ
         */
	str = CORBA_ORB_object_to_string(Orb[2], obj, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to object_to_string\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	/*
	 * Ϥǡ֥ȥե󥹤
         * 饤ȤذϤɬפ롣
         */
	TP_IOR_send(PORT, str);

	/*
	 * ORBå롼פ롣
         */
	CORBA_ORB_run(Orb[2], &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to run Orb[2]\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	/*
	 * POA
	 * (Don't reach)
         */
	PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to destroy poa\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	CORBA_Object_release((CORBA_Object)Orb[2], &ev);
	if (ev._major != CORBA_NO_EXCEPTION){
		printf("Failed to destroy poa\n");
		CORBA_exception_free(&ev);
		exit(-1);
	}

	printf("### END : Task 03 ###\n");	dly_tsk(200);
	exit(-1);
}

#ifdef	CORBA_UNIX

void
main(int argc, char *argv[])
{
	SYS_init_debug(0);
	if (ecorba_init()) {
		printf("ERROR ecorba_init\n");
		exit(-1);
	}

	tsk();
	exit(0);
}

#else	CORBA_UNIX

ERR
main(Bool Startup, TC *arg)
{
	WERR		tskid0;

	SYS_init_debug(0);
	IPA_LOG_init(0);

	if (ECORBA_init(&sg_def)) {
		return 1;
	}

	tskid0 = TP_CreateTask(tsk, DEFAULT_PRI);
	printf("tskid0: %d\n", tskid0);
	return 0;
}

#endif	/* CORBA_UNIX */
