/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#include "config.h"
#include "tpchk.h"
#include "s2301.h"
#include "ior1.h"
#include "ior2.h"
#include "ior3.h"
#include "_sysdbg.h"
#include "_loging.h"

static CORBA_long taskid_func(CORBA_Object, CORBA_Environment *);

void
task(void)
{
	int			argc = 0;
	char			*argv = "";
	CORBA_Environment	ev;
	CORBA_ORB		orb;

	TP_START();
	TP_corba_init();

	CORBA_exception_init(&ev);

	orb = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/* s230101 */
	/* s230201 */
	{
		CORBA_Object	obj1;
		CORBA_long	tskid1;

		TP_LINE();
		TP_INFO(("\ns230101\n"));

		CORBA_exception_init(&ev);
		obj1 = CORBA_ORB_string_to_object(orb, testIOR1, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((obj1 != CORBA_NULL), (" "));

 		/*
		 * ФإꥯȤ롣
		 */
		tskid1 = taskid_func(obj1, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_Msg("tskid : %d\n", tskid1);
		TP_Msg("Request send OK\n");
		
		/* 饤ȽλΤ */
		sync_send(SYNC_SERVER_NAME, SYNC_PORT);

		/* ФκλԤ */
		sync_recv(SYNC_PORT);

		TP_INFO(("s230101 OK\n"));
		TP_LINE();

		TP_INFO(("s230201\n"));

 		/*
		 * кǧ
		 * λФإꥯȤ롣
		 */
		taskid_func(obj1, &ev);
		TP_CHECK((ev._major == CORBA_SYSTEM_EXCEPTION), (" "));
		TP_Msg("_major : %d\n", ev._major);
		TP_CHECK((strcmp(ev._id, CORBA_Ex_NO_IMPLEMENT) == 0), (" "));
		TP_Msg("_id : %s\n", ev._id);
		TP_Msg("Server Delete OK\n");
		CORBA_exception_free(&ev);

		CORBA_Object_release(obj1, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		TP_INFO(("s230201 OK\n"));
		TP_LINE();
	}
	/* s230101 end */
	/* s230201 end */

	/* 饤ȽλΤ */
	sync_send(SYNC_SERVER_NAME, SYNC_PORT);

	/* s230102 */
	/* s230202 */
	{
		CORBA_Object	obj1;
		CORBA_Object	obj2;
		CORBA_long	tskid1;
		CORBA_long	tskid2;

		TP_INFO(("\ns230102\n"));

		/* 2ФϿλԤ */
		sync_recv(SYNC_PORT);

		CORBA_exception_init(&ev);
		obj1 = CORBA_ORB_string_to_object(orb, testIOR1, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((obj1 != CORBA_NULL), (" "));

		obj2 = CORBA_ORB_string_to_object(orb, testIOR2, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((obj2 != CORBA_NULL), (" "));

 		/*
		 * ФإꥯȤ롣
		 */
		tskid1 = taskid_func(obj1, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_Msg("tskid : %d\n", tskid1);
		TP_Msg("Request send OK\n");

		tskid2 = taskid_func(obj2, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_Msg("tskid : %d\n", tskid2);
		TP_Msg("Request send OK\n");
		
		/* 饤ȽλΤ */
		sync_send(SYNC_SERVER_NAME, SYNC_PORT);

		/* 2ФκλԤ */
		sync_recv(SYNC_PORT);

		TP_INFO(("s230102 OK\n"));
		TP_LINE();

		TP_INFO(("s230202\n"));

 		/*
		 * кǧ
		 * λФإꥯȤ롣
		 */
		taskid_func(obj1, &ev);
		TP_CHECK((ev._major == CORBA_SYSTEM_EXCEPTION), (" "));
		TP_Msg("_major : %d\n", ev._major);
		TP_CHECK((strcmp(ev._id, CORBA_Ex_NO_IMPLEMENT) == 0), (" "));
		TP_Msg("_id : %s\n", ev._id);
		TP_Msg("Server Delete OK\n");
		CORBA_exception_free(&ev);

		taskid_func(obj2, &ev);
		TP_CHECK((ev._major == CORBA_SYSTEM_EXCEPTION), (" "));
		TP_Msg("_major : %d\n", ev._major);
		TP_CHECK((strcmp(ev._id, CORBA_Ex_NO_IMPLEMENT) == 0), (" "));
		TP_Msg("_id : %s\n", ev._id);
		TP_Msg("Server Delete OK\n");
		CORBA_exception_free(&ev);

		CORBA_Object_release(obj1, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		CORBA_Object_release(obj2, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		TP_INFO(("s230202 OK\n"));
		TP_LINE();
	}
	/* s230102 end */
	/* s230202 end */

	/* 饤ȽλΤ */
	sync_send(SYNC_SERVER_NAME, SYNC_PORT);

	/* s230103 */
	/* s230203 */
	{
		CORBA_Object	obj1;
		CORBA_Object	obj2;
		CORBA_Object	obj3;
		CORBA_long	tskid1;
		CORBA_long	tskid2;
		CORBA_long	tskid3;

		TP_INFO(("\nk230103\n"));

		/* 3ФϿλԤ */
		sync_recv(SYNC_PORT);

		CORBA_exception_init(&ev);
		obj1 = CORBA_ORB_string_to_object(orb, testIOR1, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((obj1 != CORBA_NULL), (" "));

		obj2 = CORBA_ORB_string_to_object(orb, testIOR2, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((obj2 != CORBA_NULL), (" "));

		obj3 = CORBA_ORB_string_to_object(orb, testIOR3, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((obj3 != CORBA_NULL), (" "));

 		/*
		 * ФإꥯȤ롣
		 */
		tskid1 = taskid_func(obj1, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_Msg("tskid : %d\n", tskid1);
		TP_Msg("Request send OK\n");

		tskid2 = taskid_func(obj2, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_Msg("tskid : %d\n", tskid2);
		TP_Msg("Request send OK\n");
		
		tskid3 = taskid_func(obj3, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_Msg("tskid : %d\n", tskid3);
		TP_Msg("Request send OK\n");
		
		/* 饤ȽλΤ */
		sync_send(SYNC_SERVER_NAME, SYNC_PORT);

		/* 3ФκλԤ */
		sync_recv(SYNC_PORT);

		TP_INFO(("s230103 OK\n"));
		TP_LINE();

		TP_INFO(("s230203\n"));

 		/*
		 * кǧ
		 * λФإꥯȤ롣
		 */
		taskid_func(obj1, &ev);
		TP_CHECK((ev._major == CORBA_SYSTEM_EXCEPTION), (" "));
		TP_Msg("_major : %d\n", ev._major);
		TP_CHECK((strcmp(ev._id, CORBA_Ex_NO_IMPLEMENT) == 0), (" "));
		TP_Msg("_id : %s\n", ev._id);
		TP_Msg("Server Delete OK\n");
		CORBA_exception_free(&ev);

		taskid_func(obj2, &ev);
		TP_CHECK((ev._major == CORBA_SYSTEM_EXCEPTION), (" "));
		TP_Msg("_major : %d\n", ev._major);
		TP_CHECK((strcmp(ev._id, CORBA_Ex_NO_IMPLEMENT) == 0), (" "));
		TP_Msg("_id : %s\n", ev._id);
		TP_Msg("Server Delete OK\n");
		CORBA_exception_free(&ev);

		taskid_func(obj3, &ev);
		TP_CHECK((ev._major == CORBA_SYSTEM_EXCEPTION), (" "));
		TP_Msg("_major : %d\n", ev._major);
		TP_CHECK((strcmp(ev._id, CORBA_Ex_NO_IMPLEMENT) == 0), (" "));
		TP_Msg("_id : %s\n", ev._id);
		TP_Msg("Server Delete OK\n");
		CORBA_exception_free(&ev);

		CORBA_Object_release(obj1, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		CORBA_Object_release(obj2, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		CORBA_Object_release(obj3, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		TP_INFO(("s230203 OK\n"));
		TP_LINE();
	}
	/* s230103 end */
	/* s230203 end */

	/* 饤ȽλΤ */
	sync_send(SYNC_SERVER_NAME, SYNC_PORT);

	TP_corba_fini();
	TP_delete_ASRVtsk(ASRV_SERVER_ID);
	TP_END();
}

static CORBA_long
taskid_func(CORBA_Object obj, CORBA_Environment *ev)
{
	CORBA_char		*topp;
	CORBA_char		*bufp;
	CORBA_long		ret;
	CORBA_unsigned_long	size;
	GIOP_CliInf		cliinf;

	CORBA_exception_init(ev);
	GIOP_init_cli(&cliinf);

	do {
		size = 0;
		topp = GIOP_create_reqbuf(obj, &cliinf, size, CORBA_TRUE,
					"taskid_func", ev);
		TP_CHECK((ev->_major == CORBA_NO_EXCEPTION), (" "));

		bufp = topp;
		size = 0;
		size = bufp - topp;
		topp = GIOP_invoke_req(obj, &cliinf, size, ev);
	} while (ev->_flag == ENVFLG_LOCATION_FORWARD);

	bufp = topp;
	ret = MRSHL_get_long(&bufp, GIOP_cli_bordr(&cliinf));

	GIOP_end_cli(&cliinf);

	return ret;
}

#ifdef	CORBA_UNIX

int
main(void)
{
	MAIN_START();	

	SYS_init_debug(0);

	task();

	MAIN_END();	
	return 0;
}

#else	/* CORBA_UNIX */

ERR
main(Bool Startup, TC *arg)
{
	MAIN_START();	

	SYS_init_debug(0);
	IPA_LOG_init(0);

	TP_CreateTask(task, DEFAULT_PRI);

	MAIN_END();

	return 0;
}

#endif	/* CORBA_UNIX */
