/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#include "config.h"
#include "tpchk.h"
#include "s2301.h"
#include "_loging.h"
#include "_sysdbg.h"

void
test_task1(void)
{
	server(SERVER_NUMBER_1, SERVER_NAME_1);
}

void
test_task2(void)
{
	server(SERVER_NUMBER_2, SERVER_NAME_2);
}

void
test_task3(void)
{
	server(SERVER_NUMBER_3, SERVER_NAME_3);
}

void
test_task4(void)
{
}

static void
wait_tsk_delete(id)
{
	ER			ercd;
	T_RTSK			pk_rtsk;

	while (1) {
		ercd = ref_tsk(&pk_rtsk, id);
		if (ercd == E_OK) {
			tslp_tsk(10);
		} else {
			break;
		}
	};
}

ERR
main(Bool Startup, TC *arg)
{
	CORBA_boolean	ret;
	T_CTSK		tsk;

	SYS_init_debug(0);
	IPA_LOG_init(0);

	chg_pri(0, DEFAULT_PRI - 1);
	TP_corba_init();

	TP_LINE();

	/* s230101 */
	/* s230201 */
	/* s230301 */
	/* s230401 */
	{
		ASRV_DobjInf	info1;
		CORBA_int	doid1;
		ID		tskid;

		TP_INFO(("\ns230101\n"));
		TP_INFO(("s230301\n"));

		/*
		 * ФưŪ֥ȴơ֥Ͽ
		 */
		tsk.exinf = (VP)CH4toW('S','R','V','1');
		tsk.task = test_task1;
		tsk.itskpri = DEFAULT_PRI;
		tsk.stksz = 0x4000;
		tsk.tskatr = TA_HLNG | TA_RNG0;
		TP_Msg("server task entry %s\n", SERVER_NAME_1);

		IPA_LOG_init(IPA_LOG_DYN_GET);
		doid1 = ASRV_entry_dobj(&tsk, SERVER_NAME_1, 1);
		IPA_LOG_init(0);

		TP_CHECK((doid1 > 0), (" "));
		TP_Msg("doid %d\n", doid1);

		/* 1Ф˴ؤ븡λΤԤ */
		sync_recv(SYNC_PORT);

		TP_INFO(("s230101 OK\n"));
		TP_INFO(("s230301 OK\n"));
		TP_LINE();

		TP_INFO(("s230401\n"));

		/*
		 * ФΥID
		 */
		ret = ASRV_info_dobj_id(doid1, &info1);
		TP_CHECK((ret == CORBA_TRUE), (" "));
		TP_Msg("object taskid %d\n", info1.inf_task);

		/*
		 * ̻ҤΥå
		 */
		TP_CHECK((doid1 > 0), (" "));
		TP_Msg("doid check OK : %d\n", doid1);

		/*
		 * ưŪϿ󥿡եɽ
		 */
		TP_CHECK((info1.inf_soid > 0), (" "));
		TP_Msg("dobj_soid %d\n", info1.inf_soid);
		TP_CHECK((info1.inf_vers == 1), (" "));
		TP_Msg("dobj_vers %d\n", info1.inf_vers);
		TP_CHECK((info1.inf_delf == 0), (" "));
		TP_Msg("dobj_delf %d\n", info1.inf_delf);

		TP_INFO(("s230401 OK\n"));
		TP_LINE();

		TP_INFO(("s230201\n"));

		/*
		 * ФưŪ֥ȴơ֥뤫
		 */
		tskid = ASRV_cancel_dobj_id(doid1);
		TP_CHECK((tskid == info1.inf_task), (" "));
		TP_Msg("cancel object id %d\n", info1.inf_task);

		/*
		 * Фνλǧ
		 */
		wait_tsk_delete(info1.inf_task);
		TP_Msg("delete task id %d\n", info1.inf_task);

		/* 1Ф줿ȤΤ */
		sync_send(SYNC_CLIENT_NAME, SYNC_PORT);

		TP_INFO(("s230201 OK\n"));
		TP_LINE();


	}
	/* s230101 end */
	/* s230201 end */
	/* s230301 end */
	/* s230401 end */


	/* 饤ȽλԤ */
	sync_recv(SYNC_PORT);


	/* s230102 */
	/* s230202 */
	/* s230302 */
	/* s230402 */
	{
		ASRV_DobjInf	info1;
		ASRV_DobjInf	info2;
		CORBA_int	doid1;
		CORBA_int	doid2;
		ID		tskid;

		TP_INFO(("\ns230102\n"));
		TP_INFO(("s230302\n"));

		/*
		 * ФưŪ֥ȴơ֥Ͽ
		 */
		tsk.exinf = (VP)CH4toW('S','R','V','1');
		tsk.task = test_task1;
		tsk.itskpri = DEFAULT_PRI;
		tsk.stksz = 0x4000;
		tsk.tskatr = TA_HLNG | TA_RNG0;
		TP_Msg("server task entry %s\n", SERVER_NAME_1);

		IPA_LOG_init(IPA_LOG_DYN_GET);
		doid1 = ASRV_entry_dobj(&tsk, SERVER_NAME_1, 2);
		IPA_LOG_init(0);

		TP_CHECK((doid1 > 0), (" "));
		TP_Msg("doid %d\n", doid1);

		tsk.exinf = (VP)CH4toW('S','R','V','2');
		tsk.task = test_task2;
		tsk.itskpri = DEFAULT_PRI;
		tsk.stksz = 0x4000;
		tsk.tskatr = TA_HLNG | TA_RNG0;
		TP_Msg("server task entry %s\n", SERVER_NAME_2);

		IPA_LOG_init(IPA_LOG_DYN_GET);
		doid2 = ASRV_entry_dobj(&tsk, SERVER_NAME_2, 3);
		IPA_LOG_init(0);

		TP_CHECK((doid2 > 0), (" "));
		TP_Msg("doid %d\n", doid2);

		/* 2ФϿ줿ȤΤ */
		sync_send(SYNC_CLIENT_NAME, SYNC_PORT);

		/* 饤ȽλԤ */
		sync_recv(SYNC_PORT);

		TP_INFO(("s230102 OK\n"));
		TP_INFO(("s230302 OK\n"));
		TP_LINE();

		TP_INFO(("s230402\n"));

		/*
		 * ФΥID
		 */
		ret = ASRV_info_dobj_id(doid1, &info1);
		TP_CHECK((ret == CORBA_TRUE), (" "));
		TP_Msg("object taskid %d\n", info1.inf_task);

		ret = ASRV_info_dobj_id(doid2, &info2);
		TP_CHECK((ret == CORBA_TRUE), (" "));
		TP_Msg("object taskid %d\n", info2.inf_task);

		/*
		 * ̻ҤΥå
		 */
		TP_CHECK((doid1 != doid2), (" "));
		TP_Msg("doid check OK : %d %d\n", doid1, doid2);

		/*
		 * ưŪϿ󥿡եɽ
		 */
		TP_CHECK((info1.inf_soid > 0), (" "));
		TP_Msg("dobj_soid %d\n", info1.inf_soid);
		TP_CHECK((info1.inf_vers == 2), (" "));
		TP_Msg("dobj_vers %d\n", info1.inf_vers);
		TP_CHECK((info1.inf_delf == 0), (" "));
		TP_Msg("dobj_delf %d\n", info1.inf_delf);

		TP_CHECK((info2.inf_soid > 0), (" "));
		TP_Msg("dobj_soid %d\n", info2.inf_soid);
		TP_CHECK((info2.inf_vers == 3), (" "));
		TP_Msg("dobj_vers %d\n", info2.inf_vers);
		TP_CHECK((info2.inf_delf == 0), (" "));
		TP_Msg("dobj_delf %d\n", info2.inf_delf);

		TP_INFO(("s230402 OK\n"));
		TP_LINE();

		TP_INFO(("s230202\n"));

		/*
		 * ФưŪ֥ȴơ֥뤫
		 */
		tskid = ASRV_cancel_dobj_id(doid1);
		TP_CHECK((tskid == info1.inf_task), (" "));
		TP_Msg("cancel object id %d\n", info1.inf_task);

		tskid = ASRV_cancel_dobj_id(doid2);
		TP_CHECK((tskid == info2.inf_task), (" "));
		TP_Msg("cancel object id %d\n", info2.inf_task);

		/*
		 * Фνλǧ
		 */
		wait_tsk_delete(info1.inf_task);
		wait_tsk_delete(info2.inf_task);
		TP_Msg("delete task id %d\n", info1.inf_task);
		TP_Msg("delete task id %d\n", info2.inf_task);

		/* 2Ф줿ȤΤ */
		sync_send(SYNC_CLIENT_NAME, SYNC_PORT);

		TP_INFO(("s230202 OK\n"));
		TP_LINE();
	}
	/* s230102 end */
	/* s230202 end */
	/* s230302 end */
	/* s230402 end */

	/* 饤ȽλԤ */
	sync_recv(SYNC_PORT);

	/* s230103 end */
	/* s230203 end */
	/* s230303 end */
	/* s230403 end */
	{
		ASRV_DobjInf	info1;
		ASRV_DobjInf	info2;
		ASRV_DobjInf	info3;
		CORBA_int	doid1;
		CORBA_int	doid2;
		CORBA_int	doid3;
		ID		tskid;

		TP_INFO(("\ns230103\n"));
		TP_INFO(("s230303\n"));

		/*
		 * ФưŪ֥ȴơ֥Ͽ
		 */
		tsk.exinf = (VP)CH4toW('S','R','V','1');
		tsk.task = test_task1;
		tsk.itskpri = DEFAULT_PRI;
		tsk.stksz = 0x4000;
		tsk.tskatr = TA_HLNG | TA_RNG0;
		TP_Msg("server task entry %s\n", SERVER_NAME_1);

		IPA_LOG_init(IPA_LOG_DYN_GET);
		doid1 = ASRV_entry_dobj(&tsk, SERVER_NAME_1, 4);
		IPA_LOG_init(0);

		TP_CHECK((doid1 > 0), (" "));
		TP_Msg("doid %d\n", doid1);

		tsk.exinf = (VP)CH4toW('S','R','V','2');
		tsk.task = test_task2;
		tsk.itskpri = DEFAULT_PRI;
		tsk.stksz = 0x4000;
		tsk.tskatr = TA_HLNG | TA_RNG0;
		TP_Msg("server task entry %s\n", SERVER_NAME_2);

		IPA_LOG_init(IPA_LOG_DYN_GET);
		doid2 = ASRV_entry_dobj(&tsk, SERVER_NAME_2, 5);
		IPA_LOG_init(0);

		TP_CHECK((doid2 > 0), (" "));
		TP_Msg("doid %d\n", doid2);

		tsk.exinf = (VP)CH4toW('S','R','V','3');
		tsk.task = test_task3;
		tsk.itskpri = DEFAULT_PRI;
		tsk.stksz = 0x4000;
		tsk.tskatr = TA_HLNG | TA_RNG0;
		TP_Msg("server task entry %s\n", SERVER_NAME_3);

		IPA_LOG_init(IPA_LOG_DYN_GET);
		doid3 = ASRV_entry_dobj(&tsk, SERVER_NAME_3, 6);
		IPA_LOG_init(0);

		TP_CHECK((doid3 > 0), (" "));
		TP_Msg("doid %d\n", doid3);

		/* 3ФϿ줿ȤΤ */
		sync_send(SYNC_CLIENT_NAME, SYNC_PORT);

		/* 饤ȽλԤ */
		sync_recv(SYNC_PORT);

		TP_INFO(("s230103 OK\n"));
		TP_INFO(("s230303 OK\n"));
		TP_LINE();

		TP_INFO(("s230403\n"));

		/*
		 * ̻ҤΥå
		 */
		TP_CHECK((doid1 != doid2), (" "));
		TP_CHECK((doid1 != doid3), (" "));
		TP_CHECK((doid2 != doid3), (" "));
		TP_Msg("doid check OK : %d %d %d\n", doid1, doid2, doid3);

		/*
		 * ФΥID
		 */
		ret = ASRV_info_dobj_id(doid1, &info1);
		TP_CHECK((ret == CORBA_TRUE), (" "));
		TP_Msg("object taskid %d\n", info1.inf_task);

		ret = ASRV_info_dobj_id(doid2, &info2);
		TP_CHECK((ret == CORBA_TRUE), (" "));
		TP_Msg("object taskid %d\n", info2.inf_task);

		ret = ASRV_info_dobj_id(doid3, &info3);
		TP_CHECK((ret == CORBA_TRUE), (" "));
		TP_Msg("object taskid %d\n", info3.inf_task);

		/*
		 * ưŪϿ󥿡եɽ
		 */
		TP_CHECK((info1.inf_soid > 0), (" "));
		TP_Msg("dobj_soid %d\n", info1.inf_soid);
		TP_CHECK((info1.inf_vers == 4), (" "));
		TP_Msg("dobj_vers %d\n", info1.inf_vers);
		TP_CHECK((info1.inf_delf == 0), (" "));
		TP_Msg("dobj_delf %d\n", info1.inf_delf);

		TP_CHECK((info2.inf_soid > 0), (" "));
		TP_Msg("dobj_soid %d\n", info2.inf_soid);
		TP_CHECK((info2.inf_vers == 5), (" "));
		TP_Msg("dobj_vers %d\n", info2.inf_vers);
		TP_CHECK((info2.inf_delf == 0), (" "));
		TP_Msg("dobj_delf %d\n", info2.inf_delf);

		TP_CHECK((info3.inf_soid > 0), (" "));
		TP_Msg("dobj_soid %d\n", info3.inf_soid);
		TP_CHECK((info3.inf_vers == 6), (" "));
		TP_Msg("dobj_vers %d\n", info3.inf_vers);
		TP_CHECK((info3.inf_delf == 0), (" "));
		TP_Msg("dobj_delf %d\n", info3.inf_delf);

		TP_INFO(("s230403 OK\n"));
		TP_LINE();

		TP_INFO(("s230203\n"));

		/*
		 * ФưŪ֥ȴơ֥뤫
		 */
		tskid = ASRV_cancel_dobj_id(doid1);
		TP_CHECK((tskid == info1.inf_task), (" "));
		TP_Msg("cancel object id %d\n", info1.inf_task);

		tskid = ASRV_cancel_dobj_id(doid2);
		TP_CHECK((tskid == info2.inf_task), (" "));
		TP_Msg("cancel object id %d\n", info2.inf_task);

		tskid = ASRV_cancel_dobj_id(doid3);
		TP_CHECK((tskid == info3.inf_task), (" "));
		TP_Msg("cancel object id %d\n", info3.inf_task);

		/*
		 * Фνλǧ
		 */
		wait_tsk_delete(info1.inf_task);
		wait_tsk_delete(info2.inf_task);
		wait_tsk_delete(info3.inf_task);
		TP_Msg("delete task id %d\n", info1.inf_task);
		TP_Msg("delete task id %d\n", info2.inf_task);
		TP_Msg("delete task id %d\n", info3.inf_task);

		/* 3Ф줿ȤΤ */
		sync_send(SYNC_CLIENT_NAME, SYNC_PORT);

		TP_INFO(("s230203 OK\n"));
		TP_LINE();
	}
	/* s230103 end */
	/* s230203 end */
	/* s230303 end */
	/* s230403 end */

	/* 饤ȽλԤ */
	sync_recv(SYNC_PORT);

	TP_LINE();
	TP_INFO(("\ns230104\n"));
	{
		CORBA_int	doid1;
		CORBA_int	doid2;
		CORBA_int	doid3;
		CORBA_int	doid4;

		/*
		 * ФưŪ֥ȴơ֥Ͽ
		 */
		tsk.exinf = (VP)CH4toW('S','R','V','1');
		tsk.task = test_task1;
		tsk.itskpri = DEFAULT_PRI;
		tsk.stksz = 0x4000;
		tsk.tskatr = TA_HLNG | TA_RNG0;
		TP_Msg("server task entry %s\n", SERVER_NAME_1);

		IPA_LOG_init(IPA_LOG_DYN_GET);
		doid1 = ASRV_entry_dobj(&tsk, SERVER_NAME_1, 7);
		IPA_LOG_init(0);

		TP_CHECK((doid1 > 0), (" "));
		TP_Msg("doid %d\n", doid1);

		tsk.exinf = (VP)CH4toW('S','R','V','2');
		tsk.task = test_task2;
		tsk.itskpri = DEFAULT_PRI;
		tsk.stksz = 0x4000;
		tsk.tskatr = TA_HLNG | TA_RNG0;
		TP_Msg("server task entry %s\n", SERVER_NAME_2);

		IPA_LOG_init(IPA_LOG_DYN_GET);
		doid2 = ASRV_entry_dobj(&tsk, SERVER_NAME_2, 8);
		IPA_LOG_init(0);

		TP_CHECK((doid2 > 0), (" "));
		TP_Msg("doid %d\n", doid2);

		tsk.exinf = (VP)CH4toW('S','R','V','3');
		tsk.task = test_task3;
		tsk.itskpri = DEFAULT_PRI;
		tsk.stksz = 0x4000;
		tsk.tskatr = TA_HLNG | TA_RNG0;
		TP_Msg("server task entry %s\n", SERVER_NAME_3);

		IPA_LOG_init(IPA_LOG_DYN_GET);
		doid3 = ASRV_entry_dobj(&tsk, SERVER_NAME_3, 9);
		IPA_LOG_init(0);

		TP_CHECK((doid3 > 0), (" "));
		TP_Msg("doid %d\n", doid3);

		tsk.exinf = (VP)CH4toW('S','R','V','4');
		tsk.task = test_task4;
		tsk.itskpri = DEFAULT_PRI;
		tsk.stksz = 0x4000;
		tsk.tskatr = TA_HLNG | TA_RNG0;
		TP_Msg("server task entry %s\n", SERVER_NAME_4);

		IPA_LOG_init(IPA_LOG_DYN_GET);
		doid4 = ASRV_entry_dobj(&tsk, SERVER_NAME_4, 10);
		IPA_LOG_init(0);

		TP_CHECK((doid4 < 0), (" "));
		TP_Msg("doid %d\n", doid4);

		ASRV_cancel_dobj_id(doid1);
		ASRV_cancel_dobj_id(doid2);
		ASRV_cancel_dobj_id(doid3);
	}
	TP_INFO(("s230104 OK\n"));
	TP_LINE();

	TP_corba_fini();
	TP_delete_ASRVtsk(ASRV_SERVER_ID);
	return 0;
}




