/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#include "config.h"
#include "tpchk.h"
#include "s2301.h"

static PortableServer_ServantBase__epv base_epv = {
	NULL,
	NULL,
	NULL
};

typedef struct tagPOA_Test__epv {
	void	*_private;
	CORBA_long (*func1)(PortableServer_Servant, CORBA_Environment *);
} POA_Test__epv;

typedef struct POA_Test__vepv {
	void	*_private;
	PortableServer_ServantBase__epv	*_base_epv;
	POA_Test__epv	*Test_epv;
} POA_Test__vepv;

typedef struct tagPOA_Test {
	void		*_private;
	POA_Test__vepv	*vepv;
} POA_Test;

static CORBA_long
taskid_impl(PortableServer_Servant s, CORBA_Environment *e)
{
	ID	id;

	get_tid(&id);
	TP_Msg("Server Task ID : %d\n", id);

	return id;
}

static void
_skl_dispatch_test(PortableServer_Servant servant, GIOP_SrvInf *msg)
{
	CORBA_char		*bufp;
	CORBA_boolean		order;
	CORBA_unsigned_long	size;
	CORBA_Environment	env;

	CORBA_exception_init(&env);

	bufp = GIOP_srv_bcurp(msg);
	order = GIOP_srv_bordr(msg);

	TP_Msg("recv %s\n", GIOP_srv_opnam(msg));
	if (!strcmp(GIOP_srv_opnam(msg), "taskid_func")) {
		CORBA_long	ret;

		ret = ((POA_Test *)servant)->vepv->Test_epv->func1(servant, &env);

		bufp = GIOP_create_repbuf(msg, 0);
		MRSHL_put_long(&bufp, CORBA_NO_EXCEPTION);
		MRSHL_put_long(&bufp, ret);
		size = (CORBA_unsigned_long)(bufp - GIOP_srv_btopp(msg));
		GIOP_send_rep(msg, size);
	} else {
		TP_CHECK((0), (" "));
	}
}

static PortableServer_ServantPrivateInfo test_class = {
	TYPE_ID,
	(void (*)())_skl_dispatch_test
};

static void
POA_Test__init(POA_Test *servant, CORBA_Environment *env)
{
	POA_Test	*test;
	
	test = (POA_Test *)servant;
	((PortableServer_ServantBase *)test)->vepv->_private 
						= (void *)&test_class;
	/*
	PortableServer_ServantBase__init(
		(PortableServer_ServantBase*)servant,
		env
	);
	*/
}

/*
 * ֥ȴǽˤ˵ư륵Х
 */
void
server(CORBA_long number, CORBA_char *srv_name)
{
	int				argc;
	char				*argv;
	CORBA_char			ServerName[100];
	CORBA_Environment		ev;
	CORBA_Object			obj;
	CORBA_sequence_Policy		policy;
	PortableServer_ObjectId		*oid;
	PortableServer_POA		root_poa;
	PortableServer_POA		child_poa;
	PortableServer_POAManager	poa_mgr = NULL;
	POA_Test__epv			test_epv = {NULL, taskid_impl};
	POA_Test__vepv			test_vepv = {NULL, &base_epv, &test_epv};
	POA_Test			test = {NULL, &test_vepv };
	CORBA_ORB			orb;

	TP_Msg("\n===== %s Server Tsk Start =====\n", srv_name);

	CORBA_exception_init(&ev);

	strcpy(ServerName, "ServerName=");
	strcat(ServerName, srv_name);

	argc = 1;
	argv = ServerName;
	orb = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
         * RootPOA롣
         */
	obj = CORBA_ORB_resolve_initial_references(orb, "RootPOA", &ev);
	root_poa = (PortableServer_POA)obj;
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
         * RootPOAȴϢŤ줿POAManager롣
         */
	poa_mgr = PortableServer_POA__get_the_POAManager(root_poa, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
	 * POALifespan PolicyPERSISTENTˤ롣
	 */
	policy._buffer = CORBA_sequence_Policy_allocbuf(1);
	policy._length = 1;
	policy._release = CORBA_FALSE;
	policy._buffer[0] = PortableServer_POA_create_lifespan_policy(
					root_poa, PortableServer_PERSISTENT,
					&ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
	 * POA롣
	 */
	child_poa = PortableServer_POA_create_POA(root_poa, CHILD_POA, 
						  poa_mgr, &policy, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	CORBA_free(policy._buffer);

	POA_Test__init(&test, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
	 * ֥ID
	 */	
	oid = PortableServer_string_to_ObjectId(OBJECT_ID, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	
	/*
         * POA˥ХȤϿ롣
         */
	PortableServer_POA_activate_object_with_id(child_poa, oid, &test, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	CORBA_free(oid);

	/*
         * POAManager˳Υå롣
         * POAManagerϿƤ뤹٤ƤPOA롣
         */
	PortableServer_POAManager_activate(poa_mgr, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
	 * ORBå롼פ롣
         */
	CORBA_ORB_run(orb, &ev);

	/*
	 * POA
         */
	PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
	CORBA_Object_release((CORBA_Object)orb, &ev);

	TP_Msg("\n===== %s Server Tsk Shutdwon =====\n", srv_name);

	exd_tsk();
}


