/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#include "config.h"
#include "tpchk.h"
#include "s2105.h"
#include "_sysdbg.h"
#include "_loging.h"

static int ExcCount;

static CORBA_ORB 	Orb;

static void _skl_dispatch_test(PortableServer_Servant, GIOP_SrvInf *);

static CORBA_int	func_count;

static void
func_impl(PortableServer_Servant s, CORBA_long dat, CORBA_Environment *e)
{
	if (dat == EXCEPTION_SYSTEM) {
		CORBA_exception_set(e, CORBA_SYSTEM_EXCEPTION,
				    Exc[func_count], 0);
	} else if (dat == EXCEPTION_USER) {
		errexc	*err;

		err = errexc__alloc();
		err->code = ERREXC_CODE;
		CORBA_exception_set(e, CORBA_USER_EXCEPTION,
				    ex_errexc, err);
	} else if (dat == SHUTDOWN_CODE) {
		CORBA_ORB_shutdown(Orb, e);
	}

	func_count++;
}

static PortableServer_ServantBase__epv base_epv = {
	NULL,
	NULL,
	NULL
};

typedef struct tagPOA_Test__epv {
	void	*_private;
	void	(*func)(PortableServer_Servant, CORBA_long, CORBA_Environment *);
} POA_Test__epv;

typedef struct POA_Test__vepv {
	void		*_private;
	PortableServer_ServantBase__epv	*_base_epv;
	POA_Test__epv	*Test_epv;
} POA_Test__vepv;

typedef struct tagPOA_Test {
	void		*_private;
	POA_Test__vepv	*vepv;
} POA_Test;

static PortableServer_ServantPrivateInfo test_class = {
	"test",
	(void (*)())_skl_dispatch_test
};

static void
POA_Test__init(POA_Test *servant, CORBA_Environment *env)
{
	POA_Test	*test;
	
	test = (POA_Test *)servant;
	((PortableServer_ServantBase *)test)->vepv->_private 
						= (void *)&test_class;
	/*
	PortableServer_ServantBase__init(
		(PortableServer_ServantBase*)servant,
		env
	);
	*/
}

void
task(void)
{
	int				argc = 0;
	char				*argv = "";
	CORBA_Environment		ev;
	CORBA_Object			obj;
	PortableServer_ObjectId		*oid;
	PortableServer_POA		root_poa;
	PortableServer_POAManager	poa_mgr = NULL;
	POA_Test__epv			test_epv = {NULL, func_impl};
	POA_Test__vepv			test_vepv = {NULL, &base_epv, &test_epv};
	POA_Test			test = {NULL, &test_vepv };
	CORBA_char			*str;

	func_count = 0;

	TP_START();
	IPA_LOG_init(0);

	CORBA_exception_init(&ev);

	Orb = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
         * RootPOA롣
         */
	obj = CORBA_ORB_resolve_initial_references(Orb, "RootPOA", &ev);
	root_poa = (PortableServer_POA)obj;
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
         * RootPOAȴϢŤ줿POAManager롣
         */
	poa_mgr = PortableServer_POA__get_the_POAManager(root_poa, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	POA_Test__init(&test, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	
	oid = PortableServer_string_to_ObjectId("test", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	
	/*
         * POA˥Х(bank_account)Ͽ롣
         */
	PortableServer_POA_activate_object_with_id(root_poa, oid, &test, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
         * POAManager˳Υå롣
         * POAManagerϿƤ뤹٤ƤPOA롣
         */
	PortableServer_POAManager_activate(poa_mgr, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
	 * ХȤ饪֥ȥե󥹤κ
         */
        obj = PortableServer_POA_servant_to_reference(root_poa, &test, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	
	/*
	 * ֥ȥե󥹤ʸѴ
         */
	str = CORBA_ORB_object_to_string(Orb, obj, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
	 * ֥ȥե󥹤
         * 饤ȤذϤ
         */
	TP_IOR_send(IOR_RECV_PORT, str);


	
	/*
	 * ORBå롼פ롣
         */
	TP_Msg("\n----- Server Tsk Wait Loop Start -----\n");
	CORBA_ORB_run(Orb, &ev);
	TP_Msg("\n----- Server Tsk Wait Loop End -----\n");

	/*
	 * POA
         */
	PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
	CORBA_Object_release((CORBA_Object)Orb, &ev);

	TP_END();
}

static void
_skl_dispatch_test(PortableServer_Servant servant, GIOP_SrvInf *msg)
{
	CORBA_Environment	ev;
	CORBA_char		*bufp;
	CORBA_boolean		order;

	TP_Msg("\n_skl_dispatch_test\n");
	CORBA_exception_init(&ev);

	bufp = GIOP_srv_bcurp(msg);
	order = GIOP_srv_bordr(msg);

	printf("operation %s\n", GIOP_srv_opnam(msg));
	if (!strcmp(GIOP_srv_opnam(msg), "func")) {
		CORBA_long		dat;
		CORBA_unsigned_long	size;

		dat = MRSHL_get_long(&bufp, order);
		((POA_Test *)servant)->vepv->Test_epv->func(servant, dat, &ev);
		if (ev._major == CORBA_SYSTEM_EXCEPTION) {

			TP_Msg("_major : %d\n", ev._major);
			TP_Msg("_id : %s\n", ev._id);
			TP_Msg("_completed : %d\n", CORBA_COMPLETED_YES);

			IPA_LOG_init(IPA_LOG_EXCSEND);
			GIOP_send_repexc(msg, ev._id, CORBA_COMPLETED_YES);
			IPA_LOG_init(0);

			TP_INFO(("s210602 END\n"));
			TP_INFO(("s210603 END\n"));
			TP_LINE();

			CORBA_exception_free(&ev);
			return;
		} else if (ev._major == CORBA_USER_EXCEPTION) {
			if (!strcmp(ev._id, ex_errexc)) {
				errexc	*err;

				size = 0;
				size = MRSHL_index_long(size);
				bufp = GIOP_create_repbuf(msg, size);
				if (!bufp) {
					GIOP_send_repexc(msg,
							 CORBA_Ex_NO_MEMORY,
							 CORBA_COMPLETED_YES);
					CORBA_exception_free(&ev);
					return;
				}
				MRSHL_put_long(&bufp, CORBA_USER_EXCEPTION);
				err = (errexc *)ev._params;
				MRSHL_put_long(&bufp, err->code);
				size = (CORBA_unsigned_long)(bufp - GIOP_srv_btopp(msg));

				TP_Msg("_major : %d\n", ev._major);
				TP_Msg("_id : %s\n", ex_errexc);
				TP_Msg("err->code : %d\n", err->code);

				IPA_LOG_init(IPA_LOG_GIOP);
				GIOP_send_rep(msg, size);
				IPA_LOG_init(0);

				TP_INFO(("s210604 END\n"));
				TP_INFO(("s210605 END\n"));
				TP_LINE();

				ExcCount++;

				CORBA_exception_free(&ev);
				return;
			}
		}

		size = 0;
		bufp = GIOP_create_repbuf(msg, size);
		if (!bufp) {
			TP_LINE();
			IPA_LOG_init(IPA_LOG_EXCSEND);

			GIOP_send_repexc(msg, CORBA_Ex_NO_MEMORY,
					 CORBA_COMPLETED_YES);

			IPA_LOG_init(0);
			TP_LINE();
			return;
		}
		TP_LINE();

		MRSHL_put_long(&bufp, CORBA_NO_EXCEPTION);
		size = (CORBA_unsigned_long)(bufp - GIOP_srv_btopp(msg));

		TP_Msg("_major : %d\n", ev._major);

		IPA_LOG_init(IPA_LOG_GIOP);
		GIOP_send_rep(msg, size);
		IPA_LOG_init(0);

		TP_INFO(("s210601 END\n"));
		TP_LINE();
	} else {
		GIOP_send_repexc(msg, CORBA_Ex_BAD_OPERATION,
				 CORBA_COMPLETED_NO);
	}
}

#ifdef	CORBA_UNIX

int
main(void)
{
	MAIN_START();	

	TP_corba_init();
	SYS_init_debug(0);

	task();

	MAIN_END();	
	TP_corba_fini();
	return 0;
}

#else	/* CORBA_UNIX */

ERR
main(Bool Startup, TC *arg)
{
	MAIN_START();	

	TP_corba_init();
	SYS_init_debug(0);
	IPA_LOG_init(0);

	ExcCount = 1;

	TP_CreateTask(task, DEFAULT_PRI);

	MAIN_END();
	TP_corba_fini();
	return 0;
}

#endif	/* CORBA_UNIX */
