/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#ifndef CORBA_UNIX

#include <basic.h>
#include <bstring.h>
#include <tstring.h>
#include <inner.h>
#include <driver/driver.h>
#include <kernel/util.h>
#include <errcode.h>
#include <bstdio.h>

#else	/* CORBA_UNIX */

#include <string.h>

typedef int PRI;
typedef int ID;
typedef void (*FP)();
typedef struct {
        int     dmy;
} T_CTSK;

#endif	/* CORBA_UNIX */

#include <corba.h>

typedef struct {
	CORBA_char	char_dat;
	CORBA_short	short_dat;
	CORBA_long	long_dat;
	CORBA_long_long	long_long_dat;
	CORBA_float	float_dat;
	CORBA_double	double_dat;
} test_struct;
test_struct * test_struct__alloc(void);

#define C_ARRAY_SIZE	(10)
typedef CORBA_char test_Carray[C_ARRAY_SIZE];
typedef CORBA_char test_Carray_slice;
test_Carray_slice * test_Carray__alloc(void);

#define S_ARRAY_SIZE	(10)
typedef CORBA_short test_Sarray[S_ARRAY_SIZE];
typedef CORBA_short test_Sarray_slice;
test_Sarray_slice * test_Sarray__alloc(void);

#define L_ARRAY_SIZE	(10)
typedef CORBA_long test_Larray[L_ARRAY_SIZE];
typedef CORBA_long test_Larray_slice;
test_Larray_slice * test_Larray__alloc(void);

#define LL_ARRAY_SIZE	(10)
typedef CORBA_long_long test_LLarray[LL_ARRAY_SIZE];
typedef CORBA_long_long test_LLarray_slice;
test_LLarray_slice * test_LLarray__alloc(void);

#define F_ARRAY_SIZE	(10)
typedef CORBA_float test_Farray[F_ARRAY_SIZE];
typedef CORBA_float test_Farray_slice;
test_Farray_slice * test_Farray__alloc(void);

#define D_ARRAY_SIZE	(10)
typedef CORBA_double test_Darray[D_ARRAY_SIZE];
typedef CORBA_double test_Darray_slice;
test_Darray_slice * test_Darray__alloc(void);

CORBA_char		test_func_char(CORBA_Object, CORBA_char, CORBA_Environment *);
CORBA_short		test_func_short(CORBA_Object, CORBA_short, CORBA_Environment *);
CORBA_long		test_func_long(CORBA_Object, CORBA_long, CORBA_Environment *);
CORBA_long_long		test_func_long_long(CORBA_Object, CORBA_long_long, CORBA_Environment *);
CORBA_float		test_func_float(CORBA_Object, CORBA_float, CORBA_Environment *);
CORBA_double		test_func_double(CORBA_Object, CORBA_double, CORBA_Environment *);
CORBA_char		*test_func_string(CORBA_Object, CORBA_char *, CORBA_Environment *);
test_Carray_slice	*test_func_Carray(CORBA_Object, test_Carray, CORBA_Environment *);
test_Sarray_slice	*test_func_Sarray(CORBA_Object, test_Sarray, CORBA_Environment *);
test_Larray_slice	*test_func_Larray(CORBA_Object, test_Larray, CORBA_Environment *);
test_LLarray_slice	*test_func_LLarray(CORBA_Object, test_LLarray, CORBA_Environment *);
test_Farray_slice	*test_func_Farray(CORBA_Object, test_Farray, CORBA_Environment *);
test_Darray_slice	*test_func_Darray(CORBA_Object, test_Darray, CORBA_Environment *);
test_struct		*test_func_struct(CORBA_Object, test_struct *, CORBA_Environment *);

void _skl_dispatch_test(PortableServer_Servant, GIOP_SrvInf *);

CORBA_char		func_char_impl(PortableServer_Servant, const CORBA_char, CORBA_Environment *);
CORBA_short		func_short_impl(PortableServer_Servant, const CORBA_short, CORBA_Environment *);
CORBA_long		func_long_impl(PortableServer_Servant, const CORBA_long, CORBA_Environment *);
CORBA_long_long		func_long_long_impl(PortableServer_Servant, const CORBA_long_long, CORBA_Environment *);
CORBA_float		func_float_impl(PortableServer_Servant, const CORBA_float, CORBA_Environment *);
CORBA_double		func_double_impl(PortableServer_Servant, const CORBA_double, CORBA_Environment *);
CORBA_char		*func_string_impl(PortableServer_Servant, const CORBA_char *, CORBA_Environment *);
test_Carray_slice	*func_Carray_impl(PortableServer_Servant, const test_Carray, CORBA_Environment *);
test_Sarray_slice	*func_Sarray_impl(PortableServer_Servant, const test_Sarray, CORBA_Environment *);
test_Larray_slice	*func_Larray_impl(PortableServer_Servant, const test_Larray, CORBA_Environment *);
test_LLarray_slice	*func_LLarray_impl(PortableServer_Servant, const test_LLarray, CORBA_Environment *);
test_Farray_slice	*func_Farray_impl(PortableServer_Servant, const test_Farray, CORBA_Environment *);
test_Darray_slice	*func_Darray_impl(PortableServer_Servant, const test_Darray, CORBA_Environment *);
test_struct		*func_struct_impl(PortableServer_Servant, const test_struct *, CORBA_Environment *);

typedef struct tagPOA_Test__epv {
	void	*_private;
	CORBA_char (*func_char)(PortableServer_Servant, CORBA_char, CORBA_Environment *);
	CORBA_short (*func_short)(PortableServer_Servant, CORBA_short, CORBA_Environment *);
	CORBA_long (*func_long)(PortableServer_Servant, CORBA_long, CORBA_Environment *);
	CORBA_long_long (*func_long_long)(PortableServer_Servant, CORBA_long_long, CORBA_Environment *);
	CORBA_float (*func_float)(PortableServer_Servant, CORBA_float, CORBA_Environment *);
	CORBA_double (*func_double)(PortableServer_Servant, CORBA_double, CORBA_Environment *);
	CORBA_char *(*func_string)(PortableServer_Servant, CORBA_char *, CORBA_Environment *);
	test_Carray_slice *(*func_Carray)(PortableServer_Servant, test_Carray, CORBA_Environment *);
	test_Sarray_slice *(*func_Sarray)(PortableServer_Servant, test_Sarray, CORBA_Environment *);
	test_Larray_slice *(*func_Larray)(PortableServer_Servant, test_Larray, CORBA_Environment *);
	test_LLarray_slice *(*func_LLarray)(PortableServer_Servant, test_LLarray, CORBA_Environment *);
	test_Farray_slice *(*func_Farray)(PortableServer_Servant, test_Farray, CORBA_Environment *);
	test_Darray_slice *(*func_Darray)(PortableServer_Servant, test_Darray, CORBA_Environment *);
	test_struct *(*func_struct)(PortableServer_Servant, const test_struct *, CORBA_Environment *);
} POA_Test__epv;

typedef struct POA_Test__vepv {
	void	*_private;
	PortableServer_ServantBase__epv	*_base_epv;
	POA_Test__epv	*Test_epv;
} POA_Test__vepv;

typedef struct tagPOA_Test {
	void	*_private;
	POA_Test__vepv	*vepv;
} POA_Test;

void POA_Test__init(POA_Test *, CORBA_Environment *);
void POA_Test__fini(POA_Test *, CORBA_Environment *);

typedef CORBA_Object Test;




