/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#include "s2104.h"

CORBA_char
test_func_char(CORBA_Object obj, CORBA_char dat, CORBA_Environment *env)
{
	CORBA_char		*topp;
	CORBA_char		*bufp;
	CORBA_boolean		order;
	CORBA_char		ret;
	CORBA_unsigned_long	size;
	GIOP_CliInf		cliinf;

	ret = 0;
	GIOP_init_cli(&cliinf);

	do {
		size = 0;
		size = MRSHL_index_char(size);
		topp = GIOP_create_reqbuf(obj, &cliinf, size, CORBA_TRUE,
				       "func_char", env);
		if (env->_major != CORBA_NO_EXCEPTION) {
			break;
		}
		bufp = topp;
		MRSHL_put_char(&bufp, dat);
		size = bufp - topp;
		topp = GIOP_invoke_req(obj, &cliinf, size, env);
	} while (env->_flag == ENVFLG_LOCATION_FORWARD);

	bufp = topp;
	order = GIOP_cli_bordr(&cliinf);
	switch(env->_major) {
	case CORBA_NO_EXCEPTION:
		ret = MRSHL_get_char(&bufp, order);
		break;
	case CORBA_SYSTEM_EXCEPTION:
		break;
	case CORBA_USER_EXCEPTION:
		break;
	default:
		break;
	}

	GIOP_end_cli(&cliinf);
	return ret;
}

CORBA_short
test_func_short(CORBA_Object obj, CORBA_short dat, CORBA_Environment *env)
{
	CORBA_char		*topp;
	CORBA_char		*bufp;
	CORBA_boolean		order;
	CORBA_short		ret;
	CORBA_unsigned_long	size;
	GIOP_CliInf		cliinf;

	ret = 0;
	GIOP_init_cli(&cliinf);

	do {
		size = 0;
		size = MRSHL_index_short(size);
		topp = GIOP_create_reqbuf(obj, &cliinf, size, CORBA_TRUE,
				       "func_short", env);
		if (env->_major != CORBA_NO_EXCEPTION) {
			break;
		}
		bufp = topp;
		MRSHL_put_short(&bufp, dat);
		size = bufp - topp;
		topp = GIOP_invoke_req(obj, &cliinf, size, env);
	} while (env->_flag == ENVFLG_LOCATION_FORWARD);

	bufp = topp;
	order = GIOP_cli_bordr(&cliinf);
	switch(env->_major) {
	case CORBA_NO_EXCEPTION:
		ret = MRSHL_get_short(&bufp, order);
		break;
	case CORBA_SYSTEM_EXCEPTION:
		break;
	case CORBA_USER_EXCEPTION:
		break;
	default:
		break;
	}

	GIOP_end_cli(&cliinf);
	return ret;
}

CORBA_long
test_func_long(CORBA_Object obj, CORBA_long dat, CORBA_Environment *env)
{
	CORBA_char		*topp;
	CORBA_char		*bufp;
	CORBA_boolean		order;
	CORBA_long		ret;
	CORBA_unsigned_long	size;
	GIOP_CliInf		cliinf;

	ret = 0;
	GIOP_init_cli(&cliinf);

	do {
		size = 0;
		size = MRSHL_index_long(size);
		topp = GIOP_create_reqbuf(obj, &cliinf, size, CORBA_TRUE,
				       "func_long", env);
		if (env->_major != CORBA_NO_EXCEPTION) {
			break;
		}
		bufp = topp;
		MRSHL_put_long(&bufp, dat);
		size = bufp - topp;
		topp = GIOP_invoke_req(obj, &cliinf, size, env);
	} while (env->_flag == ENVFLG_LOCATION_FORWARD);

	bufp = topp;
	order = GIOP_cli_bordr(&cliinf);
	switch(env->_major) {
	case CORBA_NO_EXCEPTION:
		ret = MRSHL_get_long(&bufp, order);
		break;
	case CORBA_SYSTEM_EXCEPTION:
		break;
	case CORBA_USER_EXCEPTION:
		break;
	default:
		break;
	}

	GIOP_end_cli(&cliinf);
	return ret;
}

CORBA_long_long
test_func_long_long(CORBA_Object obj, CORBA_long_long dat, CORBA_Environment *env)
{
	CORBA_char		*topp;
	CORBA_char		*bufp;
	CORBA_boolean		order;
	CORBA_long_long		ret;
	CORBA_unsigned_long	size;
	GIOP_CliInf		cliinf;

	ret = 0;
	GIOP_init_cli(&cliinf);

	do {
		size = 0;
		size = MRSHL_index_long_long(size);
		topp = GIOP_create_reqbuf(obj, &cliinf, size, CORBA_TRUE,
				       "func_long_long", env);
		if (env->_major != CORBA_NO_EXCEPTION) {
			break;
		}
		bufp = topp;
		MRSHL_put_long_long(&bufp, dat);
		size = bufp - topp;
		topp = GIOP_invoke_req(obj, &cliinf, size, env);
	} while (env->_flag == ENVFLG_LOCATION_FORWARD);

	bufp = topp;
	order = GIOP_cli_bordr(&cliinf);
	switch(env->_major) {
	case CORBA_NO_EXCEPTION:
		ret = MRSHL_get_long_long(&bufp, order);
		break;
	case CORBA_SYSTEM_EXCEPTION:
		break;
	case CORBA_USER_EXCEPTION:
		break;
	default:
		break;
	}

	GIOP_end_cli(&cliinf);
	return ret;
}


CORBA_float
test_func_float(CORBA_Object obj, CORBA_float dat, CORBA_Environment *env)
{
	CORBA_char		*topp;
	CORBA_char		*bufp;
	CORBA_boolean		order;
	CORBA_float		ret;
	CORBA_unsigned_long	size;
	GIOP_CliInf		cliinf;

	ret = 0;
	GIOP_init_cli(&cliinf);

	do {
		size = 0;
		size = MRSHL_index_float(size);
		topp = GIOP_create_reqbuf(obj, &cliinf, size, CORBA_TRUE,
				       "func_float", env);
		if (env->_major != CORBA_NO_EXCEPTION) {
			break;
		}
		bufp = topp;
		MRSHL_put_float(&bufp, dat);
		size = bufp - topp;
		topp = GIOP_invoke_req(obj, &cliinf, size, env);
	} while (env->_flag == ENVFLG_LOCATION_FORWARD);

	bufp = topp;
	order = GIOP_cli_bordr(&cliinf);
	switch(env->_major) {
	case CORBA_NO_EXCEPTION:
		ret = MRSHL_get_float(&bufp, order);
		break;
	case CORBA_SYSTEM_EXCEPTION:
		break;
	case CORBA_USER_EXCEPTION:
		break;
	default:
		break;
	}

	GIOP_end_cli(&cliinf);
	return ret;
}

CORBA_double
test_func_double(CORBA_Object obj, CORBA_double dat, CORBA_Environment *env)
{
	CORBA_char		*topp;
	CORBA_char		*bufp;
	CORBA_boolean		order;
	CORBA_double		ret;
	CORBA_unsigned_long	size;
	GIOP_CliInf		cliinf;

	ret = 0;
	GIOP_init_cli(&cliinf);

	do {
		size = 0;
		size = MRSHL_index_double(size);
		topp = GIOP_create_reqbuf(obj, &cliinf, size, CORBA_TRUE,
				       "func_double", env);
		if (env->_major != CORBA_NO_EXCEPTION) {
			break;
		}
		bufp = topp;
		MRSHL_put_double(&bufp, dat);
		size = bufp - topp;
		topp = GIOP_invoke_req(obj, &cliinf, size, env);
	} while (env->_flag == ENVFLG_LOCATION_FORWARD);

	bufp = topp;
	order = GIOP_cli_bordr(&cliinf);
	switch(env->_major) {
	case CORBA_NO_EXCEPTION:
		ret = MRSHL_get_double(&bufp, order);
		break;
	case CORBA_SYSTEM_EXCEPTION:
		break;
	case CORBA_USER_EXCEPTION:
		break;
	default:
		break;
	}

	GIOP_end_cli(&cliinf);
	return ret;
}

CORBA_char *
test_func_string(CORBA_Object obj, CORBA_char *dat, CORBA_Environment *env)
{
	CORBA_char		*topp;
	CORBA_char		*bufp;
	CORBA_boolean		order;
	CORBA_char		*ret;
	CORBA_unsigned_long	size;
	GIOP_CliInf		cliinf;

	ret = 0;
	GIOP_init_cli(&cliinf);

	do {
		size = 0;
		size = MRSHL_index_string(size, dat);
		topp = GIOP_create_reqbuf(obj, &cliinf, size, CORBA_TRUE,
				       "func_string", env);
		if (env->_major != CORBA_NO_EXCEPTION) {
			break;
		}
		bufp = topp;
		MRSHL_put_string(&bufp, dat);
		size = bufp - topp;
		topp = GIOP_invoke_req(obj, &cliinf, size, env);
	} while (env->_flag == ENVFLG_LOCATION_FORWARD);


	bufp = topp;
	order = GIOP_cli_bordr(&cliinf);
	switch(env->_major) {
	case CORBA_NO_EXCEPTION:
		ret = MRSHL_get_string(&bufp, order);
		break;
	case CORBA_SYSTEM_EXCEPTION:
		break;
	case CORBA_USER_EXCEPTION:
		break;
	default:
		break;
	}

	GIOP_end_cli(&cliinf);
	return ret;
}

test_Carray_slice *
test_func_Carray(CORBA_Object obj, test_Carray dat, CORBA_Environment *env)
{
	CORBA_char		*topp;
	CORBA_char		*bufp;
	CORBA_boolean		order;
	CORBA_long		i;
	test_Carray_slice	*ret = 0;
	CORBA_unsigned_long	size;
	GIOP_CliInf		cliinf;

	GIOP_init_cli(&cliinf);

	do {
		size = (CORBA_unsigned_long)sizeof(test_Carray);
		topp = GIOP_create_reqbuf(obj, &cliinf, size, CORBA_TRUE, "func_Carray", env);
		if (env->_major != CORBA_NO_EXCEPTION) {
			break;
		}
		bufp = topp;

		MRSHL_bcopy(&bufp, dat, (CORBA_unsigned_long)sizeof(CORBA_char), (CORBA_unsigned_long)sizeof(test_Carray));

		size = bufp - topp;
		topp = GIOP_invoke_req(obj, &cliinf, size, env);
	} while (env->_flag == ENVFLG_LOCATION_FORWARD);

	bufp = topp;
	order = GIOP_cli_bordr(&cliinf);
	switch(env->_major) {
	case CORBA_NO_EXCEPTION:
		ret = test_Carray__alloc();
		for (i = 0; i < 10; i++) {
			ret[i] = MRSHL_get_char(&bufp, order);
		}
		break;
	case CORBA_SYSTEM_EXCEPTION:
		break;
	case CORBA_USER_EXCEPTION:
		break;
	default:
		break;
	}

	GIOP_end_cli(&cliinf);
	return ret;
}

test_Sarray_slice *
test_func_Sarray(CORBA_Object obj, test_Sarray dat, CORBA_Environment *env)
{
	CORBA_char		*topp;
	CORBA_char		*bufp;
	CORBA_boolean		order;
	CORBA_long		i;
	test_Sarray_slice	*ret = 0;
	CORBA_unsigned_long	size;
	GIOP_CliInf		cliinf;

	GIOP_init_cli(&cliinf);

	do {
		size = (CORBA_unsigned_long)sizeof(test_Sarray);
		topp = GIOP_create_reqbuf(obj, &cliinf, size, CORBA_TRUE, "func_Sarray", env);
		if (env->_major != CORBA_NO_EXCEPTION) {
			break;
		}
		bufp = topp;

		MRSHL_bcopy(&bufp, (CORBA_char *)dat, (CORBA_unsigned_long)sizeof(CORBA_short), (CORBA_unsigned_long)sizeof(test_Sarray));

		size = bufp - topp;
		topp = GIOP_invoke_req(obj, &cliinf, size, env);
	} while (env->_flag == ENVFLG_LOCATION_FORWARD);

	bufp = topp;
	order = GIOP_cli_bordr(&cliinf);
	switch(env->_major) {
	case CORBA_NO_EXCEPTION:
		ret = test_Sarray__alloc();
		for (i = 0; i < 10; i++) {
			ret[i] = MRSHL_get_short(&bufp, order);
		}
		break;
	case CORBA_SYSTEM_EXCEPTION:
		break;
	case CORBA_USER_EXCEPTION:
		break;
	default:
		break;
	}

	GIOP_end_cli(&cliinf);
	return ret;
}

test_Larray_slice *
test_func_Larray(CORBA_Object obj, test_Larray dat, CORBA_Environment *env)
{
	CORBA_char		*topp;
	CORBA_char		*bufp;
	CORBA_boolean		order;
	CORBA_long		i;
	test_Larray_slice	*ret = 0;
	CORBA_unsigned_long	size;
	GIOP_CliInf		cliinf;

	GIOP_init_cli(&cliinf);

	do {
		size = (CORBA_unsigned_long)sizeof(test_Larray);
		topp = GIOP_create_reqbuf(obj, &cliinf, size, CORBA_TRUE, "func_Larray", env);
		if (env->_major != CORBA_NO_EXCEPTION) {
			break;
		}
		bufp = topp;

		MRSHL_bcopy(&bufp, (CORBA_char *)dat, (CORBA_unsigned_long)sizeof(CORBA_long), (CORBA_unsigned_long)sizeof(test_Larray));

		size = bufp - topp;
		topp = GIOP_invoke_req(obj, &cliinf, size, env);
	} while (env->_flag == ENVFLG_LOCATION_FORWARD);

	bufp = topp;
	order = GIOP_cli_bordr(&cliinf);
	switch(env->_major) {
	case CORBA_NO_EXCEPTION:
		ret = test_Larray__alloc();
		for (i = 0; i < 10; i++) {
			ret[i] = MRSHL_get_long(&bufp, order);
		}
		break;
	case CORBA_SYSTEM_EXCEPTION:
		break;
	case CORBA_USER_EXCEPTION:
		break;
	default:
		break;
	}

	GIOP_end_cli(&cliinf);
	return ret;
}

test_LLarray_slice *
test_func_LLarray(CORBA_Object obj, test_LLarray dat, CORBA_Environment *env)
{
	CORBA_char		*topp;
	CORBA_char		*bufp;
	CORBA_boolean		order;
	CORBA_long		i;
	test_LLarray_slice	*ret = 0;
	CORBA_unsigned_long	size;
	GIOP_CliInf		cliinf;

	GIOP_init_cli(&cliinf);

	do {
		size = (CORBA_unsigned_long)sizeof(test_LLarray);
		topp = GIOP_create_reqbuf(obj, &cliinf, size, CORBA_TRUE, "func_LLarray", env);
		if (env->_major != CORBA_NO_EXCEPTION) {
			break;
		}
		bufp = topp;

		MRSHL_bcopy(&bufp, (CORBA_char *)dat, (CORBA_unsigned_long)sizeof(CORBA_long_long), (CORBA_unsigned_long)sizeof(test_LLarray));

		size = bufp - topp;
		topp = GIOP_invoke_req(obj, &cliinf, size, env);
	} while (env->_flag == ENVFLG_LOCATION_FORWARD);

	bufp = topp;
	order = GIOP_cli_bordr(&cliinf);
	switch(env->_major) {
	case CORBA_NO_EXCEPTION:
		ret = test_LLarray__alloc();
		for (i = 0; i < 10; i++) {
			ret[i] = MRSHL_get_long_long(&bufp, order);
		}
		break;
	case CORBA_SYSTEM_EXCEPTION:
		break;
	case CORBA_USER_EXCEPTION:
		break;
	default:
		break;
	}

	GIOP_end_cli(&cliinf);
	return ret;
}

test_Farray_slice *
test_func_Farray(CORBA_Object obj, test_Farray dat, CORBA_Environment *env)
{
	CORBA_char		*topp;
	CORBA_char		*bufp;
	CORBA_boolean		order;
	CORBA_long		i;
	test_Farray_slice	*ret = 0;
	CORBA_unsigned_long	size;
	GIOP_CliInf		cliinf;

	GIOP_init_cli(&cliinf);

	do {
		size = (CORBA_unsigned_long)sizeof(test_Farray);
		topp = GIOP_create_reqbuf(obj, &cliinf, size, CORBA_TRUE, "func_Farray", env);
		if (env->_major != CORBA_NO_EXCEPTION) {
			break;
		}
		bufp = topp;

		MRSHL_bcopy(&bufp, (CORBA_char *)dat, (CORBA_unsigned_long)sizeof(CORBA_float), (CORBA_unsigned_long)sizeof(test_Farray));

		size = bufp - topp;
		topp = GIOP_invoke_req(obj, &cliinf, size, env);
	} while (env->_flag == ENVFLG_LOCATION_FORWARD);

	bufp = topp;
	order = GIOP_cli_bordr(&cliinf);
	switch(env->_major) {
	case CORBA_NO_EXCEPTION:
		ret = test_Farray__alloc();
		for (i = 0; i < 10; i++) {
			ret[i] = MRSHL_get_float(&bufp, order);
		}
		break;
	case CORBA_SYSTEM_EXCEPTION:
		break;
	case CORBA_USER_EXCEPTION:
		break;
	default:
		break;
	}

	GIOP_end_cli(&cliinf);
	return ret;
}

test_Darray_slice *
test_func_Darray(CORBA_Object obj, test_Darray dat, CORBA_Environment *env)
{
	CORBA_char		*topp;
	CORBA_char		*bufp;
	CORBA_boolean		order;
	CORBA_long		i;
	test_Darray_slice	*ret = 0;
	CORBA_unsigned_long	size;
	GIOP_CliInf		cliinf;

	GIOP_init_cli(&cliinf);

	do {
		size = (CORBA_unsigned_long)sizeof(test_Darray);
		topp = GIOP_create_reqbuf(obj, &cliinf, size, CORBA_TRUE, "func_Darray", env);
		if (env->_major != CORBA_NO_EXCEPTION) {
			break;
		}
		bufp = topp;

		MRSHL_bcopy(&bufp, (CORBA_char *)dat, (CORBA_unsigned_long)sizeof(CORBA_double), (CORBA_unsigned_long)sizeof(test_Darray));

		size = bufp - topp;
		topp = GIOP_invoke_req(obj, &cliinf, size, env);
	} while (env->_flag == ENVFLG_LOCATION_FORWARD);

	bufp = topp;
	order = GIOP_cli_bordr(&cliinf);
	switch(env->_major) {
	case CORBA_NO_EXCEPTION:
		ret = test_Darray__alloc();
		for (i = 0; i < 10; i++) {
			ret[i] = MRSHL_get_double(&bufp, order);
		}
		break;
	case CORBA_SYSTEM_EXCEPTION:
		break;
	case CORBA_USER_EXCEPTION:
		break;
	default:
		break;
	}

	GIOP_end_cli(&cliinf);
	return ret;
}

test_struct *
test_func_struct(CORBA_Object obj, test_struct *dat, CORBA_Environment *env)
{
	CORBA_char		*topp;
	CORBA_char		*bufp;
	CORBA_boolean		order;
	test_struct		*ret = 0;
	CORBA_unsigned_long	size;
	GIOP_CliInf		cliinf;

	GIOP_init_cli(&cliinf);

	do {
		size = 0;
		size = MRSHL_index_char(size);
		size = MRSHL_index_short(size);
		size = MRSHL_index_long(size);
		size = MRSHL_index_long_long(size);
		size = MRSHL_index_float(size);
		size = MRSHL_index_double(size);
		topp = GIOP_create_reqbuf(obj, &cliinf, size, CORBA_TRUE, "func_struct", env);
		if (env->_major != CORBA_NO_EXCEPTION) {
			break;
		}
		bufp = topp;

		MRSHL_put_char(&bufp, dat->char_dat);
		MRSHL_put_short(&bufp, dat->short_dat);
		MRSHL_put_long(&bufp, dat->long_dat);
		MRSHL_put_long_long(&bufp, dat->long_long_dat);
		MRSHL_put_float(&bufp, dat->float_dat);
		MRSHL_put_double(&bufp, dat->double_dat);

		size = bufp - topp;
		topp = GIOP_invoke_req(obj, &cliinf, size, env);
	} while (env->_flag == ENVFLG_LOCATION_FORWARD);

	bufp = topp;
	order = GIOP_cli_bordr(&cliinf);
	switch(env->_major) {
	case CORBA_NO_EXCEPTION:
		ret = test_struct__alloc();
		ret->char_dat = MRSHL_get_char(&bufp, order);
		ret->short_dat = MRSHL_get_short(&bufp, order);
		ret->long_dat = MRSHL_get_long(&bufp, order);
		ret->long_long_dat = MRSHL_get_long_long(&bufp, order);
		ret->float_dat = MRSHL_get_float(&bufp, order);
		ret->double_dat = MRSHL_get_double(&bufp, order);
		break;
	case CORBA_SYSTEM_EXCEPTION:
		break;
	case CORBA_USER_EXCEPTION:
		break;
	default:
		break;
	}

	GIOP_end_cli(&cliinf);
	return ret;
}
