/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#include "s2104.h"
#include "s2104dat.h"
#include "config.h"
#include "corba.h"
#include "_sysdbg.h"	/* ### for logging message */
#include "_loging.h"

typedef struct tagQeqCount {
	CORBA_int	char_cnt;
	CORBA_int	short_cnt;
	CORBA_int	long_cnt;
	CORBA_int	long_long_cnt;
	CORBA_int	float_cnt;
	CORBA_int	double_cnt;
	CORBA_int	string_cnt;
	CORBA_int	char_array_cnt;
	CORBA_int	short_array_cnt;
	CORBA_int	long_array_cnt;
	CORBA_int	long_long_array_cnt;
	CORBA_int	float_array_cnt;
	CORBA_int	double_array_cnt;
	CORBA_int	struct_cnt;
} ReqCount;

ReqCount RequestCount;

CORBA_char
func_char_impl(PortableServer_Servant servant, const CORBA_char test,
	  CORBA_Environment *ev)
{
	CORBA_int	cnt;
	ReqCount *reqcnt = (ReqCount *)((POA_Test *)servant)->_private;

	cnt = reqcnt->char_cnt;
	reqcnt->char_cnt++;

	TP_CHECK((test == char_chkdat[cnt]), (" "));
	printf("func_char_impl arg %d ret %d\n",
	       (CORBA_int)test, (CORBA_int)test + 1);
	return test + 1;
}

CORBA_short
func_short_impl(PortableServer_Servant servant, const CORBA_short test,
	  CORBA_Environment *ev)
{
	CORBA_int	cnt;
	ReqCount *reqcnt = (ReqCount *)((POA_Test *)servant)->_private;

	cnt = reqcnt->short_cnt;
	reqcnt->short_cnt++;

	TP_CHECK((test == short_chkdat[cnt]), (" "));
	printf("func_short_impl arg %d ret %d\n",
	       (CORBA_int)test, (CORBA_int)test + 1);
	return test + 1;
}

CORBA_long
func_long_impl(PortableServer_Servant servant, const CORBA_long test,
	  CORBA_Environment *ev)
{
	CORBA_int	cnt;
	ReqCount *reqcnt = (ReqCount *)((POA_Test *)servant)->_private;

	cnt = reqcnt->long_cnt;
	reqcnt->long_cnt++;

	TP_CHECK((test == long_chkdat[cnt]), (" "));
	printf("func_long_impl arg %d ret %d\n",
	       (CORBA_int)test, (CORBA_int)test + 1);
	return test + 1;
}

CORBA_long_long
func_long_long_impl(PortableServer_Servant servant, const CORBA_long_long test,
	  CORBA_Environment *ev)
{
	CORBA_int	cnt;
	ReqCount *reqcnt = (ReqCount *)((POA_Test *)servant)->_private;

	cnt = reqcnt->long_long_cnt;
	reqcnt->long_long_cnt++;

	TP_CHECK((test == long_long_chkdat[cnt]), (" "));
	printf("func_long_long_impl arg %d\n", (CORBA_int)test);
	printf("func_long_long_impl ret %d\n", (CORBA_int)test + 1);
	return test + 1;
}

CORBA_float
func_float_impl(PortableServer_Servant servant, const CORBA_float test,
	  CORBA_Environment *ev)
{
	CORBA_int	cnt;
	ReqCount *reqcnt = (ReqCount *)((POA_Test *)servant)->_private;

	cnt = reqcnt->float_cnt;
	reqcnt->float_cnt++;

	TP_CHECK((test == float_chkdat[cnt]), (" "));
	printf("func_float_impl arg %f ret %f\n",
	       test, test + 1.0);
	return test + 1;
}

CORBA_double
func_double_impl(PortableServer_Servant servant, const CORBA_double test,
	  CORBA_Environment *ev)
{
	CORBA_int	cnt;
	ReqCount *reqcnt = (ReqCount *)((POA_Test *)servant)->_private;

	cnt = reqcnt->double_cnt;
	reqcnt->double_cnt++;

	TP_CHECK((test == double_chkdat[cnt]), (" "));
	printf("func_double_impl arg %f\n", test);
	printf("func_double_impl ret %f\n", test + 1.0);
	return test + 1;
}

CORBA_char *str_ret;

CORBA_char *
func_string_impl(PortableServer_Servant servant, const CORBA_char *test, CORBA_Environment *ev)
{
	CORBA_char	*str_ret;
	CORBA_int	cnt;
	ReqCount *reqcnt = (ReqCount *)((POA_Test *)servant)->_private;

	cnt = reqcnt->string_cnt;
	reqcnt->string_cnt++;

	TP_CHECK((strcmp(test, string_chkdat[cnt].request) == 0), (" "));
	printf("func_string_impl arg %s\n", test);

	str_ret = string_chkdat[cnt].reply;
	printf("func_string_impl ret %s\n", str_ret);
	return str_ret;
}

test_Carray_slice *
func_Carray_impl(PortableServer_Servant servant, const test_Carray test, CORBA_Environment *ev)
{
	CORBA_long		i;
	test_Carray_slice	*ret;
	CORBA_int	cnt;
	ReqCount *reqcnt = (ReqCount *)((POA_Test *)servant)->_private;

	cnt = reqcnt->char_array_cnt;
	reqcnt->char_array_cnt++;

	for (i = 0; i < carray_chkdat[cnt].size; i++) {
		TP_CHECK((test[i] == i + carray_chkdat[cnt].dat), (" "));
		printf("func_Carray_impl arg %d\n", test[i]);
	}

	ret = test_Carray__alloc();
	for (i = 0; i < carray_chkdat[cnt].size; i++) {
		ret[i] = test[i] + carray_chkdat[cnt].size;
		printf("func_Carray_impl ret %d\n", ret[i]);
	}
	return ret;
}

test_Sarray_slice *
func_Sarray_impl(PortableServer_Servant servant, const test_Sarray test, CORBA_Environment *ev)
{
	CORBA_long		i;
	test_Sarray_slice	*ret;
	CORBA_int	cnt;
	ReqCount *reqcnt = (ReqCount *)((POA_Test *)servant)->_private;

	cnt = reqcnt->short_array_cnt;
	reqcnt->short_array_cnt++;
	for (i = 0; i < sarray_chkdat[cnt].size; i++) {
		TP_CHECK((test[i] == i + sarray_chkdat[cnt].dat), (" "));
		printf("func_Sarray_impl arg %d\n", test[i]);
	}

	ret = test_Sarray__alloc();
	for (i = 0; i < sarray_chkdat[cnt].size; i++) {
		ret[i] = test[i] + sarray_chkdat[cnt].size;
		printf("func_Sarray_impl ret %d\n", ret[i]);
	}
	return ret;
}

test_Larray_slice *
func_Larray_impl(PortableServer_Servant servant, const test_Larray test, CORBA_Environment *ev)
{
	CORBA_long		i;
	test_Larray_slice	*ret;
	CORBA_int	cnt;
	ReqCount *reqcnt = (ReqCount *)((POA_Test *)servant)->_private;

	cnt = reqcnt->long_array_cnt;
	reqcnt->long_array_cnt++;

	for (i = 0; i < larray_chkdat[cnt].size; i++) {
		TP_CHECK((test[i] == i + larray_chkdat[cnt].dat), (" "));
		printf("func_Larray_impl arg %d\n", (CORBA_int)test[i]);
	}

	ret = test_Larray__alloc();
	for (i = 0; i < larray_chkdat[cnt].size; i++) {
		ret[i] = test[i] + larray_chkdat[cnt].size;
		printf("func_Larray_impl ret %d\n", (CORBA_int)ret[i]);
	}
	return ret;
}

test_LLarray_slice *
func_LLarray_impl(PortableServer_Servant servant, const test_LLarray test, CORBA_Environment *ev)
{
	CORBA_long		i;
	test_LLarray_slice	*ret;
	CORBA_int	cnt;
	ReqCount *reqcnt = (ReqCount *)((POA_Test *)servant)->_private;

	cnt = reqcnt->long_long_array_cnt;
	reqcnt->long_long_array_cnt++;

	for (i = 0; i < llarray_chkdat[cnt].size; i++) {
		TP_CHECK((test[i] == i + llarray_chkdat[cnt].dat), (" "));
		printf("func_LLarray_impl arg %d\n", (CORBA_int)test[i]);
	}

	ret = test_LLarray__alloc();
	for (i = 0; i < llarray_chkdat[cnt].size; i++) {
		ret[i] = test[i] + llarray_chkdat[cnt].size;
		printf("func_LLarray_impl ret %d\n", (CORBA_int)ret[i]);
	}
	return ret;
}

test_Farray_slice *
func_Farray_impl(PortableServer_Servant servant, const test_Farray test, CORBA_Environment *ev)
{
	CORBA_long		i;
	test_Farray_slice	*ret;
	CORBA_int	cnt;
	ReqCount *reqcnt = (ReqCount *)((POA_Test *)servant)->_private;

	cnt = reqcnt->float_array_cnt;
	reqcnt->float_array_cnt++;

	for (i = 0; i < farray_chkdat[cnt].size; i++) {
		TP_CHECK((test[i] == i + farray_chkdat[cnt].dat), (" "));
		printf("func_Farray_impl arg %f\n", test[i]);
	}

	ret = test_Farray__alloc();
	for (i = 0; i < farray_chkdat[cnt].size; i++) {
		ret[i] = test[i] + farray_chkdat[cnt].size;
		printf("func_Farray_impl ret %f\n", ret[i]);
	}
	return ret;
}

test_Darray_slice *
func_Darray_impl(PortableServer_Servant servant, const test_Darray test, CORBA_Environment *ev)
{
	CORBA_long		i;
	test_Darray_slice	*ret;
	CORBA_int	cnt;
	ReqCount *reqcnt = (ReqCount *)((POA_Test *)servant)->_private;

	cnt = reqcnt->double_array_cnt;
	reqcnt->double_array_cnt++;

	for (i = 0; i < darray_chkdat[cnt].size; i++) {
		TP_CHECK((test[i] == i + darray_chkdat[cnt].dat), (" "));
		printf("func_Darray_impl arg %f\n", test[i]);
	}

	ret = test_Darray__alloc();
	for (i = 0; i < darray_chkdat[cnt].size; i++) {
		ret[i] = test[i] + darray_chkdat[cnt].size;
		printf("func_Darray_impl ret %f\n", ret[i]);
	}
	return ret;
}

test_struct *
func_struct_impl(PortableServer_Servant servant, const test_struct *test, CORBA_Environment *ev)
{
	test_struct	*ret;
	CORBA_int	cnt;
	ReqCount *reqcnt = (ReqCount *)((POA_Test *)servant)->_private;

	cnt = reqcnt->struct_cnt;
	reqcnt->struct_cnt++;

	TP_CHECK((test->char_dat == struct_chkdat[cnt].char_dat), (" "));
	TP_CHECK((test->short_dat == struct_chkdat[cnt].short_dat), (" "));
	TP_CHECK((test->long_dat == struct_chkdat[cnt].long_dat), (" "));
	TP_CHECK((test->long_long_dat == struct_chkdat[cnt].long_long_dat), (" "));
	TP_CHECK((test->float_dat == struct_chkdat[cnt].float_dat), (" "));
	TP_CHECK((test->double_dat == struct_chkdat[cnt].double_dat), (" "));

	printf("func_struct_impl arg char %d\n", test->char_dat);
	printf("func_struct_impl arg short %d\n", test->short_dat);
	printf("func_struct_impl arg long %d\n", (CORBA_int)test->long_dat);
	printf("func_struct_impl arg long long %d\n", (CORBA_int)test->long_long_dat);
	printf("func_struct_impl arg float %f\n", test->float_dat);
	printf("func_struct_impl arg double %f\n", test->double_dat);

	ret = test_struct__alloc();

	ret->char_dat = test->char_dat + 1;
	ret->short_dat = test->short_dat + 1;
	ret->long_dat = test->long_dat + 1;
	ret->long_long_dat = test->long_long_dat + 1;
	ret->float_dat = test->float_dat + 1;
	ret->double_dat = test->double_dat + 1;

	printf("func_struct_impl ret char %d\n", ret->char_dat);
	printf("func_struct_impl ret short %d\n", ret->short_dat);
	printf("func_struct_impl ret long %d\n", (CORBA_int)ret->long_dat);
	printf("func_struct_impl ret long long %d\n", (CORBA_int)ret->long_long_dat);
	printf("func_struct_impl ret float %f\n", ret->float_dat);
	printf("func_struct_impl ret double %f\n", ret->double_dat);

	return ret;
}

PortableServer_ServantBase__epv base_epv = {
	NULL,
	NULL,
	NULL
};

PortableServer_ServantPrivateInfo test_class = {
	"IDL:test:1.0",				/*	type_id	*/
	_skl_dispatch_test,			/*	dispatchؿ	*/
} ;

void POA_Test__init(POA_Test *servant, CORBA_Environment *env)
{
	POA_Test	*test;

	test = (POA_Test *)servant;
	((PortableServer_ServantBase *)test)->vepv->_private = (void *)&test_class;
}

void POA_Test__fini(POA_Test *servant, CORBA_Environment *env)
{
}

void
_skl_dispatch_test(PortableServer_Servant servant, GIOP_SrvInf *msg)
{
	CORBA_char		*bufp;
	CORBA_boolean		order;
	CORBA_Environment	env;

	bufp = GIOP_srv_bcurp(msg);
	order = GIOP_srv_bordr(msg);

	env._major = CORBA_NO_EXCEPTION;
	env._id = 0;
	env._params = 0;

	printf("operation %s\n", GIOP_srv_opnam(msg));

	if (!strcmp(GIOP_srv_opnam(msg), "func_char")) {
		CORBA_char		ret;
		CORBA_char		dat;
		CORBA_char		*check;
		CORBA_unsigned_long	size;

		TP_LINE();
		printf("s210401 : START\n");
		dat = MRSHL_get_char(&bufp, order);

		ret = ((POA_Test *)servant)->vepv->Test_epv->func_char(servant, dat, &env);
		if (env._major == CORBA_SYSTEM_EXCEPTION) {
			GIOP_send_repexc(msg, env._id, CORBA_COMPLETED_NO);
			printf("_skl_dispatch_test_char err 1\n");
			return;
		} else if (env._major == CORBA_USER_EXCEPTION) {
			GIOP_send_repexc(msg, CORBA_Ex_UNKNOWN,
					 CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_char err 2\n");
			return;
		}

		size = 0;
		size = MRSHL_index_char(size);	/* return data size */
		bufp = GIOP_create_repbuf(msg, size);
		if (!bufp) {
			GIOP_send_repexc(msg, CORBA_Ex_NO_MEMORY,
					 CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_char err 3\n");
			return;
		}
		MRSHL_put_long(&bufp, CORBA_NO_EXCEPTION);
		check = bufp;
		MRSHL_put_char(&bufp, ret);
		TP_CHECK((*check == ret), ("\n*check 0x%x\n ret 0x%x\n", *check, ret));

		size = (CORBA_unsigned_long)(bufp - GIOP_srv_btopp(msg));
		printf("_skl_dispatch_test_char rep send\n");
		GIOP_send_rep(msg, size);

		printf("_skl_dispatch_test_char success\n");
		printf("s210401 : END\n\n");
		return ;
	} else if (!strcmp(GIOP_srv_opnam(msg), "func_short")) {
		CORBA_short		ret;
		CORBA_short		dat;
		CORBA_short		*check;
		CORBA_unsigned_long	size;

		TP_LINE();
		printf("s210402 : START\n");
		dat = MRSHL_get_short(&bufp, order);

		ret = ((POA_Test *)servant)->vepv->Test_epv->func_short(servant, dat, &env);
		if (env._major == CORBA_SYSTEM_EXCEPTION) {
			GIOP_send_repexc(msg, env._id, CORBA_COMPLETED_NO);
			printf("_skl_dispatch_test_short err 1\n");
			return;
		} else if (env._major == CORBA_USER_EXCEPTION) {
			GIOP_send_repexc(msg, CORBA_Ex_UNKNOWN,
					 CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_short err 2\n");
			return;
		}

		size = 0;
		size = MRSHL_index_short(size);	/* return data size */
		bufp = GIOP_create_repbuf(msg, size);
		if (!bufp) {
			GIOP_send_repexc(msg, CORBA_Ex_NO_MEMORY,
					 CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_short err 3\n");
			return;
		}
		MRSHL_put_long(&bufp, CORBA_NO_EXCEPTION);
		check = MRSHL_align(bufp, sizeof(CORBA_short));
		MRSHL_put_short(&bufp, ret);
		TP_CHECK((*check == ret), ("\n*check 0x%x\n ret 0x%x\n", *check, ret));

		size = (CORBA_unsigned_long)(bufp - GIOP_srv_btopp(msg));
		printf("_skl_dispatch_test_short rep send\n");
		GIOP_send_rep(msg, size);
		printf("_skl_dispatch_test_short success\n");
		printf("s210402 : END\n\n");
		return ;
	} else if (!strcmp(GIOP_srv_opnam(msg), "func_long")) {
		CORBA_long		ret;
		CORBA_long		dat;
		CORBA_long		*check;
		CORBA_unsigned_long	size;

		TP_LINE();
		printf("s210403 : START\n");
		dat = MRSHL_get_long(&bufp, order);

		ret = ((POA_Test *)servant)->vepv->Test_epv->func_long(servant, dat, &env);
		if (env._major == CORBA_SYSTEM_EXCEPTION) {
			GIOP_send_repexc(msg, env._id, CORBA_COMPLETED_NO);
			printf("_skl_dispatch_test_long err 1\n");
			return;
		} else if (env._major == CORBA_USER_EXCEPTION) {
			GIOP_send_repexc(msg, CORBA_Ex_UNKNOWN,
					 CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_long err 2\n");
			return;
		}

		size = 0;
		size = MRSHL_index_long(size);	/* return data size */
		bufp = GIOP_create_repbuf(msg, size);
		if (!bufp) {
			GIOP_send_repexc(msg, CORBA_Ex_NO_MEMORY,
					 CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_long err 3\n");
			return;
		}
		MRSHL_put_long(&bufp, CORBA_NO_EXCEPTION);
		check = bufp;
		MRSHL_put_long(&bufp, ret);
		TP_CHECK((*check == ret), (""));

		size = (CORBA_unsigned_long)(bufp - GIOP_srv_btopp(msg));
		printf("_skl_dispatch_test_long rep send\n");
		GIOP_send_rep(msg, size);
		printf("_skl_dispatch_test_long success\n");
		printf("s210403 : END\n\n");
		return ;
	} else if (!strcmp(GIOP_srv_opnam(msg), "func_long_long")) {
		CORBA_long_long		ret;
		CORBA_long_long		dat;
		CORBA_long_long		*check;
		CORBA_unsigned_long	size;

		TP_LINE();
		printf("s210404 : START\n");
		dat = MRSHL_get_long_long(&bufp, order);

		ret = ((POA_Test *)servant)->vepv->Test_epv->func_long_long(servant, dat, &env);
		if (env._major == CORBA_SYSTEM_EXCEPTION) {
			GIOP_send_repexc(msg, env._id, CORBA_COMPLETED_NO);
			printf("_skl_dispatch_test_long_long err 1\n");
			return;
		} else if (env._major == CORBA_USER_EXCEPTION) {
			GIOP_send_repexc(msg, CORBA_Ex_UNKNOWN,
					 CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_long_long err 2\n");
			return;
		}

		size = 0;
		size = MRSHL_index_long_long(size);	/* return data size */
		bufp = GIOP_create_repbuf(msg, size);
		if (!bufp) {
			GIOP_send_repexc(msg, CORBA_Ex_NO_MEMORY,
					 CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_long_long err 3\n");
			return;
		}
		MRSHL_put_long(&bufp, CORBA_NO_EXCEPTION);
		check = bufp;
		MRSHL_put_long_long(&bufp, ret);
		TP_CHECK((*check == ret), (""));

		size = (CORBA_unsigned_long)(bufp - GIOP_srv_btopp(msg));
		printf("_skl_dispatch_test_long_long rep send\n");
		GIOP_send_rep(msg, size);
		printf("_skl_dispatch_test_long_long success\n");
		printf("s210404 : END\n\n");
		return ;
	} else if (!strcmp(GIOP_srv_opnam(msg), "func_float")) {
		CORBA_float		ret;
		CORBA_float		dat;
		CORBA_float		*check;
		CORBA_unsigned_long	size;

		TP_LINE();
		printf("s210405 : START\n");
		dat = MRSHL_get_float(&bufp, order);

		ret = ((POA_Test *)servant)->vepv->Test_epv->func_float(servant, dat, &env);
		if (env._major == CORBA_SYSTEM_EXCEPTION) {
			GIOP_send_repexc(msg, env._id, CORBA_COMPLETED_NO);
			printf("_skl_dispatch_test_float err 1\n");
			return;
		} else if (env._major == CORBA_USER_EXCEPTION) {
			GIOP_send_repexc(msg, CORBA_Ex_UNKNOWN,
					 CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_float err 2\n");
			return;
		}

		size = 0;
		size = MRSHL_index_float(size);	/* return data size */
		bufp = GIOP_create_repbuf(msg, size);
		if (!bufp) {
			GIOP_send_repexc(msg, CORBA_Ex_NO_MEMORY,
					 CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_float err 3\n");
			return;
		}
		MRSHL_put_long(&bufp, CORBA_NO_EXCEPTION);
		check = bufp;
		MRSHL_put_float(&bufp, ret);
		TP_CHECK((*check == ret), (""));

		size = (CORBA_unsigned_long)(bufp - GIOP_srv_btopp(msg));
		printf("_skl_dispatch_test_float rep send\n");
		GIOP_send_rep(msg, size);
		printf("_skl_dispatch_test_float success\n");
		printf("s210405 : END\n\n");
		return ;
	} else if (!strcmp(GIOP_srv_opnam(msg), "func_double")) {
		CORBA_double		ret;
		CORBA_double		dat;
		CORBA_double		*check;
		CORBA_unsigned_long	size;

		TP_LINE();
		printf("s210406 : START\n");
		dat = MRSHL_get_double(&bufp, order);

		ret = ((POA_Test *)servant)->vepv->Test_epv->func_double(servant, dat, &env);
		if (env._major == CORBA_SYSTEM_EXCEPTION) {
			GIOP_send_repexc(msg, env._id, CORBA_COMPLETED_NO);
			printf("_skl_dispatch_test_double err 1\n");
			return;
		} else if (env._major == CORBA_USER_EXCEPTION) {
			GIOP_send_repexc(msg, CORBA_Ex_UNKNOWN,
					 CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_double err 2\n");
			return;
		}

		size = 0;
		size = MRSHL_index_double(size);	/* return data size */
		bufp = GIOP_create_repbuf(msg, size);
		if (!bufp) {
			GIOP_send_repexc(msg, CORBA_Ex_NO_MEMORY,
					 CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_double err 3\n");
			return;
		}
		MRSHL_put_long(&bufp, CORBA_NO_EXCEPTION);
		check = bufp;
		MRSHL_put_double(&bufp, ret);
		TP_CHECK((*check == ret), (""));

		size = (CORBA_unsigned_long)(bufp - GIOP_srv_btopp(msg));
		printf("_skl_dispatch_test_double rep send\n");
		GIOP_send_rep(msg, size);
		printf("_skl_dispatch_test_double success\n");
		printf("s210406 : END\n\n");
		return ;
	} else if (!strcmp(GIOP_srv_opnam(msg), "func_string")) {
		CORBA_char		*ret;
		CORBA_char		*dat;
		CORBA_char		*check;
		CORBA_unsigned_long	size;

		TP_LINE();
		printf("s210407 : START\n");
		dat = MRSHL_get_string(&bufp, order);

		ret = ((POA_Test *)servant)->vepv->Test_epv->func_string(servant, dat, &env);
		if (env._major == CORBA_SYSTEM_EXCEPTION) {
			GIOP_send_repexc(msg, env._id, CORBA_COMPLETED_NO);
			printf("_skl_dispatch_test_string err 1\n");
			return;
		} else if (env._major == CORBA_USER_EXCEPTION) {
			GIOP_send_repexc(msg, CORBA_Ex_UNKNOWN,
					 CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_string err 2\n");
			return;
		}

		size = 0;
		size = MRSHL_index_string(size, dat);	/* return data size */
		bufp = GIOP_create_repbuf(msg, size);
		if (!bufp) {
			GIOP_send_repexc(msg, CORBA_Ex_NO_MEMORY, CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_string err 3\n");
			return;
		}
		MRSHL_put_long(&bufp, CORBA_NO_EXCEPTION);
		check = bufp;
		MRSHL_put_string(&bufp, ret);
		TP_CHECK((strcmp((char *)(check + 4), ret) == 0), (" "));

		size = (CORBA_unsigned_long)(bufp - GIOP_srv_btopp(msg));
		printf("_skl_dispatch_test_string rep send\n");
		GIOP_send_rep(msg, size);

		CORBA_free(dat);

		printf("_skl_dispatch_test_string success\n");
		printf("s210407 : END\n\n");
		return ;
	} else if (!strcmp(GIOP_srv_opnam(msg), "func_Carray")) {
		test_Carray_slice	*ret;
		test_Carray		dat;
		CORBA_char		*check;
		CORBA_unsigned_long	size;
		CORBA_long		i;

		TP_LINE();
		printf("s210408 : START\n");

		for (i = 0; i < 10; i++) {
			dat[i] = MRSHL_get_char(&bufp, order);
		}

		ret = ((POA_Test *)servant)->vepv->Test_epv->func_Carray(servant, dat, &env);
		if (env._major == CORBA_SYSTEM_EXCEPTION) {
			GIOP_send_repexc(msg, env._id, CORBA_COMPLETED_NO);
			printf("_skl_dispatch_test_Carray err 1\n");
			return;
		} else if (env._major == CORBA_USER_EXCEPTION) {
			GIOP_send_repexc(msg, CORBA_Ex_UNKNOWN,
					 CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_Carray err 2\n");
			return;
		}

		size = (CORBA_unsigned_long)sizeof(test_Carray);
		bufp = GIOP_create_repbuf(msg, size);
		if (!bufp) {
			GIOP_send_repexc(msg, CORBA_Ex_NO_MEMORY, CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_Carray err 3\n");
			return;
		}
		MRSHL_put_long(&bufp, CORBA_NO_EXCEPTION);
		check = bufp;
		MRSHL_bcopy(&bufp, (CORBA_char *)ret, sizeof(CORBA_char), (CORBA_unsigned_long)sizeof(test_Carray));
		TP_CHECK((memcmp(check, ret, sizeof(test_Carray)) == 0), (""));

		size = (CORBA_unsigned_long)(bufp - GIOP_srv_btopp(msg));
		printf("_skl_dispatch_test_Carray rep send\n");
		GIOP_send_rep(msg, size);

		CORBA_free(ret);

		printf("_skl_dispatch_test_Carray success\n");
		printf("s210408 : END\n\n");
		return ;
	} else  if (!strcmp(GIOP_srv_opnam(msg), "func_Sarray")) {
		test_Sarray_slice	*ret;
		test_Sarray		dat;
		CORBA_short		*check;
		CORBA_unsigned_long	size;
		CORBA_long		i;

		TP_LINE();
		printf("s210409 : START\n");

		for (i = 0; i < 10; i++) {
			dat[i] = MRSHL_get_short(&bufp, order);
		}

		ret = ((POA_Test *)servant)->vepv->Test_epv->func_Sarray(servant, dat, &env);
		if (env._major == CORBA_SYSTEM_EXCEPTION) {
			GIOP_send_repexc(msg, env._id, CORBA_COMPLETED_NO);
			printf("_skl_dispatch_test_Sarray err 1\n");
			return;
		} else if (env._major == CORBA_USER_EXCEPTION) {
			GIOP_send_repexc(msg, CORBA_Ex_UNKNOWN,
					 CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_Sarray err 2\n");
			return;
		}

		size = (CORBA_unsigned_long)sizeof(test_Sarray);
		bufp = GIOP_create_repbuf(msg, size);
		if (!bufp) {
			GIOP_send_repexc(msg, CORBA_Ex_NO_MEMORY, CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_Sarray err 3\n");
			return;
		}
		MRSHL_put_long(&bufp, CORBA_NO_EXCEPTION);
		check = bufp;
		MRSHL_bcopy(&bufp, (CORBA_char *)ret, sizeof(CORBA_short), (CORBA_unsigned_long)sizeof(test_Sarray));
		TP_CHECK((memcmp(check, ret, sizeof(test_Sarray)) == 0), (""));

		size = (CORBA_unsigned_long)(bufp - GIOP_srv_btopp(msg));
		printf("_skl_dispatch_test_Sarray rep send\n");
		GIOP_send_rep(msg, size);

		CORBA_free(ret);

		printf("_skl_dispatch_test_Sarray success\n");
		printf("s210409 : END\n\n");
		return ;
	} else  if (!strcmp(GIOP_srv_opnam(msg), "func_Larray")) {
		test_Larray_slice	*ret;
		test_Larray		dat;
		CORBA_long		*check;
		CORBA_unsigned_long	size;
		CORBA_long		i;

		TP_LINE();
		printf("s210410 : START\n");

		for (i = 0; i < 10; i++) {
			dat[i] = MRSHL_get_long(&bufp, order);
		}

		ret = ((POA_Test *)servant)->vepv->Test_epv->func_Larray(servant, dat, &env);
		if (env._major == CORBA_SYSTEM_EXCEPTION) {
			GIOP_send_repexc(msg, env._id, CORBA_COMPLETED_NO);
			printf("_skl_dispatch_test_Larray err 1\n");
			return;
		} else if (env._major == CORBA_USER_EXCEPTION) {
			GIOP_send_repexc(msg, CORBA_Ex_UNKNOWN,
					 CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_Larray err 2\n");
			return;
		}

		size = (CORBA_unsigned_long)sizeof(test_Larray);
		bufp = GIOP_create_repbuf(msg, size);
		if (!bufp) {
			GIOP_send_repexc(msg, CORBA_Ex_NO_MEMORY, CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_Larray err 3\n");
			return;
		}
		MRSHL_put_long(&bufp, CORBA_NO_EXCEPTION);
		check = bufp;
		MRSHL_bcopy(&bufp, (CORBA_char *)ret, sizeof(CORBA_long), (CORBA_unsigned_long)sizeof(test_Larray));
		TP_CHECK((memcmp(check, ret, sizeof(test_Larray)) == 0), (""));

		size = (CORBA_unsigned_long)(bufp - GIOP_srv_btopp(msg));
		printf("_skl_dispatch_test_Larray rep send\n");
		GIOP_send_rep(msg, size);

		CORBA_free(ret);

		printf("_skl_dispatch_test_Larray success\n");
		printf("s2104110 : END\n\n");
		return ;
	} else  if (!strcmp(GIOP_srv_opnam(msg), "func_LLarray")) {
		test_LLarray_slice	*ret;
		test_LLarray		dat;
		CORBA_long_long		*check;
		CORBA_unsigned_long	size;
		CORBA_long		i;

		TP_LINE();
		printf("s2104111 : START\n");

		for (i = 0; i < 10; i++) {
			dat[i] = MRSHL_get_long_long(&bufp, order);
		}

		ret = ((POA_Test *)servant)->vepv->Test_epv->func_LLarray(servant, dat, &env);
		if (env._major == CORBA_SYSTEM_EXCEPTION) {
			GIOP_send_repexc(msg, env._id, CORBA_COMPLETED_NO);
			printf("_skl_dispatch_test_LLarray err 1\n");
			return;
		} else if (env._major == CORBA_USER_EXCEPTION) {
			GIOP_send_repexc(msg, CORBA_Ex_UNKNOWN,
					 CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_LLarray err 2\n");
			return;
		}

		size = (CORBA_unsigned_long)sizeof(test_LLarray);
		bufp = GIOP_create_repbuf(msg, size);
		if (!bufp) {
			GIOP_send_repexc(msg, CORBA_Ex_NO_MEMORY, CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_LLarray err 3\n");
			return;
		}
		MRSHL_put_long(&bufp, CORBA_NO_EXCEPTION);
		check = bufp;
		MRSHL_bcopy(&bufp, (CORBA_char *)ret, sizeof(CORBA_long_long), (CORBA_unsigned_long)sizeof(test_LLarray));
		TP_CHECK((memcmp(check, ret, sizeof(test_LLarray)) == 0), (""));

		size = (CORBA_unsigned_long)(bufp - GIOP_srv_btopp(msg));
		printf("_skl_dispatch_test_LLarray rep send\n");
		GIOP_send_rep(msg, size);

		CORBA_free(ret);

		printf("_skl_dispatch_test_LLarray success\n");
		printf("s2104111 : END\n\n");
		return ;
	} else  if (!strcmp(GIOP_srv_opnam(msg), "func_Farray")) {
		test_Farray_slice	*ret;
		test_Farray		dat;
		CORBA_float		*check;
		CORBA_unsigned_long	size;
		CORBA_long		i;

		TP_LINE();
		printf("s2104112 : START\n");

		for (i = 0; i < 10; i++) {
			dat[i] = MRSHL_get_float(&bufp, order);
		}

		ret = ((POA_Test *)servant)->vepv->Test_epv->func_Farray(servant, dat, &env);
		if (env._major == CORBA_SYSTEM_EXCEPTION) {
			GIOP_send_repexc(msg, env._id, CORBA_COMPLETED_NO);
			printf("_skl_dispatch_test_Farray err 1\n");
			return;
		} else if (env._major == CORBA_USER_EXCEPTION) {
			GIOP_send_repexc(msg, CORBA_Ex_UNKNOWN,
					 CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_Farray err 2\n");
			return;
		}

		size = (CORBA_unsigned_long)sizeof(test_Farray);
		bufp = GIOP_create_repbuf(msg, size);
		if (!bufp) {
			GIOP_send_repexc(msg, CORBA_Ex_NO_MEMORY, CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_Farray err 3\n");
			return;
		}
		MRSHL_put_long(&bufp, CORBA_NO_EXCEPTION);
		check = bufp;
		MRSHL_bcopy(&bufp, (CORBA_char *)ret, sizeof(CORBA_float), (CORBA_unsigned_long)sizeof(test_Farray));
		TP_CHECK((memcmp(check, ret, sizeof(test_Farray)) == 0), (""));

		size = (CORBA_unsigned_long)(bufp - GIOP_srv_btopp(msg));
		printf("_skl_dispatch_test_Farray rep send\n");
		GIOP_send_rep(msg, size);

		CORBA_free(ret);

		printf("_skl_dispatch_test_Farray success\n");
		printf("s2104112 : END\n\n");
		return ;
	} else  if (!strcmp(GIOP_srv_opnam(msg), "func_Darray")) {
		test_Darray_slice	*ret;
		test_Darray		dat;
		CORBA_double	*check;
		CORBA_unsigned_long	size;
		CORBA_long		i;

		TP_LINE();
		printf("s2104113 : START\n");

		for (i = 0; i < 10; i++) {
			dat[i] = MRSHL_get_double(&bufp, order);
		}

		ret = ((POA_Test *)servant)->vepv->Test_epv->func_Darray(servant, dat, &env);
		if (env._major == CORBA_SYSTEM_EXCEPTION) {
			GIOP_send_repexc(msg, env._id, CORBA_COMPLETED_NO);
			printf("_skl_dispatch_test_Darray err 1\n");
			return;
		} else if (env._major == CORBA_USER_EXCEPTION) {
			GIOP_send_repexc(msg, CORBA_Ex_UNKNOWN,
					 CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_Darray err 2\n");
			return;
		}

		size = (CORBA_unsigned_long)sizeof(test_Darray);
		bufp = GIOP_create_repbuf(msg, size);
		if (!bufp) {
			GIOP_send_repexc(msg, CORBA_Ex_NO_MEMORY, CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_Darray err 3\n");
			return;
		}
		MRSHL_put_long(&bufp, CORBA_NO_EXCEPTION);
		check = bufp;
		MRSHL_bcopy(&bufp, (CORBA_char *)ret, sizeof(CORBA_double), (CORBA_unsigned_long)sizeof(test_Darray));
		TP_CHECK((memcmp(check, ret, sizeof(test_Darray)) == 0), (""));

		size = (CORBA_unsigned_long)(bufp - GIOP_srv_btopp(msg));
		printf("_skl_dispatch_test_Darray rep send\n");
		GIOP_send_rep(msg, size);

		CORBA_free(ret);

		printf("_skl_dispatch_test_Darray success\n");
		printf("s210413 : END\n\n");
		return ;
	} else  if (!strcmp(GIOP_srv_opnam(msg), "func_struct")) {
		test_struct		*ret;
		test_struct		*dat;
		CORBA_char		*ccheck;
		CORBA_short		*scheck;
		CORBA_long		*lcheck;
		CORBA_long_long		*llcheck;
		CORBA_float		*fcheck;
		CORBA_double		*dcheck;
		CORBA_unsigned_long	size;

		TP_LINE();
		printf("s210414 : START\n");

		dat = test_struct__alloc();
		dat->char_dat = MRSHL_get_char(&bufp, order);
		dat->short_dat = MRSHL_get_short(&bufp, order);
		dat->long_dat = MRSHL_get_long(&bufp, order);
		dat->long_long_dat = MRSHL_get_long_long(&bufp, order);
		dat->float_dat = MRSHL_get_float(&bufp, order);
		dat->double_dat = MRSHL_get_double(&bufp, order);

		ret = ((POA_Test *)servant)->vepv->Test_epv->func_struct(servant, dat, &env);
		if (env._major == CORBA_SYSTEM_EXCEPTION) {
			GIOP_send_repexc(msg, env._id, CORBA_COMPLETED_NO);
			printf("_skl_dispatch_test_struct err 1\n");
			return;
		} else if (env._major == CORBA_USER_EXCEPTION) {
			GIOP_send_repexc(msg, CORBA_Ex_UNKNOWN, CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_struct err 2\n");
			return;
		}

		size = 0;
		size = MRSHL_index_char(size);
		size = MRSHL_index_short(size);
		size = MRSHL_index_long(size);
		size = MRSHL_index_long_long(size);
		size = MRSHL_index_float(size);
		size = MRSHL_index_double(size);
		bufp = GIOP_create_repbuf(msg, size);
		if (!bufp) {
			GIOP_send_repexc(msg, CORBA_Ex_NO_MEMORY, CORBA_COMPLETED_YES);
			printf("_skl_dispatch_test_struct err 3\n");
			return;
		}
		MRSHL_put_long(&bufp, CORBA_NO_EXCEPTION);

		ccheck = bufp;
		MRSHL_put_char(&bufp, ret->char_dat);
		TP_CHECK((*ccheck == ret->char_dat), (""));

		scheck = MRSHL_align(bufp, sizeof(CORBA_short));
		MRSHL_put_short(&bufp, ret->short_dat);
		TP_CHECK((*scheck == ret->short_dat), (""));

		lcheck = MRSHL_align(bufp, sizeof(CORBA_long));
		MRSHL_put_long(&bufp, ret->long_dat);
		TP_CHECK((*lcheck == ret->long_dat), (""));

		llcheck = MRSHL_align(bufp, sizeof(CORBA_long_long));
		MRSHL_put_long_long(&bufp, ret->long_long_dat);
		TP_CHECK((*llcheck == ret->long_long_dat), (""));

		fcheck = MRSHL_align(bufp, sizeof(CORBA_float));
		MRSHL_put_float(&bufp, ret->float_dat);
		TP_CHECK((*fcheck == ret->float_dat), (""));

		dcheck = MRSHL_align(bufp, sizeof(CORBA_double));
		MRSHL_put_double(&bufp, ret->double_dat);
		TP_CHECK((*dcheck == ret->double_dat), (""));

		size = (CORBA_unsigned_long)(bufp - GIOP_srv_btopp(msg));
		printf("_skl_dispatch_test_struct rep send\n");
		GIOP_send_rep(msg, size);

		CORBA_free(ret);
		CORBA_free(dat);

		printf("_skl_dispatch_test_struct success\n");
		printf("s210414 : END\n\n");
		TP_LINE();
		return ;
	} else {
		GIOP_send_repexc(msg, CORBA_Ex_BAD_OPERATION,
				 CORBA_COMPLETED_NO);
		return;
	}
}

void
tsk(void)
{
	int				argc;
	char				*argv;
	CORBA_ORB			orb;
	CORBA_Environment		ev;
	CORBA_Object			obj;
	PortableServer_ObjectId		*oid;
	PortableServer_POA		root_poa;
	PortableServer_POAManager	poa_mgr = NULL;
	POA_Test__epv test_epv = {
	  NULL,
	  func_char_impl,
	  func_short_impl,
	  func_long_impl,
	  func_long_long_impl,
	  func_float_impl,
	  func_double_impl,
	  func_string_impl,
	  func_Carray_impl,
	  func_Sarray_impl,
	  func_Larray_impl,
	  func_LLarray_impl,
	  func_Farray_impl,
	  func_Darray_impl,
	  func_struct_impl
	};
	POA_Test__vepv			test_vepv = { NULL, &base_epv, &test_epv };
	POA_Test		 	test = { &RequestCount, &test_vepv };
	CORBA_char			*str;

	RequestCount.char_cnt = 0;
	RequestCount.short_cnt = 0;
	RequestCount.long_cnt = 0;
	RequestCount.long_long_cnt = 0;
	RequestCount.float_cnt = 0;
	RequestCount.double_cnt = 0;
	RequestCount.string_cnt = 0;
	RequestCount.char_array_cnt = 0;
	RequestCount.short_array_cnt = 0;
	RequestCount.long_array_cnt = 0;
	RequestCount.long_long_array_cnt = 0;
	RequestCount.float_array_cnt = 0;
	RequestCount.double_array_cnt = 0;
	RequestCount.struct_cnt = 0;

	CORBA_exception_init(&ev);

	argc = 0;
	orb = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
         * RootPOA롣
         */
	obj = CORBA_ORB_resolve_initial_references(orb, "RootPOA", &ev);
	root_poa = (PortableServer_POA)obj;
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
         * RootPOAȴϢŤ줿POAManager롣
         */
	poa_mgr = PortableServer_POA__get_the_POAManager(root_poa, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	POA_Test__init(&test, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	
	oid = PortableServer_string_to_ObjectId("test", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	
	/*
         * POA˥ХȤϿ롣
         */
	PortableServer_POA_activate_object_with_id(root_poa, oid, &test, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
         * POAManager˳Υå롣
         * POAManagerϿƤ뤹٤ƤPOA롣
         */
	PortableServer_POAManager_activate(poa_mgr, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
	 * ХȤ饪֥ȥե󥹤κ
         */
        obj = PortableServer_POA_servant_to_reference(root_poa, &test, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	
	/*
	 * ֥ȥե󥹤ʸѴ
         */
	str = CORBA_ORB_object_to_string(orb, obj, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
	 * Ϥǡ֥ȥե󥹤
         * 饤ȤذϤɬפ롣
         */
	TP_IOR_send(6000, str);

	/*
	 * ORBå롼פ롣
         */
	CORBA_ORB_run(orb, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
	 * POA
	 * (Don't reach)
         */
	PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	CORBA_Object_release((CORBA_Object)orb, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	exit(-1);
}

#ifdef	CORBA_UNIX

void
main(int argc, char *argv[])
{
	SYS_init_debug(0);
	if (ecorba_init()) {
		printf("ERROR ecorba_init\n");
		exit(-1);
	}

	tsk();
	exit(0);
}

#else	CORBA_UNIX

ERR
main(Bool Startup, TC *arg)
{
	WERR		tskid0;

	SYS_init_debug(0);
	IPA_LOG_init(0);

	TP_corba_init();

	tskid0 = TP_CreateTask(tsk, DEFAULT_PRI);

	return 0;
}

#endif	/* CORBA_UNIX */
