/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#include "config.h"
#include "tpchk.h"
#include "s2201.h"
#include "ior1_1.h"
#include "ior2_1.h"
#include "ior2_2.h"
#include "ior3_1.h"
#include "ior3_2.h"
#include "ior3_3.h"
#include "errior.h"
#include "noent.h"
#include "_sysdbg.h"
#include "_loging.h"

static CORBA_long shutdown_func(CORBA_Object, CORBA_long, CORBA_Environment *);
static CORBA_long taskid_func(CORBA_Object, CORBA_Environment *);

void
task(void)
{
	int			argc = 0;
	char			*argv = "";
	CORBA_Environment	ev;
	CORBA_ORB		orb;

	TP_START();
	TP_corba_init();

	CORBA_exception_init(&ev);

	orb = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	TP_LINE();

	/* s220101 */
	/* s220201 */
	/* s220301 */
	{
		CORBA_Object	obj;
		CORBA_long	id;
		CORBA_long	start_id;

		CORBA_exception_init(&ev);
		obj = CORBA_ORB_string_to_object(orb, testIOR1_1, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((obj != CORBA_NULL), (" "));

		TP_INFO(("s220201\n"));

 		/*
		 * ưƤʤФإꥯȤ롣
		 */
		start_id = taskid_func(obj, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_Msg("tskid : %d\n", start_id);
		TP_Msg("Request send OK\n");

		TP_INFO(("s220201 OK\n"));
		TP_LINE();

		TP_INFO(("s220101\n"));

 		/*
		 * ưƤ륵ФإꥯȤ롣
		 */
		id = taskid_func(obj, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((id == start_id), (" "));
		TP_Msg("tskid : %d\n", id);
		TP_Msg("Request send OK\n");

		TP_INFO(("s220101 OK\n"));
		TP_LINE();

		TP_INFO(("s220301\n"));

 		/*
		 * ưƤ륵Фλ롣
		 */
		id = shutdown_func(obj, SERVER_NUMBER_1, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((id == start_id), (" "));
		TP_Msg("Request send OK\n");

 		/*
		 * нλǧ
		 */
		tsk_stop_check(id, SYNC_SERVER_NAME, TASK_INF_SERVER_PORT);

		TP_INFO(("s220301 OK\n"));
		TP_LINE();

		CORBA_Object_release(obj, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	}
	/* s220101 end */
	/* s220201 end */
	/* s220301 end */

	/* 2Ф˴ؤλԤ */
	sync_recv(SYNC_SERVER_PORT);


	/* s220102 */
	/* s220202 */
	/* s220302 */
	{
		CORBA_Object	obj1;
		CORBA_Object	obj2;
		CORBA_long	id1;
		CORBA_long	id2;
		CORBA_long	start_id1;
		CORBA_long	start_id2;

		CORBA_exception_init(&ev);
		obj1 = CORBA_ORB_string_to_object(orb, testIOR2_1, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((obj1 != CORBA_NULL), (" "));

		obj2 = CORBA_ORB_string_to_object(orb, testIOR2_2, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((obj2 != CORBA_NULL), (" "));

		TP_INFO(("s220202\n"));

 		/*
		 * ưƤʤФإꥯȤ롣
		 */
		start_id1 = taskid_func(obj1, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_Msg("tskid : %d\n", start_id1);
		TP_Msg("Request send OK\n");

		start_id2 = taskid_func(obj2, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_Msg("tskid : %d\n", start_id2);
		TP_Msg("Request send OK\n");

		TP_INFO(("s220202 OK\n"));
		TP_LINE();

		TP_INFO(("s220102\n"));

 		/*
		 * ưƤ륵ФإꥯȤ롣
		 */
		id1 = taskid_func(obj1, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((id1 == start_id1), (" "));
		TP_Msg("tskid : %d\n", id1);
		TP_Msg("Request send OK\n");

		id2 = taskid_func(obj2, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((id2 == start_id2), (" "));
		TP_Msg("tskid : %d\n", id2);
		TP_Msg("Request send OK\n");

		TP_INFO(("s220102 OK\n"));
		TP_LINE();

		TP_INFO(("s220302\n"));

		/*
		 * ưƤ륵Фλ롣
		 */
		id1 = shutdown_func(obj1, SERVER_NUMBER_1, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((id1 == start_id1), (" "));
		TP_Msg("Request send OK\n");

		id2 = shutdown_func(obj2, SERVER_NUMBER_2, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((id2 == start_id2), (" "));
		TP_Msg("Request send OK\n");

 		/*
		 * нλǧ
		 */
		tsk_stop_check(id1, SYNC_SERVER_NAME, TASK_INF_SERVER_PORT);
		tsk_stop_check(id2, SYNC_SERVER_NAME, TASK_INF_SERVER_PORT);

		TP_INFO(("s220302 OK\n"));
		TP_LINE();

		CORBA_Object_release(obj1, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		CORBA_Object_release(obj2, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	}
	/* s220102 end */
	/* s220202 end */
	/* s220302 end */

	/* 3Ф˴ؤλԤ */
	sync_recv(SYNC_SERVER_PORT);

	/* s220103 */
	/* s220203 */
	/* s220303 */
	{
		CORBA_Object	obj1;
		CORBA_Object	obj2;
		CORBA_Object	obj3;
		CORBA_long	id1;
		CORBA_long	id2;
		CORBA_long	id3;
		CORBA_long	start_id1;
		CORBA_long	start_id2;
		CORBA_long	start_id3;

		CORBA_exception_init(&ev);
		obj1 = CORBA_ORB_string_to_object(orb, testIOR3_1, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((obj1 != CORBA_NULL), (" "));

		obj2 = CORBA_ORB_string_to_object(orb, testIOR3_2, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((obj2 != CORBA_NULL), (" "));

		obj3 = CORBA_ORB_string_to_object(orb, testIOR3_3, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((obj3 != CORBA_NULL), (" "));

		TP_INFO(("s220203\n"));

 		/*
		 * ưƤʤФإꥯȤ롣
		 */
		start_id1 = taskid_func(obj1, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_Msg("tskid : %d\n", start_id1);
		TP_Msg("Request send OK\n");

		start_id2 = taskid_func(obj2, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_Msg("tskid : %d\n", start_id2);
		TP_Msg("Request send OK\n");

		start_id3 = taskid_func(obj3, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_Msg("tskid : %d\n", start_id3);
		TP_Msg("Request send OK\n");

		TP_INFO(("s220203 OK\n"));
		TP_LINE();

		TP_INFO(("s220103\n"));

 		/*
		 * ưƤ륵ФإꥯȤ롣
		 */
		id1 = taskid_func(obj1, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((id1 == start_id1), (" "));
		TP_Msg("tskid : %d\n", id1);
		TP_Msg("Request send OK\n");

		id2 = taskid_func(obj2, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((id2 == start_id2), (" "));
		TP_Msg("tskid : %d\n", id2);
		TP_Msg("Request send OK\n");

		id3 = taskid_func(obj3, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((id3 == start_id3), (" "));
		TP_Msg("tskid : %d\n", id3);
		TP_Msg("Request send OK\n");

		TP_INFO(("s220103 OK\n"));
		TP_LINE();

		TP_INFO(("s220303\n"));

 		/*
		 * ưƤ륵Фλ롣
		 */
		id1 = shutdown_func(obj1, SERVER_NUMBER_1, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((id1 == start_id1), (" "));
		TP_Msg("Request send OK\n");

		id2 = shutdown_func(obj2, SERVER_NUMBER_2, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((id2 == start_id2), (" "));
		TP_Msg("Request send OK\n");

		id3 = shutdown_func(obj3, SERVER_NUMBER_3, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((id3 == start_id3), (" "));
		TP_Msg("Request send OK\n");

 		/*
		 * нλǧ
		 */
		tsk_stop_check(id1, SYNC_SERVER_NAME, TASK_INF_SERVER_PORT);
		tsk_stop_check(id2, SYNC_SERVER_NAME, TASK_INF_SERVER_PORT);
		tsk_stop_check(id3, SYNC_SERVER_NAME, TASK_INF_SERVER_PORT);

		TP_INFO(("s220303 OK\n"));
		TP_LINE();

		CORBA_Object_release(obj1, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		CORBA_Object_release(obj2, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		CORBA_Object_release(obj3, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	}
	/* s220103 end */
	/* s220203 end */
	/* s220303 end */

	/* 顼ѥФ˴ؤλԤ */
	sync_recv(SYNC_SERVER_PORT);

	TP_LINE();
	TP_INFO(("s220104\n"));
	{
		CORBA_Object	obj;
		CORBA_char	*excid;

		CORBA_exception_init(&ev);
		obj = CORBA_ORB_string_to_object(orb, noentIOR, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((obj != CORBA_NULL), (" "));

 		/*
		 * ϿƤʤФإꥯȤ롣
		 */
		taskid_func(obj, &ev);
		TP_CHECK((ev._major == CORBA_SYSTEM_EXCEPTION), (" "));
		TP_Msg("_major : %d\n", ev._major);

		excid = CORBA_exception_id(&ev);
		TP_CHECK((strcmp(excid, CORBA_Ex_NO_IMPLEMENT) == 0), (" "));
		TP_Msg("_id : %s\n", excid);
		CORBA_exception_free(&ev);

		CORBA_Object_release(obj, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	}
	TP_INFO(("s220104 OK\n"));

	/* 饤¦顼λΤ */
	sync_send(SYNC_SERVER_NAME, SYNC_SERVER_PORT);

	/* ưԥФνλԤ */
	sync_recv(SYNC_SERVER_PORT);

	TP_LINE();
	TP_INFO(("s220204\n"));
	{
		CORBA_Object	obj;
		CORBA_char	*excid;

		CORBA_exception_init(&ev);
		obj = CORBA_ORB_string_to_object(orb, errIOR, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((obj != CORBA_NULL), (" "));

 		/*
		 * ưԤ륵ФإꥯȤ롣
		 */
		taskid_func(obj, &ev);
		TP_CHECK((ev._major == CORBA_SYSTEM_EXCEPTION), (" "));
		TP_Msg("_major : %d\n", ev._major);

		excid = CORBA_exception_id(&ev);
		TP_CHECK((strcmp(excid, CORBA_Ex_NO_RESOURCES) == 0), (" "));
		TP_Msg("_id : %s\n", excid);
		CORBA_exception_free(&ev);

		CORBA_Object_release(obj, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	}
	TP_INFO(("s220204 OK\n"));
	TP_LINE();

	/* 饤¦顼λΤ */
	sync_send(SYNC_SERVER_NAME, SYNC_SERVER_PORT);

	TP_corba_fini();
	TP_delete_ASRVtsk(ASRV_SERVER_ID);
	TP_END();
}

static CORBA_long
shutdown_func(CORBA_Object obj, CORBA_long number, CORBA_Environment *ev)
{
	CORBA_char		*topp;
	CORBA_char		*bufp;
	CORBA_long		ret;
	CORBA_unsigned_long	size;
	GIOP_CliInf		cliinf;

	CORBA_exception_init(ev);
	GIOP_init_cli(&cliinf);

	do {
		size = 0;
		size = MRSHL_index_long(size);
		topp = GIOP_create_reqbuf(obj, &cliinf, size, CORBA_TRUE,
					"shutdown_func", ev);
		TP_CHECK((ev->_major == CORBA_NO_EXCEPTION), (" "));

		bufp = topp;
		size = 0;
		MRSHL_put_long(&bufp, number);
		size = bufp - topp;
		topp = GIOP_invoke_req(obj, &cliinf, size, ev);
	} while (ev->_flag == ENVFLG_LOCATION_FORWARD);

	bufp = topp;
	ret = MRSHL_get_long(&bufp, GIOP_cli_bordr(&cliinf));

	GIOP_end_cli(&cliinf);

	return ret;
}

static CORBA_long
taskid_func(CORBA_Object obj, CORBA_Environment *ev)
{
	CORBA_char		*topp;
	CORBA_char		*bufp;
	CORBA_long		ret;
	CORBA_unsigned_long	size;
	GIOP_CliInf		cliinf;

	CORBA_exception_init(ev);
	GIOP_init_cli(&cliinf);

	do {
		size = 0;
		topp = GIOP_create_reqbuf(obj, &cliinf, size, CORBA_TRUE,
					"taskid_func", ev);
		TP_CHECK((ev->_major == CORBA_NO_EXCEPTION), (" "));

		bufp = topp;
		size = 0;
		size = bufp - topp;
		topp = GIOP_invoke_req(obj, &cliinf, size, ev);
	} while (ev->_flag == ENVFLG_LOCATION_FORWARD);

	bufp = topp;
	ret = MRSHL_get_long(&bufp, GIOP_cli_bordr(&cliinf));

	GIOP_end_cli(&cliinf);

	return ret;
}

#ifdef	CORBA_UNIX

int
main(void)
{
	MAIN_START();	
	IPA_LOG_init(0);

	SYS_init_debug(0);

	task();

	MAIN_END();	
	return 0;
}

#else	/* CORBA_UNIX */

ERR
main(Bool Startup, TC *arg)
{
	MAIN_START();	
	IPA_LOG_init(0);

	SYS_init_debug(0);

	TP_CreateTask(task, DEFAULT_PRI);

	MAIN_END();

	return 0;
}

#endif	/* CORBA_UNIX */
