/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#include "config.h"
#include "tpchk.h"
#include "s2201.h"
#include "_sysdbg.h"
#include "_loging.h"

void
test_task1(void)
{
	server(SERVER_NUMBER_1, SERVER_NAME_1);
}

void
test_task2(void)
{
	server(SERVER_NUMBER_2, SERVER_NAME_2);
}

void
test_task3(void)
{
	server(SERVER_NUMBER_3, SERVER_NAME_3);
}

void
err_task(void)
{
	TP_Msg("Server Task Start Fail\n");
	exd_tsk();
}

ERR
main(Bool Startup, TC *arg)
{
	T_CTSK		tsk;
	CORBA_int	soid;

	IPA_LOG_init(0);
	SYS_init_debug(0);
	chg_pri(0, DEFAULT_PRI - 1);

	TP_LINE();
	TP_INFO(("s220101\n"));
	TP_INFO(("s220201\n"));
	TP_INFO(("s220301\n"));
	{
		TP_corba_init2(TP_ASRV_PORT1);

		/*
		 * Ф򥪥֥ȴơ֥Ͽ
		 */
		tsk.exinf = (VP)CH4toW('S','R','V','1');
		tsk.task = test_task1;
		tsk.itskpri = DEFAULT_PRI;
		tsk.stksz = 0x4000;
		tsk.tskatr = TA_HLNG | TA_RNG0;
		TP_Msg("server task entry %s\n", SERVER_NAME_1);
		soid = ASRV_entry_sobj(&tsk, SERVER_NAME_1);
		TP_CHECK((soid > 0), (" "));
		TP_Msg("object id %d\n", soid);

		/* 1Ф˴ؤ븡λΤԤ */
		tsk_stop_wait(TASK_INF_SERVER_PORT);

		TP_corba_fini();
		TP_delete_ASRVtsk(ASRV_SERVER_ID);
	}
	TP_INFO(("s220101 OK\n"));
	TP_INFO(("s220201 OK\n"));
	TP_INFO(("s220301 OK\n"));

	TP_LINE();
	TP_INFO(("s220102\n"));
	TP_INFO(("s220202\n"));
	TP_INFO(("s220302\n"));
	{
		TP_corba_init2(TP_ASRV_PORT2);

		/*
		 * Ф򥪥֥ȴơ֥Ͽ
		 */
		tsk.exinf = (VP)CH4toW('S','R','V','1');
		tsk.task = test_task1;
		tsk.itskpri = DEFAULT_PRI;
		tsk.stksz = 0x4000;
		tsk.tskatr = TA_HLNG | TA_RNG0;
		TP_Msg("server task entry %s\n", SERVER_NAME_1);
		soid = ASRV_entry_sobj(&tsk, SERVER_NAME_1);
		TP_CHECK((soid > 0), (" "));
		TP_Msg("object id %d\n", soid);

		/*
		 * Ф򥪥֥ȴơ֥Ͽ
		 */
		tsk.exinf = (VP)CH4toW('S','R','V','2');
		tsk.task = test_task2;
		tsk.itskpri = DEFAULT_PRI;
		tsk.stksz = 0x4000;
		tsk.tskatr = TA_HLNG | TA_RNG0;
		TP_Msg("server task entry %s\n", SERVER_NAME_2);
		soid = ASRV_entry_sobj(&tsk, SERVER_NAME_2);
		TP_CHECK((soid > 0), (" "));
		TP_Msg("object id %d\n", soid);

		/* 2Ф˴ؤλΤ */
		sync_send(SYNC_CLIENT_NAME, SYNC_SERVER_PORT);

		/* 2Ф˴ؤ븡λΤԤ */
		tsk_stop_wait(TASK_INF_SERVER_PORT);
		tsk_stop_wait(TASK_INF_SERVER_PORT);

		TP_corba_fini();
		TP_delete_ASRVtsk(ASRV_SERVER_ID);
	}
	TP_INFO(("s220102 OK\n"));
	TP_INFO(("s220202 OK\n"));
	TP_INFO(("s220302 OK\n"));

	TP_LINE();
	TP_INFO(("s220103\n"));
	TP_INFO(("s220203\n"));
	TP_INFO(("s220303\n"));
	{
		TP_corba_init2(TP_ASRV_PORT3);

		/*
		 * Ф򥪥֥ȴơ֥Ͽ
		 */
		tsk.exinf = (VP)CH4toW('S','R','V','1');
		tsk.task = test_task1;
		tsk.itskpri = DEFAULT_PRI;
		tsk.stksz = 0x4000;
		tsk.tskatr = TA_HLNG | TA_RNG0;
		TP_Msg("server task entry %s\n", SERVER_NAME_1);
		soid = ASRV_entry_sobj(&tsk, SERVER_NAME_1);
		TP_CHECK((soid > 0), (" "));
		TP_Msg("object id %d\n", soid);

		/*
		 * Ф򥪥֥ȴơ֥Ͽ
		 */
		tsk.exinf = (VP)CH4toW('S','R','V','2');
		tsk.task = test_task2;
		tsk.itskpri = DEFAULT_PRI;
		tsk.stksz = 0x4000;
		tsk.tskatr = TA_HLNG | TA_RNG0;
		TP_Msg("server task entry %s\n", SERVER_NAME_2);
		soid = ASRV_entry_sobj(&tsk, SERVER_NAME_2);
		TP_CHECK((soid > 0), (" "));
		TP_Msg("object id %d\n", soid);

		/*
		 * Ф򥪥֥ȴơ֥Ͽ
		 */
		tsk.exinf = (VP)CH4toW('S','R','V','3');
		tsk.task = test_task3;
		tsk.itskpri = DEFAULT_PRI;
		tsk.stksz = 0x4000;
		tsk.tskatr = TA_HLNG | TA_RNG0;
		TP_Msg("server task entry %s\n", SERVER_NAME_3);
		soid = ASRV_entry_sobj(&tsk, SERVER_NAME_3);
		TP_CHECK((soid > 0), (" "));
		TP_Msg("object id %d\n", soid);

		/* 3Ф˴ؤλΤ */
		sync_send(SYNC_CLIENT_NAME, SYNC_SERVER_PORT);

		/* 3Ф˴ؤ븡λΤԤ */
		tsk_stop_wait(TASK_INF_SERVER_PORT);
		tsk_stop_wait(TASK_INF_SERVER_PORT);
		tsk_stop_wait(TASK_INF_SERVER_PORT);

		TP_corba_fini();
		TP_delete_ASRVtsk(ASRV_SERVER_ID);
	}
	TP_INFO(("s220103 OK\n"));
	TP_INFO(("s220203 OK\n"));
	TP_INFO(("s220303 OK\n"));

	TP_corba_init2(TP_ASRV_PORT4);

	/* 顼ѥФ˴ؤλΤ */
	sync_send(SYNC_CLIENT_NAME, SYNC_SERVER_PORT);

	/* 饤¦顼λԤ */
	sync_recv(SYNC_SERVER_PORT);

	TP_LINE();
	TP_INFO(("s220204\n"));
	{
		/*
		 * Ф򥪥֥ȴơ֥Ͽ
		 */
		tsk.exinf = (VP)CH4toW('S','R','V','1');
		tsk.task = err_task;
		tsk.itskpri = DEFAULT_PRI;
		tsk.stksz = 0x4000;
		tsk.tskatr = TA_HLNG | TA_RNG0;
		TP_Msg("server task entry %s\n", SERVER_NAME_4);
		soid = ASRV_entry_sobj(&tsk, SERVER_NAME_4);
		TP_CHECK((soid > 0), (" "));
		TP_Msg("object id %d\n", soid);

		/* ưԥФνλΤ */
		sync_send(SYNC_CLIENT_NAME, SYNC_SERVER_PORT);
	}
	TP_INFO(("s220204 OK\n"));
	TP_LINE();

	/* 饤¦顼λԤ */
	sync_recv(SYNC_SERVER_PORT);

	TP_corba_fini();
	TP_delete_ASRVtsk(ASRV_SERVER_ID);

	return 0;
}




