/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#include "s2103.h"
#include "config.h"
#include "_sysdbg.h"
#include "_syslibc.h"

#define TEST00  0
#define TEST01  1
#define TEST02  2
#define TEST03  3
#define TEST04  4
#define TEST05  5

#define PORT 6666

CORBA_char	IORstr0[1024];

CORBA_char	IORstr1[1024];
CORBA_char	IORstr2[1024];

CORBA_char	IORstr3[1024];

CORBA_char	IORstr4[1024];
CORBA_char	IORstr5[1024];

CORBA_UsrDefine corba_def = {
	CORBA_TARGET_NAME,
	CORBA_SERVER_NUMBER,
	CORBA_MAX_MEMORY,
	CORBA_NULL,
	0,
	0,
	0,
	0
};

ASRV_UsrDefine asrv_def = {
	ASRV_SERVER_ID,
	ASRV_SERVER_PRI,
	ASRV_SERVER_PORT,
	ASRV_OBJECT_PRI,
	ASRV_OBJECT_NUMBER,
	ASRV_DYNAMIC_NUMBER,
	0,
	0,
	0,
	0
};

ORB_UsrDefine orb_def = {
	0,
	0,
	0,
	0
};

POA_UsrDefine poa_def = {
	POA_MAX_POA_NUMBER,
	POA_MAX_SERVANT_NUMBER,
	0,
	0,
	0,
	0
};

MRSHL_UsrDefine mrshl_def = {
	0,
	0,
	0,
	0
};

GIOP_UsrDefine giop_def = {
	0,
	0,
	0,
	0
};

CON_UsrDefine con_def = {
	CON_SERVER_NUMBER,
	CON_CLIENT_NUMBER,
	CON_SERVER_TIMEOUT,
	0,
	0,
	0,
	0
};

SYS_UsrDefine sys_def = {
	0,
	0,
	0,
	0
};

SG_CORBA sg_def = {
	&corba_def,
	&asrv_def,
	&orb_def,
	&poa_def,
	&mrshl_def,
	&giop_def,
	&con_def,
	&sys_def,
	0,
	0,
	0,
	0
};

static void tsk(void);

void
tsk(void)
{
	int			argc;
	char			*argv;
	CORBA_Environment	ev;
	CORBA_ORB		orb;
	Test			test0;
	Test			test1;
	Test			test2;
	Test			test3;
	Test			test4;
	Test			test5;

	TP_START();

	printf("Task End\n");

	CORBA_exception_init(&ev);

	argc = 0;
	orb = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	test0 = CORBA_ORB_string_to_object(orb, IORstr0, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	test1 = CORBA_ORB_string_to_object(orb, IORstr1, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	test2 = CORBA_ORB_string_to_object(orb, IORstr2, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	
	test3 = CORBA_ORB_string_to_object(orb, IORstr3, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	test4 = CORBA_ORB_string_to_object(orb, IORstr4, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	test5 = CORBA_ORB_string_to_object(orb, IORstr5, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	
	TP_LINE();
	printf("s210301 : START\n");
	{
		CORBA_char	l = 5;

		printf("Servant00 request data = %d\n", (CORBA_int)l);
		l = test_func_char(test0, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((l == 0), (" "));
		printf("Servant00 reply data = %d\n", (CORBA_int)l);
	}
	printf("s210301 : OK\n");

	TP_LINE();
	printf("s210302 : START\n");
	{
		CORBA_char	l = 5;

		printf("Servant01 request data = %d\n", (CORBA_int)l);
		l = test_func_char(test1, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((l == 1), (" "));
		printf("Servant01 reply data = %d\n", (CORBA_int)l);

		printf("Servant02 request data = %d\n", (CORBA_int)l);
		l = test_func_char(test2, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((l == 2), (" "));
		printf("Servant02 reply data = %d\n", (CORBA_int)l);
	}
	printf("s210302 : OK\n\n");

	TP_LINE();
	printf("s210303 : START\n");
	{
		CORBA_char	l = 5;

		printf("Servant03 request data = %d\n", (CORBA_int)l);
		l = test_func_char(test3, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((l == 3), (" "));
		printf("Servant03 reply data = %d\n", (CORBA_int)l);

		printf("Servant00 request data = %d\n", (CORBA_int)l);
		l = test_func_char(test0, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((l == 0), (" "));
		printf("Servant00 reply data = %d\n", (CORBA_int)l);
	}
	printf("s210303 : OK\n\n");

	TP_LINE();
	printf("s210304 : START\n");
	{
		CORBA_char	l = 5;

		printf("Servant04 request data = %d\n", (CORBA_int)l);
		l = test_func_char(test4, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((l == 4), (" "));
		printf("Servant04 reply data = %d\n", (CORBA_int)l);

		printf("Servant05 request data = %d\n", (CORBA_int)l);
		l = test_func_char(test5, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((l == 5), (" "));
		printf("Servant05 reply data = %d\n", (CORBA_int)l);

		printf("Servant01 request data = %d\n", (CORBA_int)l);
		l = test_func_char(test1, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((l == 1), (" "));
		printf("Servant01 reply data = %d\n", (CORBA_int)l);

		printf("Servant02 request data = %d\n", (CORBA_int)l);
		l = test_func_char(test2, l, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_CHECK((l == 2), (" "));
		printf("Servant02 reply data = %d\n", (CORBA_int)l);
	}
	printf("s210304 : OK\n\n");

	TP_LINE();
	printf("s210305 : START\n");
	{
		CORBA_SystemException	*value;
		CORBA_char	l = 5;

		printf("request data = %d\n", (CORBA_int)l);
		l = test_func_deactive(test2, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

		l = test_func_char(test2, l, &ev);
		TP_CHECK((ev._major == CORBA_SYSTEM_EXCEPTION), (" "));
		printf("_major : %d\n", (int)ev._major);
		TP_CHECK((SYS_strcmp(CORBA_exception_id(&ev), CORBA_Ex_NO_IMPLEMENT) == 0), (" "));
		printf("_id : %s\n", CORBA_exception_id(&ev));
		
		value = CORBA_exception_value(&ev);
		TP_CHECK((value != CORBA_NULL), (" "));
		TP_CHECK((value->_completed == CORBA_COMPLETED_NO), (" "));
		TP_Msg("_completed : %d\n", value->_completed);
		CORBA_exception_free(&ev);
	}
	printf("s210305 : OK\n\n");

	TP_LINE();
	printf("s210306 : START\n");
	{
		CORBA_SystemException	*value;
		CORBA_char	l = 5;

		printf("request data = %d\n", (CORBA_int)l);
		l = test_func_NoOperation(test0, l, &ev);
		TP_CHECK((ev._major == CORBA_SYSTEM_EXCEPTION), (" "));
		printf("_major : %d\n", (int)ev._major);
		TP_CHECK((SYS_strcmp(CORBA_exception_id(&ev), CORBA_Ex_BAD_OPERATION) == 0), (" "));
		printf("_id : %s\n", CORBA_exception_id(&ev));

		value = CORBA_exception_value(&ev);
		TP_CHECK((value != CORBA_NULL), (" "));
		TP_CHECK((value->_completed == CORBA_COMPLETED_NO), (" "));
		TP_Msg("_completed : %d\n", value->_completed);

		CORBA_exception_free(&ev);
	}
	printf("s210306 : OK\n\n");
	TP_LINE();

	test_func_shutdown(test0, TEST00, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	test_func_shutdown(test1, TEST01, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	test_func_shutdown(test3, TEST03, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	test_func_shutdown(test4, TEST04, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	CORBA_Object_release(test5, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	CORBA_Object_release(test4, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	CORBA_Object_release(test3, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	CORBA_Object_release(test2, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	CORBA_Object_release(test1, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	CORBA_Object_release(test0, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	CORBA_Object_release((CORBA_Object)orb, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	printf("Task End\n");

	TP_END();
 	ext_tsk();
}

#ifdef	CORBA_UNIX

void
main(int argc, char *argv[])
{
	SYS_init_debug(0);
	if (ecorba_init()) {
		TP_CHECK((1), (" "));
	}

	IORstr1 = (CORBA_char *)SYS_malloc(1024);
	if (TP_IOR_recv(PORT, IORstr1) == CORBA_FLASE) {
		TP_CHECK((1), (" "));
	}

	IORstr2 = (CORBA_char *)SYS_malloc(1024);
	if (TP_IOR_recv(PORT, IORstr2) == CORBA_FLASE) {
		TP_CHECK((1), (" "));
	}

	IORstr3 = (CORBA_char *)SYS_malloc(1024);
	if (TP_IOR_recv(PORT, IORstr3) == CORBA_FLASE) {
		TP_CHECK((1), (" "));
	}

	tsk01();

	SYS_free(IORstr1);
	SYS_free(IORstr2);
	SYS_free(IORstr3);

	exit(0);
}

#else	/* CORBA_UNIX */

ERR
main(Bool Startup, TC *arg)
{
	WERR		tskid0;

	MAIN_START();

	SYS_init_debug(0);
	if (ECORBA_init(&sg_def)) {
		TP_CHECK((1), (" "));
	}

	if (TP_IOR_recv(PORT, IORstr0) == CORBA_FALSE) {
		TP_CHECK((1), (" "));
	}

	if (TP_IOR_recv(PORT, IORstr1) == CORBA_FALSE) {
		TP_CHECK((1), (" "));
	}

	if (TP_IOR_recv(PORT, IORstr2) == CORBA_FALSE) {
		TP_CHECK((1), (" "));
	}

	if (TP_IOR_recv(PORT, IORstr3) == CORBA_FALSE) {
		TP_CHECK((1), (" "));
	}

	if (TP_IOR_recv(PORT, IORstr4) == CORBA_FALSE) {
		TP_CHECK((1), (" "));
	}

	if (TP_IOR_recv(PORT, IORstr5) == CORBA_FALSE) {
		TP_CHECK((1), (" "));
	}

	tskid0 = TP_CreateTask(tsk, DEFAULT_PRI);
	printf("tskid0: %d\n", tskid0);

	MAIN_END();
	return 0;
}

#endif	/* CORBA_UNIX */
