/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#include "s2103.h"
#include "config.h"
#include "_sysdbg.h"	/* ### for logging message */
#include "_loging.h"

#define PORT 6666

CORBA_UsrDefine corba_def = {
	CORBA_TARGET_NAME,
	CORBA_SERVER_NUMBER,
	CORBA_MAX_MEMORY,
	CORBA_NULL,
	0,
	0,
	0,
	0
};

ASRV_UsrDefine asrv_def = {
	ASRV_SERVER_ID,
	ASRV_SERVER_PRI,
	ASRV_SERVER_PORT,
	ASRV_OBJECT_PRI,
	ASRV_OBJECT_NUMBER,
	ASRV_DYNAMIC_NUMBER,
	0,
	0,
	0,
	0
};

ORB_UsrDefine orb_def = {
	0,
	0,
	0,
	0
};

POA_UsrDefine poa_def = {
	POA_MAX_POA_NUMBER,
	POA_MAX_SERVANT_NUMBER,
	0,
	0,
	0,
	0
};

MRSHL_UsrDefine mrshl_def = {
	0,
	0,
	0,
	0
};

GIOP_UsrDefine giop_def = {
	0,
	0,
	0,
	0
};

CON_UsrDefine con_def = {
	CON_SERVER_NUMBER,
	CON_CLIENT_NUMBER,
	CON_SERVER_TIMEOUT,
	0,
	0,
	0,
	0
};

SYS_UsrDefine sys_def = {
	0,
	0,
	0,
	0
};

SG_CORBA sg_def = {
	&corba_def,
	&asrv_def,
	&orb_def,
	&poa_def,
	&mrshl_def,
	&giop_def,
	&con_def,
	&sys_def,
	0,
	0,
	0,
	0
};

#define	TEST00	0

#define	TEST01	1
#define	TEST02	2

#define	TEST03	3

#define	TEST04	4
#define	TEST05	5

CORBA_ORB				Orb[6];
static PortableServer_ObjectId		*Oid;
static PortableServer_POA		Poa;

CORBA_long
func_shutdown_impl(PortableServer_Servant servant, CORBA_long num,
	  CORBA_Environment *ev)
{
	CORBA_ORB_shutdown(Orb[num], ev);
	return 0;
}

CORBA_long
func_deactive_impl(PortableServer_Servant servant, CORBA_Environment *ev)
{
	PortableServer_POA_deactivate_object(Poa, Oid, ev);
	return 0;
}

CORBA_char
func_char_impl(PortableServer_Servant servant, const CORBA_char test,
	  CORBA_Environment *ev)
{
	if (!strcmp((CORBA_char *)(((POA_Test *)servant)->_private), "Servant00")) {
		TP_LINE();
		printf("\nServant00\n");
		TP_LINE();
		return 0;
	} else if (!strcmp((CORBA_char *)(((POA_Test *)servant)->_private), "Servant01")) {
		TP_LINE();
		printf("\nServant01\n");
		TP_LINE();
		return 1;
	} else if (!strcmp((CORBA_char *)(((POA_Test *)servant)->_private), "Servant02")) {
		TP_LINE();
		printf("\nServant02\n");
		TP_LINE();
		return 2;
	} else if (!strcmp((CORBA_char *)(((POA_Test *)servant)->_private), "Servant03")) {
		TP_LINE();
		printf("\nServant03\n");
		TP_LINE();
		return 3;
	} else if (!strcmp((CORBA_char *)(((POA_Test *)servant)->_private), "Servant04")) {
		TP_LINE();
		printf("\nServant04\n");
		TP_LINE();
		return 4;
	} else if (!strcmp((CORBA_char *)(((POA_Test *)servant)->_private), "Servant05")) {
		TP_LINE();
		printf("\nServant05\n");
		TP_LINE();
		return 5;
	}

	return test + 10;
}

PortableServer_ServantBase__epv base_epv = {
	NULL,
	NULL,
	NULL
};

static void tsk(void);
static void tsk01(void);
static void tsk02(void);
static void tsk03(void);
static void tsk04(void);

static CORBA_int FlgTsk01;
static CORBA_int FlgTsk02;
static CORBA_int FlgTsk03;
static CORBA_int FlgTsk04;

#define ior_send_dly(flg)	\
{				\
	while (flg == 0) {	\
		dly_tsk(10);	\
	}			\
}

void
tsk(void)
{
	ID	id1;
	ID	id2;
	ID	id3;
	ID	id4;

	FlgTsk01 = 0;
	FlgTsk02 = 0;
	FlgTsk03 = 0;
	FlgTsk04 = 0;

	id1 = TP_CreateTask(tsk01, DEFAULT_PRI);
	ior_send_dly(FlgTsk01);

	id2 = TP_CreateTask(tsk02, DEFAULT_PRI);
	ior_send_dly(FlgTsk02);

	id3 = TP_CreateTask(tsk03, DEFAULT_PRI);
	ior_send_dly(FlgTsk03);

	id4 = TP_CreateTask(tsk04, DEFAULT_PRI);
	ior_send_dly(FlgTsk04);

	ext_tsk();
}

void
tsk01(void)
{
	int				argc;
	char				*argv;
	CORBA_Environment		ev;
	CORBA_Object			obj00;
	PortableServer_ObjectId		*oid;
	PortableServer_POA		root_poa;
	PortableServer_POAManager	poa_mgr = NULL;
	POA_Test__epv			test_epv00 = {NULL, func_char_impl, func_shutdown_impl, func_deactive_impl};
	POA_Test__vepv			test_vepv00 = { NULL, &base_epv, &test_epv00 };
	POA_Test			test00 = { "Servant00", &test_vepv00 };
	CORBA_char			*str;

	printf("### START : tsk01 ###\n");

	IPA_LOG_init(0);

	CORBA_exception_init(&ev);

	argc = 0;
	Orb[TEST00] = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
         * RootPOA롣
         */
	obj00 = CORBA_ORB_resolve_initial_references(Orb[TEST00], "RootPOA", &ev);
	root_poa = (PortableServer_POA)obj00;
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
         * RootPOAȴϢŤ줿POAManager롣
         */
	poa_mgr = PortableServer_POA__get_the_POAManager(root_poa, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	POA_Test__init(&test00, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	
	oid = PortableServer_string_to_ObjectId("test00", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
         * POA˥ХȤϿ롣
         */
	PortableServer_POA_activate_object_with_id(root_poa, oid, &test00, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
         * POAManager˳Υå롣
         * POAManagerϿƤ뤹٤ƤPOA롣
         */
	PortableServer_POAManager_activate(poa_mgr, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
	 * ХȤ饪֥ȥե󥹤κ
         */
	obj00 = PortableServer_POA_servant_to_reference(root_poa, &test00, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	
	/*
	 * ֥ȥե󥹤ʸѴ
         */
	str = CORBA_ORB_object_to_string(Orb[TEST00], obj00, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	TP_IOR_send(PORT, str);

	FlgTsk01 = 1;

	/*
	 * ORBå롼פ롣
         */
	CORBA_ORB_run(Orb[TEST00], &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
	 * POA
	 * (Don't reach)
         */
	PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	CORBA_Object_release((CORBA_Object)Orb[TEST00], &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	IPA_LOG_init(0);

	printf("### END : tsk01 ###\n");
	ext_tsk();
}

void
tsk02(void)
{
	int				argc;
	char				*argv;
	CORBA_Environment		ev;
	CORBA_Object			obj, obj01, obj02;
	PortableServer_ObjectId		*oid01;
	PortableServer_POAManager	poa_mgr = NULL;
	POA_Test__epv			test_epv00 = {NULL, func_char_impl, func_shutdown_impl, func_deactive_impl};
	POA_Test__vepv			test_vepv00 = { NULL, &base_epv, &test_epv00 };
	POA_Test			test01 = { "Servant01", &test_vepv00 };
	POA_Test__epv			test_epv01 = {NULL, func_char_impl, func_shutdown_impl, func_deactive_impl};
	POA_Test__vepv			test_vepv01 = { NULL, &base_epv, &test_epv01 };
	POA_Test			test02 = { "Servant02", &test_vepv01 };
	CORBA_char			*str01, *str02;

	printf("### START : tsk02 ###\n");
	CORBA_exception_init(&ev);

	argc = 0;
	Orb[TEST01] = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
         * RootPOA롣
         */
	obj = CORBA_ORB_resolve_initial_references(Orb[TEST01], "RootPOA", &ev);
	Poa = (PortableServer_POA)obj;
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
         * RootPOAȴϢŤ줿POAManager롣
         */
	poa_mgr = PortableServer_POA__get_the_POAManager(Poa, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	POA_Test__init(&test01, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	POA_Test__init(&test02, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	
	oid01 = PortableServer_string_to_ObjectId("test01", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	Oid = PortableServer_string_to_ObjectId("test02", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
         * POA˥ХȤϿ롣
         */
	PortableServer_POA_activate_object_with_id(Poa, oid01, &test01, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	PortableServer_POA_activate_object_with_id(Poa, Oid, &test02, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
         * POAManager˳Υå롣
         * POAManagerϿƤ뤹٤ƤPOA롣
         */
	PortableServer_POAManager_activate(poa_mgr, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
	 * ХȤ饪֥ȥե󥹤κ
         */
	obj01 = PortableServer_POA_servant_to_reference(Poa, &test01, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	obj02 = PortableServer_POA_servant_to_reference(Poa, &test02, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
	 * ֥ȥե󥹤ʸѴ
         */
	str01 = CORBA_ORB_object_to_string(Orb[TEST01], obj01, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	TP_IOR_send(PORT, str01);

	str02 = CORBA_ORB_object_to_string(Orb[TEST01], obj02, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	TP_IOR_send(PORT, str02);

	FlgTsk02 = 1;

	/*
	 * ORBå롼פ롣
         */
	CORBA_ORB_run(Orb[TEST01], &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
	 * POA
	 * (Don't reach)
         */
	PortableServer_POA_destroy(Poa, CORBA_TRUE, CORBA_TRUE, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	CORBA_Object_release((CORBA_Object)Orb[TEST01], &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	printf("### END : tsk02 ###\n");
	ext_tsk();
}

void
tsk03(void)
{
	int				argc;
	char				*argv;
	CORBA_Environment		ev;
	CORBA_Object			obj;
	PortableServer_ObjectId		*oid;
	PortableServer_POA		root_poa;
	PortableServer_POAManager	poa_mgr = NULL;
	POA_Test__epv			test_epv00 = {NULL, func_char_impl, func_shutdown_impl, func_deactive_impl};
	POA_Test__vepv			test_vepv00 = { NULL, &base_epv, &test_epv00 };
	POA_Test			test03 = { "Servant03", &test_vepv00 };
	CORBA_char			*str;

	printf("### START : tsk03 ###\n");
	CORBA_exception_init(&ev);

	argc = 0;
	Orb[TEST03] = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
         * RootPOA롣
         */
	obj = CORBA_ORB_resolve_initial_references(Orb[TEST03], "RootPOA", &ev);
	root_poa = (PortableServer_POA)obj;
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
         * RootPOAȴϢŤ줿POAManager롣
         */
	poa_mgr = PortableServer_POA__get_the_POAManager(root_poa, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	POA_Test__init(&test03, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	
	oid = PortableServer_string_to_ObjectId("test03", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	
	/*
         * POA˥ХȤϿ롣
         */
	PortableServer_POA_activate_object_with_id(root_poa, oid, &test03, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
         * POAManager˳Υå롣
         * POAManagerϿƤ뤹٤ƤPOA롣
         */
	PortableServer_POAManager_activate(poa_mgr, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
	 * ХȤ饪֥ȥե󥹤κ
         */
        obj = PortableServer_POA_servant_to_reference(root_poa, &test03, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	
	/*
	 * ֥ȥե󥹤ʸѴ
         */
	str = CORBA_ORB_object_to_string(Orb[TEST03], obj, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
	 * Ϥǡ֥ȥե󥹤
         * 饤ȤذϤɬפ롣
         */
	TP_IOR_send(PORT, str);
	FlgTsk03 = 1;

	/*
	 * ORBå롼פ롣
         */
	CORBA_ORB_run(Orb[TEST03], &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
	 * POA
	 * (Don't reach)
         */
	PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	CORBA_Object_release((CORBA_Object)Orb[TEST03], &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	printf("### END : tsk03 ###\n");
	ext_tsk();
}

void
tsk04(void)
{
	int				argc;
	char				*argv;
	CORBA_Environment		ev;
	CORBA_Object			obj, obj04, obj05;
	PortableServer_ObjectId		*oid04, *oid05;
	PortableServer_POA		root_poa;
	PortableServer_POAManager	poa_mgr = NULL;
	POA_Test__epv			test_epv00 = {NULL, func_char_impl, func_shutdown_impl, func_deactive_impl};
	POA_Test__vepv			test_vepv00 = { NULL, &base_epv, &test_epv00 };
	POA_Test			test04 = { "Servant04", &test_vepv00 };
	POA_Test__epv			test_epv01 = {NULL, func_char_impl, func_shutdown_impl, func_deactive_impl};
	POA_Test__vepv			test_vepv01 = { NULL, &base_epv, &test_epv01 };
	POA_Test			test05 = { "Servant05", &test_vepv01 };
	CORBA_char			*str04, *str05;

	printf("### START : tsk04 ###\n");
	CORBA_exception_init(&ev);

	argc = 0;
	Orb[TEST04] = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
         * RootPOA롣
         */
	obj = CORBA_ORB_resolve_initial_references(Orb[TEST04], "RootPOA", &ev);
	root_poa = (PortableServer_POA)obj;
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
         * RootPOAȴϢŤ줿POAManager롣
         */
	poa_mgr = PortableServer_POA__get_the_POAManager(root_poa, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	POA_Test__init(&test04, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	POA_Test__init(&test05, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	
	oid04 = PortableServer_string_to_ObjectId("test04", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	
	oid05 = PortableServer_string_to_ObjectId("test05", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	
	/*
         * POA˥ХȤϿ롣
         */
	PortableServer_POA_activate_object_with_id(root_poa, oid04, &test04, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	PortableServer_POA_activate_object_with_id(root_poa, oid05, &test05, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
         * POAManager˳Υå롣
         * POAManagerϿƤ뤹٤ƤPOA롣
         */
	PortableServer_POAManager_activate(poa_mgr, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
	 * ХȤ饪֥ȥե󥹤κ
         */
        obj04 = PortableServer_POA_servant_to_reference(root_poa, &test04, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	
        obj05 = PortableServer_POA_servant_to_reference(root_poa, &test05, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	
	/*
	 * ֥ȥե󥹤ʸѴ
         */
	str04 = CORBA_ORB_object_to_string(Orb[TEST04], obj04, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	TP_IOR_send(PORT, str04);

	str05 = CORBA_ORB_object_to_string(Orb[TEST04], obj05, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	TP_IOR_send(PORT, str05);

	FlgTsk04 = 1;

	/*
	 * ORBå롼פ롣
         */
	CORBA_ORB_run(Orb[TEST04], &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
	 * POA
	 * (Don't reach)
         */
	PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	CORBA_Object_release((CORBA_Object)Orb[TEST04], &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	printf("### END : tsk04 ###\n");
	ext_tsk();
}

#ifdef	CORBA_UNIX

void
main(int argc, char *argv[])
{
	SYS_init_debug(0);
	if (ecorba_init()) {
		TP_CHECK((1), (" "));
	}

	tsk();
	exit(0);
}

#else	CORBA_UNIX

ERR
main(Bool Startup, TC *arg)
{
	WERR		tskid0;

	SYS_init_debug(0);
	IPA_LOG_init(0);

	TP_corba_init();

	tskid0 = TP_CreateTask(tsk, DEFAULT_PRI + 5);
	printf("tskid0: %d\n", tskid0);
	return 0;
}

#endif	/* CORBA_UNIX */
