/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#include "config.h"
#include "tpchk.h"
#include "s2106.h"
#include "_sysdbg.h"

extern TskID;
CORBA_ORB	Orb[10];
CORBA_Object	Obj[10];

#define IOR_BUFSZ	(1000)
CORBA_char		IOR_str[IOR_BUFSZ];

static void clitsk(void);
static CORBA_boolean TP_tsk_wait(ID);
static void shutdown_server(void);

static void TP_tsk_wait_set(CORBA_boolean);

static CORBA_UsrDefine corba_def = {
	CORBA_TARGET_NAME,
	CORBA_SERVER_NUMBER,
	CORBA_MAX_MEMORY,
	CORBA_NULL,
	0,
	0,
	0,
	0
};

static ASRV_UsrDefine asrv_def = {
	ASRV_SERVER_ID,
	ASRV_SERVER_PRI,
	ASRV_OBJECT_PRI,
	ASRV_SERVER_PORT,
	ASRV_OBJECT_NUMBER,
	ASRV_DYNAMIC_NUMBER,
	0,
	0,
	0,
	0
};

static ORB_UsrDefine orb_def;

static POA_UsrDefine poa_def = {
	POA_MAX_POA_NUMBER,
	POA_MAX_SERVANT_NUMBER,
	0,
	0,
	0,
	0
};

static MRSHL_UsrDefine mrshl_def;
static GIOP_UsrDefine giop_def;

static CON_UsrDefine con_def = {
	CON_SERVER_NUMBER,
	CON_CLIENT_NUMBER,
	CON_SERVER_TIMEOUT,
	0,
	0,
	0,
	0
};

#define CON_CLIENT_NUMBER2	(6)

static CON_UsrDefine con_def2 = {
	CON_SERVER_NUMBER,
	CON_CLIENT_NUMBER2,
	CON_SERVER_TIMEOUT,
	0,
	0,
	0,
	0
};

static SYS_UsrDefine sys_def;

static CORBA_long
func_impl(PortableServer_Servant s, CORBA_Environment *e)
{
	return 0;
}

static void
_skl_dispatch_test(PortableServer_Servant s, CORBA_Environment *e)
{
}

static PortableServer_ServantBase__epv base_epv = {
	NULL,
	NULL,
	NULL
};

typedef struct tagPOA_Test__epv {
	void	*_private;
	CORBA_long (*func)(PortableServer_Servant, CORBA_Environment *);
} POA_Test__epv;
static POA_Test__epv test_epv = {NULL, func_impl};

typedef struct POA_Test__vepv {
	PortableServer_ServantBase__epv	*_base_epv;
	POA_Test__epv	*Test_epv;
} POA_Test__vepv;
static POA_Test__vepv test_vepv = {&base_epv, &test_epv};

typedef struct tagPOA_Test {
	void		*_private;
	POA_Test__vepv	*vepv;
} POA_Test;
static POA_Test test = {0, &test_vepv};

static PortableServer_ServantPrivateInfo test_class = {
	"test",
	(void (*)())_skl_dispatch_test
};

static void
POA_Test__init(POA_Test *servant, CORBA_Environment *env)
{
	POA_Test	*test;
	
	test = (POA_Test *)servant;
	((PortableServer_ServantBase *)test)->vepv->_private 
							= (void *)&test_class;
	/*
	PortableServer_ServantBase__init(
		(PortableServer_ServantBase*)servant,
		env
	);
	*/
}

static char	*HexTbl = "0123456789abcde";

static void	POA_001(CORBA_unsigned_long);
static void	POA_002(CORBA_unsigned_long);
static void	ASRV_003(CORBA_unsigned_long);
static void	MEM_004(CORBA_unsigned_long);
static void	CON_005(CORBA_unsigned_long);
static void	CON_006(CORBA_unsigned_long);
static void	ASRV_007(CORBA_unsigned_long);

void
tp_resource(void)
{
	SG_CORBA	sg;
	CORBA_int	ret;

	sg.sg_corba = &corba_def;
	sg.sg_asrv = &asrv_def;
	sg.sg_orb = &orb_def;
	sg.sg_poa = &poa_def;
	sg.sg_mrshl = &mrshl_def;
	sg.sg_giop = &giop_def;
	sg.sg_con = &con_def;
	sg.sg_sys = &sys_def;

	TP_LINE();
	TP_INFO(("s210801\n"));
	TP_INFO(("s210808\n"));
	{
		ret = ECORBA_init(&sg);
		TP_CHECK((ret == CORBA_SGOK), ("ret:%d ", ret));
		POA_001(sg.sg_poa->poa_limit);
		TP_Msg("k210801_01 OK\n");
		TP_Msg("k210808_01 OK\n");
		TP_corba_fini();
		TP_delete_ASRVtsk(ASRV_SERVER_ID);		

		sg.sg_poa->poa_limit = 1;
		ret = ECORBA_init(&sg);
		TP_CHECK((ret == CORBA_SGOK), ("ret:%d ", ret));
		POA_001(sg.sg_poa->poa_limit);
		TP_Msg("k210801_02 OK\n");
		TP_Msg("k210808_02 OK\n");
		TP_corba_fini();
		TP_delete_ASRVtsk(ASRV_SERVER_ID);		

		sg.sg_poa->poa_limit = 30;
		ret = ECORBA_init(&sg);
		TP_CHECK((ret == CORBA_SGOK), ("ret:%d ", ret));
		POA_001(sg.sg_poa->poa_limit);
		TP_Msg("k210801_03 OK\n");
		TP_Msg("k210808_03 OK\n");
		TP_corba_fini();
		TP_delete_ASRVtsk(ASRV_SERVER_ID);		

		sg.sg_poa->poa_limit = POA_MAX_POA_NUMBER;
	}
	TP_INFO(("s210801 OK\n"));
	TP_INFO(("s210808 OK\n"));

	TP_LINE();
	TP_INFO(("s210802\n"));
	TP_INFO(("s210809\n"));
	{
		ret = ECORBA_init(&sg);
		TP_CHECK((ret == CORBA_SGOK), ("ret:%d ", ret));
		POA_002(sg.sg_poa->map_limit);
		TP_Msg("k210802_01 OK\n");
		TP_Msg("k210809_01 OK\n");
		TP_corba_fini();
		TP_delete_ASRVtsk(ASRV_SERVER_ID);		

		sg.sg_poa->map_limit = 1;
		ret = ECORBA_init(&sg);
		TP_CHECK((ret == CORBA_SGOK), ("ret:%d ", ret));
		POA_002(sg.sg_poa->map_limit);
		TP_Msg("k210802_02 OK\n");
		TP_Msg("k210809_02 OK\n");
		TP_corba_fini();
		TP_delete_ASRVtsk(ASRV_SERVER_ID);		

		sg.sg_poa->map_limit = 30;
		ret = ECORBA_init(&sg);
		TP_CHECK((ret == CORBA_SGOK), ("ret:%d ", ret));
		POA_002(sg.sg_poa->map_limit);
		TP_Msg("k210802_03 OK\n");
		TP_Msg("k210809_03 OK\n");
		TP_corba_fini();
		TP_delete_ASRVtsk(ASRV_SERVER_ID);		

		sg.sg_poa->map_limit = POA_MAX_SERVANT_NUMBER;
	}
	TP_INFO(("s210802 OK\n"));
	TP_INFO(("s210809 OK\n"));

	TP_LINE();
	TP_INFO(("s210803\n"));
	TP_INFO(("s210810\n"));
	{
		ret = ECORBA_init(&sg);
		TP_CHECK((ret == CORBA_SGOK), ("ret:%d ", ret));
		ASRV_003(sg.sg_asrv->asrv_ddobjnm);
		TP_Msg("k210803_01 OK\n");
		TP_Msg("k210810_01 OK\n");
		TP_corba_fini();
		TP_delete_ASRVtsk(ASRV_SERVER_ID);		

		sg.sg_asrv->asrv_ddobjnm = 1;
		ret = ECORBA_init(&sg);
		TP_CHECK((ret == CORBA_SGOK), ("ret:%d ", ret));
		ASRV_003(sg.sg_asrv->asrv_ddobjnm);
		TP_Msg("k210803_02 OK\n");
		TP_Msg("k210810_02 OK\n");
		TP_corba_fini();
		TP_delete_ASRVtsk(ASRV_SERVER_ID);		

		sg.sg_asrv->asrv_ddobjnm = 30;
		sg.sg_corba->corba_srvnum = 50;
		ret = ECORBA_init(&sg);
		TP_CHECK((ret == CORBA_SGOK), ("ret:%d ", ret));
		ASRV_003(sg.sg_asrv->asrv_ddobjnm);
		TP_Msg("k210803_03 OK\n");
		TP_Msg("k210810_03 OK\n");
		TP_corba_fini();
		TP_delete_ASRVtsk(ASRV_SERVER_ID);		

		sg.sg_corba->corba_srvnum = CORBA_SERVER_NUMBER;
		sg.sg_asrv->asrv_ddobjnm = ASRV_DYNAMIC_NUMBER;
	}
	TP_INFO(("s210803 OK\n"));
	TP_INFO(("s210810 OK\n"));

	TP_LINE();
	TP_INFO(("s210804\n"));
	TP_INFO(("s210811\n"));
	{
		sg.sg_corba->corba_memsz = 0x2000;
		ret = ECORBA_init(&sg);
		TP_CHECK((ret == CORBA_SGOK), ("ret:%d ", ret));
		MEM_004(sg.sg_corba->corba_memsz);
		TP_Msg("k210804_01 OK\n");
		TP_Msg("k210811_01 OK\n");
		TP_corba_fini();
		TP_delete_ASRVtsk(ASRV_SERVER_ID);		

		sg.sg_corba->corba_memsz = 0x19000;
		ret = ECORBA_init(&sg);
		TP_CHECK((ret == CORBA_SGOK), ("ret:%d ", ret));
		MEM_004(sg.sg_corba->corba_memsz);
		TP_Msg("k210804_02 OK\n");
		TP_Msg("k210811_02 OK\n");
		TP_corba_fini();
		TP_delete_ASRVtsk(ASRV_SERVER_ID);		

		sg.sg_corba->corba_memsz = CORBA_MAX_MEMORY;
		ret = ECORBA_init(&sg);
		TP_CHECK((ret == CORBA_SGOK), ("ret:%d ", ret));
		MEM_004(sg.sg_corba->corba_memsz);
		TP_Msg("k210804_03 OK\n");
		TP_Msg("k210811_03 OK\n");
		TP_corba_fini();
		TP_delete_ASRVtsk(ASRV_SERVER_ID);		
	}
	TP_INFO(("s210804 OK\n"));
	TP_INFO(("s210811 OK\n"));

#ifndef	CORBA_UNIX
	TP_IOR_recv(IOR_SERVER_PORT, IOR_str);

	TP_LINE();
	TP_INFO(("s210805\n"));
	{
		sg.sg_con->con_clilim = 7;
		ret = ECORBA_init(&sg);
		TP_CHECK((ret == CORBA_SGOK), ("ret:%d ", ret));
		CON_005(sg.sg_con->con_clilim);
		TP_Msg("k210805_01 OK\n");
		TP_corba_fini();
		TP_delete_ASRVtsk(ASRV_SERVER_ID);		

		sg.sg_con->con_clilim = 1;
		ret = ECORBA_init(&sg);
		TP_CHECK((ret == CORBA_SGOK), ("ret:%d ", ret));
		CON_005(sg.sg_con->con_clilim);
		TP_Msg("k210805_02 OK\n");
		TP_corba_fini();
		TP_delete_ASRVtsk(ASRV_SERVER_ID);		

		sg.sg_con->con_clilim = CON_CLIENT_NUMBER;
		ret = ECORBA_init(&sg);
		TP_CHECK((ret == CORBA_SGOK), ("ret:%d ", ret));
		CON_005(sg.sg_con->con_clilim);
		TP_Msg("k210805_03 OK\n");
		TP_corba_fini();
		TP_delete_ASRVtsk(ASRV_SERVER_ID);		

	}
	TP_INFO(("s210805 OK\n"));

	TP_LINE();
	TP_INFO(("s210806\n"));
	TP_INFO(("s210812\n"));
	{
		sg.sg_con->con_clilim = 7;
		ret = ECORBA_init(&sg);
		TP_CHECK((ret == CORBA_SGOK), ("ret:%d ", ret));
		CON_006(sg.sg_con->con_clilim);
		shutdown_server();	/* ¦ץλ롣 */
		dly_tsk(1000);
		TP_Msg("k210806_01 OK\n");
		TP_Msg("k210812_01 OK\n");
		TP_corba_fini();
		TP_delete_ASRVtsk(ASRV_SERVER_ID);		


		sync_send(SRV_NAME, 6005);

		TP_IOR_recv(IOR_SERVER_PORT, IOR_str);

		sg.sg_con->con_clilim = 1;
		ret = ECORBA_init(&sg);
		TP_CHECK((ret == CORBA_SGOK), ("ret:%d ", ret));
		CON_006(sg.sg_con->con_clilim);
		shutdown_server();	/* ¦ץλ롣 */
		dly_tsk(1000);
		TP_Msg("k210806_02 OK\n");
		TP_Msg("k210812_02 OK\n");
		TP_corba_fini();
		TP_delete_ASRVtsk(ASRV_SERVER_ID);

		sync_send(SRV_NAME, 6005);
		TP_IOR_recv(IOR_SERVER_PORT, IOR_str);

		sg.sg_con->con_clilim = CON_CLIENT_NUMBER;
		ret = ECORBA_init(&sg);
		TP_CHECK((ret == CORBA_SGOK), ("ret:%d ", ret));
		CON_006(sg.sg_con->con_clilim);
		shutdown_server();	/* ¦ץλ롣 */
		TP_Msg("k210806_03 OK\n");
		TP_Msg("k210812_02 OK\n");
		TP_corba_fini();
		TP_delete_ASRVtsk(ASRV_SERVER_ID);		
	}
	TP_INFO(("s210806 OK\n"));
	TP_INFO(("s210812 OK\n"));
#endif 	/* CORBA_UNIX */

	TP_LINE();
	TP_INFO(("s210807\n"));
	TP_INFO(("s210813\n"));
	{
		ret = ECORBA_init(&sg);
		TP_CHECK((ret == CORBA_SGOK), ("ret:%d ", ret));
		ASRV_007(sg.sg_asrv->asrv_dservnm);
		TP_Msg("k210807_01 OK\n");
		TP_Msg("k210813_01 OK\n");
		TP_corba_fini();
		TP_delete_ASRVtsk(ASRV_SERVER_ID);		

		sg.sg_asrv->asrv_dservnm = 1;
		ret = ECORBA_init(&sg);
		TP_CHECK((ret == CORBA_SGOK), ("ret:%d ", ret));
		ASRV_007(sg.sg_asrv->asrv_dservnm);
		TP_Msg("k210807_02 OK\n");
		TP_Msg("k210813_02 OK\n");
		TP_corba_fini();
		TP_delete_ASRVtsk(ASRV_SERVER_ID);		

		sg.sg_asrv->asrv_dservnm = 7;
		sg.sg_corba->corba_srvnum = 15;
		ret = ECORBA_init(&sg);
		TP_CHECK((ret == CORBA_SGOK), ("ret:%d ", ret));
		ASRV_007(sg.sg_asrv->asrv_dservnm);
		TP_Msg("k210807_03 OK\n");
		TP_Msg("k210813_03 OK\n");
		TP_corba_fini();
		TP_delete_ASRVtsk(ASRV_SERVER_ID);		

		sg.sg_asrv->asrv_dservnm = ASRV_OBJECT_NUMBER;
	}
	TP_INFO(("s210807 OK\n"));
	TP_INFO(("s210813 OK\n"));
	TP_LINE();
}

#ifdef CORBA_UNIX
#define	TP_TASK_END()	/**/
#else /* CORBA_UNIX */
#define	TP_TASK_END()	exd_tsk()
#endif /* CORBA_UNIX */

static void
POA_001(CORBA_unsigned_long max_poa_num)
{
	int				argc = 0;
	static char			*argv = "";
	CORBA_Environment		ev;
	CORBA_ORB			orb;
	CORBA_Object			obj;
	CORBA_int			i;
	PortableServer_POA		poa;
	PortableServer_POAManager	poa_mgr = NULL;

	CORBA_exception_init(&ev);

	TP_Msg("POA MAX %d\n", max_poa_num);

	orb = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	TP_CHECK((orb != CORBA_OBJECT_NIL), (" "));

	obj = CORBA_ORB_resolve_initial_references(orb, "RootPOA", &ev);
	TP_CHECK((orb != CORBA_OBJECT_NIL), (" "));
	poa = (PortableServer_POA)obj;
	TP_Msg("create POA 1 OK\n");

	poa_mgr = PortableServer_POA__get_the_POAManager(poa, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	for (i = 1; i < max_poa_num; i++) {
		CORBA_char	poa_name[3];

		poa_name[0] = HexTbl[i/(strlen(HexTbl) - 1)];
		poa_name[1] = HexTbl[i%(strlen(HexTbl) - 1)];
		poa_name[2] = '\0';
		PortableServer_POA_create_POA(poa, poa_name, poa_mgr, CORBA_NULL, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_Msg("create POA %d OK\n", i + 1);
	}

	PortableServer_POA_create_POA(poa, "NG", poa_mgr, CORBA_NULL, &ev);
	TP_CHECK((ev._major == CORBA_SYSTEM_EXCEPTION), (" "));
	TP_Msg("create POA %d NG\n", i + 1);

	PortableServer_POA_destroy(poa, CORBA_TRUE, CORBA_TRUE, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	CORBA_Object_release((CORBA_Object)orb, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	CORBA_exception_free(&ev);
}

static void
POA_002(CORBA_unsigned_long max_servant_num)
{
	int				argc = 0;
	static char			*argv = "";
	CORBA_Environment		ev;
	CORBA_ORB			orb;
	CORBA_Object			obj;
	CORBA_int			i;
	PortableServer_POA		poa;
	PortableServer_POAManager	poa_mgr = NULL;
	PortableServer_ObjectId		*oid[max_servant_num + 1];
	PortableServer_ObjectId		*ng_oid;

	CORBA_exception_init(&ev);

	orb = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	TP_CHECK((orb != CORBA_OBJECT_NIL), (" "));

	obj = CORBA_ORB_resolve_initial_references(orb, "RootPOA", &ev);
	TP_CHECK((orb != CORBA_OBJECT_NIL), (" "));
	poa = (PortableServer_POA)obj;
	TP_Msg("create root POA OK\n");

	poa_mgr = PortableServer_POA__get_the_POAManager(poa, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	TP_Msg("SERVANT MAX %d\n", max_servant_num);

	for (i = 0; i < max_servant_num; i++) {
		POA_Test	t[max_servant_num + 1];

		CORBA_char	id[5];

		id[0] = 't';
		id[1] = HexTbl[i/(strlen(HexTbl) - 1)];
		id[2] = HexTbl[i%(strlen(HexTbl) - 1)];
		id[3] = '\0';

		t[i]._private = 0;
		t[i].vepv = &test_vepv;
		POA_Test__init(&t[i], &ev);
		oid[i] = PortableServer_string_to_ObjectId(id, &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		PortableServer_POA_activate_object_with_id(poa, oid[i], &t[i], &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		TP_Msg("SERVANT %d OK\n", i + 1);
	}
	ng_oid = PortableServer_string_to_ObjectId("NG", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	PortableServer_POA_activate_object_with_id(poa, ng_oid, &test, &ev);
	TP_CHECK((ev._major == CORBA_SYSTEM_EXCEPTION), (" "));
	TP_Msg("SERVANT %d NG\n", i + 1);

	for (i = 0; i < max_servant_num; i++) {
		PortableServer_POA_deactivate_object(poa, oid[i], &ev);
		TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
		CORBA_free(oid[i]);
	}

	PortableServer_POA_destroy(poa, CORBA_TRUE, CORBA_TRUE, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	CORBA_Object_release((CORBA_Object)orb, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	CORBA_exception_free(&ev);
}

static void
ASRV_003(CORBA_unsigned_long dyn_num)
{
	CORBA_char		srvname[4];
	CORBA_int		i;
	CORBA_int		doid[dyn_num + 1];
	CORBA_int		ng_doid;
	T_CTSK			tskinf;

	srvname[0] = 'T';
	srvname[3] = '\0';

	TP_Msg("ASRV DYNAMIC OBJECT MAX %d\n", dyn_num);

	for (i = 0; i < dyn_num; i++) {
		srvname[1] = HexTbl[i/(strlen(HexTbl) - 1)];
		srvname[2] = HexTbl[i%(strlen(HexTbl) - 1)];
		doid[i] = ASRV_entry_dobj(&tskinf, srvname, 0);
		TP_CHECK((doid[i] > 0), (" "));
		TP_Msg("obj entry %d OK\n", i + 1);
	}
	ng_doid = ASRV_entry_dobj(&tskinf, "NG", 0);
	TP_CHECK((ng_doid < 0), (" "));
	TP_Msg("dobj entry %d NG\n", i + 1);

	for (i = 0; i < dyn_num; i++) {
		ASRV_cancel_dobj_id(doid[i]);
	}
}

static void
MEM_004(CORBA_unsigned_long mem_size)
{
	CORBA_char		*p1;
	CORBA_int		i;
	CORBA_int		j = 0;

	TP_Msg("MAX MEMORY %d\n" ,mem_size);
	for (i = sizeof(CORBA_long_long); (i < mem_size); j = i, i += sizeof(CORBA_long_long)) {
		p1 = CORBA_malloc(i, 1, 0);
		if (p1 == CORBA_NULL) {
			TP_CHECK((i < mem_size), (" "));
			break;
		} else {
			CORBA_free(p1);
		}
	}
	TP_Msg("malloc %d byte OK\n", j);
	TP_Msg("malloc %d byte NG\n", i);
}

static void
CON_005(CORBA_unsigned_long cli_num)
{
	ID			tskid[cli_num + 1];
	CORBA_int		i;
	CORBA_boolean 		retval;

	TP_Msg("CON CLIENT MAX %d\n", cli_num);
	for (i = 0; i < cli_num; i++) {
		TP_tsk_wait_set(CORBA_FALSE);
		tskid[i] = TP_CreateTask(clitsk, DEFAULT_PRI - 1);
		retval = TP_tsk_wait(tskid[i]);
		TP_CHECK((retval == CORBA_TRUE), (" "));
	}
	for (i = 0; i < cli_num; i++) {
		T_RTSK	pk_rtsk;
		ER	ercd;

		wup_tsk(tskid[i]);
		do {
			dly_tsk(300);
			ercd = ref_tsk(&pk_rtsk, tskid[i]);
		} while (ercd == E_OK);
	}
}

static void
CON_006(CORBA_unsigned_long srv_num)
{
	ID			tskid[srv_num + 1];
	CORBA_int		i;
	CORBA_boolean 		retval;

	TP_Msg("CON SERVER MAX %d\n", srv_num);
	for (i = 0; i < srv_num; i++) {
		TP_tsk_wait_set(CORBA_FALSE);
		tskid[i] = TP_CreateTask(clitsk, DEFAULT_PRI - 1);
		retval = TP_tsk_wait(tskid[i]);
		TP_CHECK((retval == CORBA_TRUE), (" "));
	}

	TP_tsk_wait_set(CORBA_FALSE);
	tskid[i] = TP_CreateTask(clitsk, DEFAULT_PRI - 1);
	retval = TP_tsk_wait(tskid[i]);
	TP_CHECK((retval == CORBA_TRUE), (" "));

	for (i = 0; i < srv_num; i++) {
		T_RTSK	pk_rtsk;
		ER	ercd;

		wup_tsk(tskid[i]);
		do {
			dly_tsk(300);
			ercd = ref_tsk(&pk_rtsk, tskid[i]);
		} while (ercd == E_OK);
	}
}

static void
ASRV_007(CORBA_unsigned_long srv_num)
{
	CORBA_char		srvname[4];
	CORBA_int		i;
	CORBA_int		soid[srv_num + 1];
	CORBA_int		ng_soid;
	T_CTSK			tskinf;

	srvname[0] = 'S';
	srvname[3] = '\0';

	TP_Msg("ASRV OBJECT MAX %d\n", srv_num);
	for (i = 0; i < srv_num; i++) {
		srvname[1] = HexTbl[i/(strlen(HexTbl) - 1)];
		srvname[2] = HexTbl[i%(strlen(HexTbl) - 1)];
		soid[i] = ASRV_entry_sobj(&tskinf, srvname);
		TP_CHECK((soid[i] > 0), (" "));
		TP_Msg("obj entry %d OK\n", i + 1);
	}
	ng_soid = ASRV_entry_sobj(&tskinf, "NG");
	TP_CHECK((ng_soid < 0), (" "));
	TP_Msg("obj entry %d NG\n", i + 1);
}

static void
shutdown_server(void)
{
	int			argc = 0;
	char			*argv = "";
	CORBA_Environment	ev;
	CORBA_ORB		orb;
	CORBA_Object		obj;
	CORBA_unsigned_long	size;
	GIOP_CliInf		cliinf;

	CORBA_exception_init(&ev);

	orb = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	if (ev._major == CORBA_SYSTEM_EXCEPTION) {
		TP_Msg("CORBA_ORB_init err!\n");
	}

	obj = CORBA_ORB_string_to_object(orb, IOR_str, &ev);
	if (ev._major == CORBA_SYSTEM_EXCEPTION) {
		TP_Msg("CORBA_ORB_string_to_object err!\n");
	}

	GIOP_init_cli(&cliinf);
	size = 0;
	GIOP_create_reqbuf(obj, &cliinf, size, CORBA_TRUE, "shutdown", &ev);
	if (ev._major == CORBA_SYSTEM_EXCEPTION) {
		TP_Msg("GIOP_create_reqbuf err!\n");
	}

	size = 0;
	GIOP_invoke_req(obj, &cliinf, size, &ev);
	if (ev._major == CORBA_SYSTEM_EXCEPTION) {
		TP_Msg("GIOP_invoke_req err!\n");
	}
	GIOP_end_cli(&cliinf);

	CORBA_Object_release(obj, &ev);
	CORBA_Object_release((CORBA_Object)orb, &ev);
	CORBA_exception_free(&ev);
}

void
clitsk(void)
{
	int			argc = 0;
	char			*argv = "";
	CORBA_Environment	ev;
	CORBA_ORB		orb;
	CORBA_Object		obj;
	CORBA_unsigned_long	size;
	GIOP_CliInf		cliinf;

	CORBA_exception_init(&ev);

	orb = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	if (ev._major == CORBA_SYSTEM_EXCEPTION) {
		TP_Msg("CORBA_ORB_init err!\n");
	}

	obj = CORBA_ORB_string_to_object(orb, IOR_str, &ev);
	if (ev._major == CORBA_SYSTEM_EXCEPTION) {
		TP_Msg("CORBA_ORB_string_to_object err!\n");
	}

	GIOP_init_cli(&cliinf);
	size = 0;
	GIOP_create_reqbuf(obj, &cliinf, size, CORBA_TRUE, "CON_CHECK", &ev);
	if (ev._major == CORBA_SYSTEM_EXCEPTION) {
		TP_Msg("GIOP_create_reqbuf err!\n");
	}

	size = 0;
	GIOP_invoke_req(obj, &cliinf, size, &ev);

	if (ev._major == CORBA_SYSTEM_EXCEPTION) {
		TP_Msg("GIOP_invoke_req NG!\n");
	} else {
		TP_Msg("GIOP_invoke_req OK!\n");
	}
	GIOP_end_cli(&cliinf);

	TP_tsk_wait_set(CORBA_TRUE);
	slp_tsk();
	CORBA_Object_release(obj, &ev);
	CORBA_Object_release((CORBA_Object)orb, &ev);
	CORBA_exception_free(&ev);

	TP_TASK_END();
}

static CORBA_boolean TskSleepFlg;


#ifndef CORBA_UNIX

static CORBA_boolean
TP_tsk_wait(ID tskid)
{
	ER	ercd;
	T_RTSK	pk_rtsk;

	TP_Msg("TP_tsk_wait\n");

	while (1) {
		ercd = ref_tsk(&pk_rtsk, tskid);
		if (ercd < 0) {
			dly_tsk(100);
			continue;
		}
		if ((pk_rtsk.tskstat & TTS_WAI)
		    && (TskSleepFlg == CORBA_TRUE)) {
			TP_Msg("TP_tsk_wait CORBA_TRUE\n");
			return CORBA_TRUE;
		}
	}
}

static void
TP_tsk_wait_set(CORBA_boolean flag)
{
	TskSleepFlg = flag;
}

#endif /* CORBA_UNIX */

