/*--------------------------------------------------------------*/
/*      Copyright (c) 2000 NEC Corporation                      */
/*      NEC CONFIDENTIAL AND PROPRIETARY                        */
/*      All rights reserved by NEC Corporation.                 */
/*      This program must be used solely for the purpose for    */
/*      which it was furnished by NEC Corporation.   No part    */
/*      of this program may be reproduced  or  disclosed  to    */
/*      others,  in  any form,  without  the  prior  written    */
/*      permission of NEC Corporation.    Use  of  copyright    */
/*      notice does not evidence publication of the program.    */
/*--------------------------------------------------------------*/
#include "config.h"
#include "tpchk.h"
#include "s2106.h"
#include "_sysdbg.h"
#include "_loging.h"

static CORBA_UsrDefine corba_def = {
	CORBA_TARGET_NAME,
	CORBA_SERVER_NUMBER,
	CORBA_MAX_MEMORY,
	CORBA_NULL,
	0,
	0,
	0,
	0
};

static ASRV_UsrDefine asrv_def = {
	ASRV_SERVER_ID,
	ASRV_SERVER_PRI,
	ASRV_OBJECT_PRI,
	ASRV_SERVER_PORT,
	ASRV_OBJECT_NUMBER,
	ASRV_DYNAMIC_NUMBER,
	0,
	0,
	0,
	0
};

static ORB_UsrDefine orb_def;

static POA_UsrDefine poa_def = {
	POA_MAX_POA_NUMBER,
	POA_MAX_SERVANT_NUMBER,
	0,
	0,
	0,
	0
};

static MRSHL_UsrDefine mrshl_def;
static GIOP_UsrDefine giop_def;

static CON_UsrDefine con_def = {
	CON_SERVER_NUMBER,
	CON_CLIENT_NUMBER,
	CON_SERVER_TIMEOUT,
	0,
	0,
	0,
	0
};

static SYS_UsrDefine sys_def;

static CORBA_ORB Orb;

static void
_skl_dispatch_test(PortableServer_Servant servant, GIOP_SrvInf *msg)
{
	CORBA_char		*bufp;
	CORBA_boolean		order;
	CORBA_unsigned_long	size;
	CORBA_Environment	env;

	TP_Msg("_skl_dispatch_test start\n");

	bufp = GIOP_srv_bcurp(msg);
	order = GIOP_srv_bordr(msg);

	CORBA_exception_init(&env);

	if (!strcmp(GIOP_srv_opnam(msg), "shutdown")) {
		TP_Msg("Server receive shutdown request\n");
		CORBA_ORB_shutdown(Orb, &env);
		TP_CHECK((env._major == CORBA_NO_EXCEPTION), (" "));
	}

	bufp = GIOP_create_repbuf(msg, 0);
	MRSHL_put_long(&bufp, CORBA_NO_EXCEPTION);
	size = (CORBA_unsigned_long)(bufp - GIOP_srv_btopp(msg));
	GIOP_send_rep(msg, size);

	TP_Msg("_skl_dispatch_test success\n");
}

static CORBA_long
func_impl(PortableServer_Servant s, CORBA_Environment *e)
{
	return 0;
}

static PortableServer_ServantBase__epv base_epv = {
	NULL,
	NULL,
	NULL
};

typedef struct tagPOA_Test__epv {
	void	*_private;
	CORBA_long (*func)(PortableServer_Servant, CORBA_Environment *);
	CORBA_long (*shutdown)(PortableServer_Servant, CORBA_Environment *);
} POA_Test__epv;

typedef struct POA_Test__vepv {
	void	*_private;
	PortableServer_ServantBase__epv	*_base_epv;
	POA_Test__epv	*Test_epv;
} POA_Test__vepv;


typedef struct tagPOA_Test {
	void		*_private;
	POA_Test__vepv	*vepv;
} POA_Test;

static PortableServer_ServantPrivateInfo test_class = {
	"test",
	(void (*)())_skl_dispatch_test
};

static void
POA_Test__init(POA_Test *servant, CORBA_Environment *env)
{
	POA_Test	*test;
	
	test = (POA_Test *)servant;
	((PortableServer_ServantBase *)test)->vepv->_private 
							= (void *)&test_class;
	/*
	PortableServer_ServantBase__init(
		(PortableServer_ServantBase*)servant,
		env
	);
	*/
}

int		argc;
char		*argv = "";

void
task(void)
{
	CORBA_Environment ev;
	CORBA_Object obj;
	PortableServer_ObjectId	*oid;
	PortableServer_POA root_poa;
	PortableServer_POAManager poa_mgr = NULL;
	POA_Test__epv test_epv = {NULL, func_impl, NULL};
	POA_Test__vepv test_vepv = {NULL, &base_epv, &test_epv};
	POA_Test test = {NULL, &test_vepv };
	CORBA_char *str;

	CORBA_exception_init(&ev);

	Orb = CORBA_ORB_init(&argc, &argv, "e-corba", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
         * RootPOA롣
         */
	obj = CORBA_ORB_resolve_initial_references(Orb, "RootPOA", &ev);
	root_poa = (PortableServer_POA)obj;
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
         * RootPOAȴϢŤ줿POAManager롣
         */
	poa_mgr = PortableServer_POA__get_the_POAManager(root_poa, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	POA_Test__init(&test, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	
	oid = PortableServer_string_to_ObjectId("test", &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	
	/*
         * POA˥Х(bank_account)Ͽ롣
         */
	PortableServer_POA_activate_object_with_id(root_poa, oid, &test, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
         * POAManager˳Υå롣
         * POAManagerϿƤ뤹٤ƤPOA롣
         */
	PortableServer_POAManager_activate(poa_mgr, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
	 * ХȤ饪֥ȥե󥹤κ
         */
        obj = PortableServer_POA_servant_to_reference(root_poa, &test, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));
	
	/*
	 * ֥ȥե󥹤ʸѴ
         */
	str = CORBA_ORB_object_to_string(Orb, obj, &ev);
	TP_CHECK((ev._major == CORBA_NO_EXCEPTION), (" "));

	/*
	 * ֥ȥե󥹤
         * 饤ȤذϤ
         */
	TP_IOR_send(IOR_SERVER_PORT, str);

	/*
	 * ORBå롼פ롣
         */
	TP_Msg("\n----- Server Tsk Wait Loop -----\n");
	CORBA_ORB_run(Orb, &ev);
	TP_Msg("\n----- Server Tsk Wait Loop End -----\n");

	/*
	 * POA
         */
	PortableServer_POA_destroy(root_poa, CORBA_TRUE, CORBA_TRUE, &ev);
	CORBA_Object_release((CORBA_Object)Orb, &ev);

	exd_tsk();
}

#ifdef	CORBA_UNIX

int
main(void)
{
	MAIN_START();	

	SYS_init_debug(0);

	task();

	MAIN_END();	
	return 0;
}

#else	/* CORBA_UNIX */

ERR
main(Bool Startup, TC *arg)
{
	SG_CORBA	sg;
	CORBA_int	ret;
	ID	taskid;
	ER	ercd;
	T_RTSK	pk_rtsk;
  
	SYS_init_debug(0);

	sg.sg_corba = &corba_def;
	sg.sg_asrv = &asrv_def;
	sg.sg_orb = &orb_def;
	sg.sg_poa = &poa_def;
	sg.sg_mrshl = &mrshl_def;
	sg.sg_giop = &giop_def;
	sg.sg_con = &con_def;
	sg.sg_sys = &sys_def;

	chg_pri(0, DEFAULT_PRI + 1);

	sg.sg_con->con_srvlim = 11;

	IPA_LOG_init(0);

	ret = ECORBA_init(&sg);
	TP_CHECK((ret == CORBA_SGOK), ("ret:%d ", ret));

	IPA_LOG_init(0);

	taskid = TP_CreateTask(task, DEFAULT_PRI);
	do {
		dly_tsk(1);
		ercd = ref_tsk(&pk_rtsk, taskid);
	} while (ercd == E_OK);
	sync_recv(6005);
	TP_corba_fini();
	TP_delete_ASRVtsk(ASRV_SERVER_ID);		

	sg.sg_con->con_srvlim = 1;
	ret = ECORBA_init(&sg);
	TP_CHECK((ret == CORBA_SGOK), ("ret:%d ", ret));
	taskid = TP_CreateTask(task, DEFAULT_PRI);
	do {
		dly_tsk(1);
		ercd = ref_tsk(&pk_rtsk, taskid);
	} while (ercd == E_OK);
	sync_recv(6005);
	TP_corba_fini();
	TP_delete_ASRVtsk(ASRV_SERVER_ID);		

	sg.sg_con->con_srvlim = CON_SERVER_NUMBER;
	ret = ECORBA_init(&sg);
	TP_CHECK((ret == CORBA_SGOK), ("ret:%d ", ret));
	taskid = TP_CreateTask(task, DEFAULT_PRI);
	do {
		dly_tsk(100);
		ercd = ref_tsk(&pk_rtsk, taskid);
	} while (ercd == E_OK);
	TP_corba_fini();
	TP_delete_ASRVtsk(ASRV_SERVER_ID);		
	
	return 0;
}

#endif	/* CORBA_UNIX */
